<?php

/* ===========================================================================*/
//
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
/* ===========================================================================*/

if (!isset($links_permissions["can_admin_links"]) or !$links_permissions["can_admin_links"]) {
	print_no_permission();
	exit;
}

/* ===========================================================================*/
// Main command function
/* ===========================================================================*/

if ($this_action == "admin" and $adminset == "checkversions") {

	$navbits[""] = $vbphrase['ll_menu_admcheck'];

    ldm_fetch_navbar_template($BASE_CAT);

	$show['notices'] = 0;
    $navbits = construct_navbits($navbits);
    $navbar = render_navbar_template($navbits);

    $dirpats = array( '', '/includes', '/clientscript', );
    $filepats = array( 'local_links', 'ldm', );

    $filerecords = array();

    $ndir = 0;

    foreach ($dirpats as $thisdir) {
        $handle = @opendir(DIR  . $thisdir);
        $ndir++;

        if ($handle) {

            $filerecords["$ndir:"] = '
                        <tr>
                            <td class="ldm_admin_td">'.$thisdir.'</td>
                            <td class="ldm_admin_td">&nbsp;</td>
                            <td class="ldm_admin_td">&nbsp;</td>
                            <td class="ldm_admin_td">&nbsp;</td>
                            <td class="ldm_admin_td">&nbsp;</td>
                        </tr>
                        ';

	    	while ($file = readdir($handle)) {
		    	foreach ($filepats as $thisfile) {
			        if (!preg_match("#^$thisfile#", $file, $match)) {
                        continue;
    			    }
                    $filecontents = @file(DIR . $thisdir . '/' . $file);
                    $filemd5 = "??";
                    if (is_array($file_version_md5)) {
                        if (isset($file_version_md5[$thisdir . '/' . $file])) {
                            $filemd5 = md5_file(DIR . $thisdir . '/' . $file);
                            if ($filemd5==$file_version_md5[$thisdir . '/' . $file]) {
                                $filemd5 = "ok";
                            }
                            else {
                                $filemd5 = "<span class='highlight'>mismatch</span>";
                            }
                        }
                    }
                    $filelines = 0;
                    $fileversion = "";
                    foreach ($filecontents as $rec) {
                        $filelines ++;
                        if (preg_match("#^// v([2-9]\.[0-9]\.[0-9])#", $rec, $match)) {
                            $fileversion = $match[1];
                            if ($fileversion and $fileversion != $LDM_environment['LDM_PVersion']) {
                                $fileversion = "<span class='highlight'>" . $fileversion . "</span>";
                            }
                        }
                    }
                    $filerecords["$ndir:$file"] = '
                        <tr>
                            <td class="ldm_admin_td">&nbsp;</td>
                            <td class="ldm_admin_td">'.$file.'</td>
                            <td class="ldm_admin_td" align="center">'.$filelines.'</td>
                            <td class="ldm_admin_td" align="center">'.$fileversion.'</td>
                            <td class="ldm_admin_td" align="center">'.$filemd5.'</td>
                        </tr>
                        ';
    			}
	    	}
		    closedir($handle);

	    }
	}

    ksort($filerecords);

    $mainadminbits['checkversions'] = implode("\n", $filerecords);

}

?>