<?php

/* ===========================================================================*/
//
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
/* ===========================================================================*/

if (!isset($links_permissions["can_admin_links"]) or !$links_permissions["can_admin_links"]) {
	print_no_permission();
	exit;
}

/* ===========================================================================*/
// Visualise available linkbits
/* ===========================================================================*/

if ($this_action == "admin" and $adminset == "linkbits") {

	$navbits[""] = $vbphrase['ll_menu_admlkbt'];

    ldm_fetch_navbar_template($viewcatid);

    $show['notices'] = 0;
    $navbits = construct_navbits($navbits);
    $navbar = render_navbar_template($navbits);

	$linkbits = "";

// preset the main linkbit variables...
	$linklegendbuttons = 1;
	$linktypebit	= "*type icon*";
	$linkurljump	= "*Link jump*";
	$linkurllink	= "*Link link*";
	$linkimg		= "*Image*";
	$linkimgsize	= 100;
	$linkimgjump	= "*Image jump*";
	$linkimglink	= "*Image link*";
	$linkimgmag		= "*Mag*";
	$linknewbit		= "*new*";
	$linkdoi		= "*doi*";
	$linksize		= "#bytes";
	$linkstatus		= "*Entry status*";
	$linkdesc		= "*Entry description*";
	$linkshortdesc	= "*Short description*";
	$linkothercatsbit = "*Other categories*";
	$linkfavbit 	= "*Fav*";
	$linkeditbit 	= "*Edit*";
	$linksendtofriendbit = "*SendFriend*";
	$linkreportlinkbit = "*Report*";
	$linkstarbit 	= "*Starred*";
	$linkusername 	= "*Username*";
	$linkuserid 	= "*Userid*";
	$thisorder 		= "*Order*";
	$linkdate 		= "*Date*";
	$linkhits 		= "#hits";
	$linkcomments 	= "*Comments*";
	$linkrate 		= "5";
	$linkraters 	= 1;
	$linkismedia 	= 1;
	$linkbottomline	= "*Bottom line*";
	$linktopline 	= "*Top line*";
	$linkratebitinline 	= "<span class='smallfont'>*Inline Rating Summary*</span>";
	$linkratebitdropdown 	= "<span class='smallfont'>*Dropdown Rating Summary*</span>";

	$linkbit = array();
	$nbit = 0;

	foreach ($ldm_linkbitcache as $thisname=>$thisbit) {
		$linkid	= $nbit;

        $templater = vB_Template::create($thisname);
        $templater->quickRegister(array(
	       'linklegendbuttons'=>$linklegendbuttons,
           'linkbottomline'=>$linkbottomline,
           'linkcomments'=>$linkcomments,
           'linkdate'=>$linkdate,
           'linkdesc'=>$linkdesc,
           'linkdoi'=>$linkdoi,
           'linkeditbit'=>$linkeditbit,
           'linkfavbit'=>$linkfavbit,
           'linkhits'=>$linkhits,
           'linkimg'=>$linkimg,
           'linkimgjump'=>$linkimgjump,
           'linkimglink'=>$linkimglink,
           'linkimgmag'=>$linkimgmag,
           'linkimgsize'=>$linkimgsize,
           'linkinfoicon'=>$ldm_icon_cache['info'],
           'linkismedia'=>$linkismedia,
           'linkmagicon'=>$ldm_icon_cache['magnify'],
           'linknewbit'=>$linknewbit,
           'linkothercatsbit'=>$linkothercatsbit,
           'linkrate'=>$linkrate,
           'linkratebitdropdown'=>$linkratebitdropdown,
           'linkratebitinline'=>$linkratebitinline,
           'linkraters'=>$linkraters,
           'linkreportlinkbit'=>$linkreportlinkbit,
           'linksendtofriendbit'=>$linksendtofriendbit,
           'linkshortdesc'=>$linkshortdesc,
           'linksize'=>$linksize,
           'linkstarbit'=>$linkstarbit,
           'linkstatus'=>$linkstatus,
           'linktopline'=>$linktopline,
           'linktypebit'=>$linktypebit,
           'linkurljump'=>$linkurljump,
           'linkurllink'=>$linkurllink,
           'linkuserid'=>$linkuserid,
           'linkusername'=>$linkusername,
           'thisorder'=>$thisorder,
            ));
        $thislinkbit = $templater->render();
        $thislinkbit = preg_replace('/ id="[^"]*"/', "", $thislinkbit);

        $templater = vB_Template::create("links_admin_viewlinkbit");
        $templater->quickRegister(array(
            'thislinkbit'=>$thislinkbit,
            'thisname'=>$thisname,
            'thisbit'=>$thisbit,
            'LDM_scripts'=>$LDM_scripts,
            ));
        $linkbit[$nbit] = $templater->render();

		$linkbit[$nbit] = preg_replace(
			array("/<!--$linkid::ajaxrating-->/", "/<!--$linkid::entities-->/", "/<!--$linkid::rate-->/", "/<a[^>]*>(.*?)<\/a>/"),
			array("<div class='smallfont'>*Quick Comment/Rating*</div>", "<div class='smallfont'>*Additional attributes*</div>", "<div class='smallfont'>*Comments/Ratings*</div>", "$1"),
			$linkbit[$nbit]
			);
		$nbit++;
	}

	$mainadminbits['linkbits'] = implode("\n", $linkbit);

// Category bits
    $catinfo = array(
    	'caticonbit'=>"*cat icon*",
	    'catname'=>"*Category jump*",
	    'catdesc'=>"*Category description*",
	    'subcatnames'=>"*Subcategory names*",
    	'catsub'=>"#subcats",
	    'catentry'=>"#entries",
	    'catchildentry'=>"#entries"
	    );

	$catbit = array();
	$nbit = 0;

	$create = 0;
	foreach ($ldm_catbitcache as $thisname=>$thisbit) {

        $templater = vB_Template::create($thisname);
        $templater->quickRegister(array(
            'links_defaults'=>$links_defaults,
            'catinfo'=>$catinfo,
            ));
        $thiscatbit = $templater->render();

        $templater = vB_Template::create("links_admin_viewcatbit");
        $templater->quickRegister(array(
            'thiscatbit'=>$thiscatbit,
            'thisname'=>$thisname,
            'thisbit'=>$thisbit,
            'LDM_scripts'=>$LDM_scripts,
            ));
        $catbit[$nbit] = $templater->render();

		$catbit[$nbit] = preg_replace(
			array("/<a[^>]*>(.*?)<\/a>/"),
			array("$1"),
			$catbit[$nbit]
			);
		$nbit++;
	}

	$mainadminbits['catbits'] = implode("\n", $catbit);

}

/* ===========================================================================*/
// Follow-up action
/* ===========================================================================*/

if ($this_action == "doadmin" and isset($_REQUEST["dolinkbits"])) {

	$vbulletin->input->clean_array_gpc('r', array(
		'altbit' => TYPE_STR,
		'candelete' => TYPE_INT,
		'collapse' => TYPE_STR,
		'create' => TYPE_INT,
		'defcol' => TYPE_INT,
		'delete' => TYPE_INT,
		'dolinkbits' => TYPE_INT,
		'maxcol' => TYPE_INT,
		'name' => TYPE_STR,
		'sequence' => TYPE_INT,
		'subbit' => TYPE_STR,
		'template' => TYPE_STR,
	));

	$vbulletin->url = ADMIN_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."action=admin&amp;set=linkbits";

	$doupdate = 1;
	$template = $vbulletin->GPC['template'];
	$sequence = $vbulletin->GPC['sequence'];

	$bit = array(
		'name' => $vbulletin->GPC['name'],
		'defcol' => $vbulletin->GPC['defcol'],
		'maxcol' => $vbulletin->GPC['maxcol'],
		);
	$bit['maxcol'] = max(1, $bit['maxcol']);
	$bit['defcol'] = max(1, $bit['defcol']);
	$bit['defcol'] = min($bit['defcol'], $bit['maxcol']);

	switch ($vbulletin->GPC['dolinkbits']) {
	case 1: // linkbit
		if (!$bit['name']) {
			eval(print_standard_redirect("Linkbits must have unique names",0));
			exit;
		}
		$bit['collapse'] = $vbulletin->GPC['collapse'];
		if (!$bit['collapse']) {
			$bit['collapse'] = 0;
		}
		$bit['altbit'] = $vbulletin->GPC['altbit'];
		if (!$bit['altbit']) {
			$bit['altbit'] = 0;
		}
		foreach ($ldm_linkbitcache as $thislinkbit) {
			if ($thislinkbit['sequence']!=$sequence) {
				if ($thislinkbit['name']==$bit['name']) {
					eval(print_standard_redirect("Linkbits must have unique names",0));
					exit;
				}
			}
		}
		break;

	case 2: // catbit
		if (!$bit['name']) {
			eval(print_standard_redirect("Catbits must have unique names",0));
			exit;
		}
		$bit['subbit'] = $vbulletin->GPC['subbit'];
		if (!$bit['subbit']) {
			$bit['subbit'] = 0;
		}
		foreach ($ldm_catbitcache as $thiscatbit) {
			if ($thiscatbit['sequence']!=$sequence) {
				if ($thiscatbit['name']==$bit['name']) {
					eval(print_standard_redirect("Catbits must have unique names",0));
					exit;
				}
			}
		}
		break;

	default: // Should not happen
		$doupdate = 0;

	}

	if ($doupdate) {
		$query = "
			UPDATE ".THIS_TABLE."linksadmin
			SET
				setting='".$vbulletin->db->escape_string(serialize($bit))."',
				settingname='".$vbulletin->db->escape_string($template)."'
			WHERE sequence='".$sequence."'
			";
		$vbulletin->db->query_write($query);
		ldm_datastore_markdirty('ldm_admin');
	}

	eval(print_standard_redirect($vbphrase['ll_edited'],0));
	exit;

}

?>