<?php

/* ===========================================================================*/
//
// This code is provided free on the basis that you do not claim that
// it is your own, sell it or use it as the basis for other products that you
// sell. But by all means extend it, modify it, upgrade it, correct it,
// suggest improvements, call me an idiot, etc.
//
// (c) 2004/10
// Andrew Dearing
// European Industrial Research Management Association
// www.eirma.org
//
// v3.0.0, 01.01.2010
// For VB4.0.x
// see changes.txt for history
// v1.00, 1.3.2004
//
/* ===========================================================================*/

// #################### Moderate

if ($this_action == "mod") {

	($hook = vBulletinHook::fetch_hook('ldm_moddisplay_begin')) ? eval($hook) : false;

	if (!$links_permissions["can_moderate_links"] and !$links_permissions["can_moderate_forums"]) {
		print_no_permission();
		exit;
	}

	$this_navigation_title = ldm_kill_bbcodes($vbphrase['ll_links_moderation']);

    $navpopup = array(
    	'id'    => 'ldmdisplay_navpopup',
    	'title' => $vbphrase['ll_moderate'],
        'link'  => $LINKS_SCRIPT . '.php?' . $vbulletin->session->vars['sessionurl'] . 'action=mod',
    );
    construct_quick_nav($navpopup);

	$navbits = array();
	$navbits[$LINKS_SCRIPT . '.php' . $vbulletin->session->vars['sessionurl_q']] = $master_title;
	$navbits[""] = $vbphrase['ll_links_moderation'];

	$can_bypass = $links_permissions['can_see_protected_links_on_portal'] | $links_permissions['can_bypass_forumperms'];
	$limitfids = ldm_lookup_forum_protections($can_bypass);

	$forum = array();
	$asb = $vbulletin->db->query_read("
		SELECT forumid, title
		FROM ". TABLE_PREFIX . "forum
	");
	while ($row=$vbulletin->db->fetch_array($asb)) {
		$forum[$row['forumid']] = $row['title'];
	}
	$vbulletin->db->free_result($asb);

	foreach ($linkscat AS $thiscat) {
		$tomod[$thiscat['catid']] = 0;
	}

	$asb = $vbulletin->db->query_read("
		SELECT link.linkid AS linkid, ltoc.catid AS linkcatid, link.linkmoderate AS linkmoderate
		FROM ". THIS_TABLE . "linkslink AS link
		LEFT JOIN ". THIS_TABLE . "linksltoc AS ltoc
		ON link.linkid = ltoc.linkid
		WHERE
			link.linkforum NOT IN (".implode(',', $limitfids).")
			AND (
			link.linkmoderate = $LINK_TO_MODERATE
				OR
			(link.linkreviewfreq>0 AND (link.linkmoddate+link.linkreviewfreq*24*60*60)<".TIMENOW.")
			)
	");

	while ($row=$vbulletin->db->fetch_array($asb)) {
		$tomod[$row['linkcatid']] += 1;
	}
	$vbulletin->db->free_result($asb);

	$links_permissions["can_edit_category"] = 0;
	$categorypage = ($pagenumber ? $pagenumber : 1);

	$numcatsmod = 0;
	$catlistarray = array();
	foreach ($linkscat AS $thiscat) {
		if (!in_array($thiscat["catforum"], $limitfids) and
			($tomod[$thiscat['catid']] > 0 or $thiscat['catmoderate'] == $LINK_TO_MODERATE)) {
			ldm_get_categorybits ($catlistarray, 'links_moderate_catbit', 'links_subcatbit', $thiscat['catid'], array(), 1, 1, $categorypage);
			if ($thiscat['catmoderate'] == $LINK_TO_MODERATE) {
				$numcatsmod++;
			}
		}
	}

	$pagenav = "";
	$sortnav = "";

	if (count($catlistarray)==0) {
        $templater = vB_Template::create('links_moderate_catbit_null');
        $templater->quickRegister(array(
            ));
        $catlistbit = $templater->render();
	}
	else {
		$catlistbit = ldm_map_listbit_to_grid(array_slice($catlistarray,($pagenumber-1)*$perpage,$perpage), 1);
		$pagenav = construct_page_nav($pagenumber, $perpage, count($catlistarray), $LINKS_SCRIPT.".php?".$vbulletin->session->vars['sessionurl']."action=mod", "&amp;pp=$perpage");
	}

	$catjumpbit = "";
	if ($links_defaults['category_jump_menu']) {
		$catjumpbit = ldm_construct_category_list(array(0), "links_catjump", 0, "catid", "catid", 1);
	}

	$script = LINKS_SCRIPT;
	$linkfeatbit = "";

	($hook = vBulletinHook::fetch_hook('ldm_moddisplay_end')) ? eval($hook) : false;

	ldm_process_placed_blocks();

    $navpopup = array(
    	'id'    => 'ldmdisplay_navpopup',
    	'title' => $master_title,
        'link'  => $LINKS_SCRIPT . '.php?' . $vbulletin->session->vars['sessionurl'],
    );
    construct_quick_nav($navpopup);

    ldm_fetch_navbar_template($viewcatid);

	$show['notices'] = 0;
	$navbits = construct_navbits($navbits);
    $navbar = render_navbar_template($navbits);

    $templater = vB_Template::create('links_header');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'ldm_header_include'=>$ldm_header_include, 'ldm_headtag_include'=>$ldm_headtag_include,
        'LDM_scripts'=>$LDM_scripts, 'links_defaults'=>$links_defaults,
        'navbar'=>$navbar, 'this_navigation_title'=>$this_navigation_title
        ));
    $output = $templater->render();

    $templater = vB_Template::create('links_moderate_main');
    $templater->quickRegister(array(
             'catlistbit'=>$catlistbit,
             'numcatsmod'=>$numcatsmod,
             'pagenav'=>$pagenav,
             'pagenumber'=>$pagenumber,
             'LDM_scripts'=>$LDM_scripts,
         ));
    $output .= $templater->render();

    $templater = vB_Template::create('links_footer');
    $templater->register_page_templates();
    $templater->quickRegister(array(
        'catjumpbit'=>$catjumpbit, 'forumjump'=>$forumjump,
        'LDM_scripts'=>$LDM_scripts, 'ldm_footer_include'=>$ldm_footer_include
        ));
    $output .= $templater->render();

	print_output($output);
	exit;
}

?>