<?php
//error_reporting(E_ALL & ~E_NOTICE);
define('ezircvb4', true);
define('THIS_SCRIPT', 'ezirc');
define('CSRF_PROTECTION', true);  

// change this depending on your filename

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array();

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array('ezircvb4_mibbit',
);

// pre-cache templates used by specific actions
$actiontemplates = array();


// ######################### REQUIRE BACK-END ############################
require_once('./global.php');

if($vbulletin->options['ezircvb4_enabled'] == 0)
{
	print_no_permission();
}

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################
$vboptions = $vbulletin->options;

$navbits = construct_navbits(array('ezirc.php' => $vboptions['ezircvb4_title']));
$navbar = render_navbar_template($navbits);

// ###### YOUR CUSTOM CODE GOES HERE #####

function parseName($name)
{
	if(is_numeric(substr($name, 0, 1)))
	{
		$name = substr($name, 1);
		parseName($name);
	} else {
		$name = preg_replace("/[^a-zA-Z0-9\_\`\^\s]/", "", $name);
		$name = str_replace('\s', '_', $name);
		return $name;
	}
}

// ###### NOW YOUR TEMPLATE IS BEING RENDERED ######
if(empty($_REQUEST['do']))
{
	if($vboptions['ezircvb4_mibbit'] && !$vboptions['ezircvb4_pjirc']) {
		$templater = vB_Template::create('ezircvb4_mibbit');
		$continue = true;
	} else
	if($vboptions['ezircvb4_pjirc'] && !$vboptions['ezircvb4_mibbit']) {
		// Not yet implemented.
		$templater = vB_Template::create('ezircvb4_pjirc');
		$continue = true;
	} else
	if($vboptions['ezircvb4_pjirc'] && $vboptions['ezircvb4_mibbit']) {
		// Not yet implemented.
		$templater = vB_Template::create('ezircvb4_select');
		$continue = true;
	} else {
		standard_error($vbphrase['ezircvb4_misconfiguration']);
	}
	if($continue)
	{
		$templater->register_page_templates();
			$templater->register('navbar', $navbar);
		$templater->register('pagetitle', $vboptions['ezircvb4_title']);
		print_output($templater->render());
	}
} else if($_REQUEST['do'] == 'options') {
	if($show['member'])
	{
		if(empty($_POST['username']))
		{
			$templater = vB_Template::create('ezircvb4_options');
			$templater->register('name', parseName($vbulletin->userinfo['username']));
		} else {
			if(is_numeric(substr($_POST['username'], 0, 1)))
			{
				standard_error("Your username may not start with a number.");
			} else {
				if(strlen($_POST['username']) > 32)
				{
					standard_error("Your username must not be longer than 32 characters.");
				} else {
					$_POST['username'] = parseName($_POST['username']);
					$db->query_read("UPDATE `" . TABLE_PREFIX . "user` SET `ezircvb4_username`='" . $_POST['username'] . "' WHERE `userid`='".$vbulletin->userinfo['userid']."' LIMIT 1");
//					$content = "<div align='center'>Your settings have been saved.</div>";
					standard_redirect("Your settings have been saved.", "ezirc.php");
				}
			}
			$templater = vB_Template::create('ezircvb4_options_final');
		}
		$templater->register_page_templates();
		$templater->register('pagecontents', $content);
		$templater->register('navbar', $navbar);
		$templater->register('pagetitle', $vboptions['ezircvb4_title']);
		print_output($templater->render());
	} else {
		print_no_permission();
	}
} else {
	print_no_permission();
}
