<?php
/////////////////////// Categories /////////////////////////////////////////////

// Get Premium Items
function getPremium($catid)
{
    global $db, $vbulletin, $premium_items, $premium_items_bit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    // Premium Classifieds
    $maximum_premium = $vbulletin->options["microclassifieds_premium_items"];
    $sql_premium = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE categoryid=$catid AND active=1 AND premium=1 AND sold=0 ORDER BY rand() LIMIT $maximum_premium");
    $total_premium = $db->num_rows($sql_premium);
    if($total_premium == 0)
    {
       $sql_premium = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE active=1 AND premium=1 AND sold=0 ORDER BY rand() LIMIT $maximum_premium");
    }
    while($premium = $db->fetch_array($sql_premium)) {
          $current_premium = $premium["id"];
          $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$current_premium AND istitlephoto=1");
          if(!$photo)
          {
              $photo = $db->query_first("SELECT photoname FROM ".TABLE_PREFIX."microclassifieds_item_photos WHERE itemid=$current_premium");
          }
		  if($photo)
          {
		     $premium_photo = $photo["photoname"];
          } else {
             $premium_photo = '';
          }
		  $templater = vB_Template::create('microclassifieds_premium_items_bit');
		  $templater->register('premium_title', $premium[title]);
		  $templater->register('premium_id', $premium[id]);
		  $templater->register('premium_photo', $premium_photo);
		  $premium_items_bit .= $templater->render();
    }
    $templater = vB_Template::create('microclassifieds_premium_items');
    $templater->register('premium_items_bit', $premium_items_bit);
    $premium_items .= $templater->render();
    return;
}

// Get Newest Items
function getNewest($catid)
{
    global $db, $vbulletin, $newest_items, $newest_items_bit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    $maximum_newest = $vbulletin->options["microclassifieds_newest_items"];
    $sql_newest = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE categoryid=$catid AND active=1 AND sold=0 ORDER BY starts DESC LIMIT $maximum_newest");
    $total_newest = $db->num_rows($sql_newest);
    if($total_newest == 0)
    {
          $sql_newest = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE active=1 AND sold=0 ORDER BY starts DESC LIMIT $maximum_newest");
    }
    while($newest = $db->fetch_array($sql_newest)) {
          // Get Seller data
          $newest_sellerid = getRecordById("user",$newest["userid"],"userid");
          $newest_seller = $newest_sellerid["username"];
		  $templater = vB_Template::create('microclassifieds_newest_items_bit');
          $templater->register('newest_id', $newest[id]);
          $templater->register('newest_title', $newest[title]);
          $templater->register('newest_seller', $newest_seller);
		  $newest_items_bit .= $templater->render();
    }
    $templater = vB_Template::create('microclassifieds_newest_items');
    $templater->register('newest_items_bit', $newest_items_bit);
    $newest_items .= $templater->render();
    return;
}

// Get Upcoming Items
function getUpcoming($catid)
{
    global $db, $vbulletin, $upcoming_items, $upcoming_items_bit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    // Soon to Expire Classifieds
    $maximum_upcoming = $vbulletin->options["microclassifieds_upcoming_items"];
    $sql_upcoming = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE categoryid=$catid AND active=1 AND sold=0 ORDER BY ends DESC LIMIT $maximum_upcoming");
    $total_upcoming = $db->num_rows($sql_upcoming);
    if($total_upcoming == 0)
    {
       $sql_upcoming = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE active=1 AND sold=0 ORDER BY ends DESC LIMIT $maximum_upcoming");
    }
    while($upcoming = $db->fetch_array($sql_upcoming)) {
          // Count remaining time
          $now_time = time();
          $exp_time = $item["ends"];
          $dif_time = $exp_time - $now_time;
          $upcoming_expiration = time_duration_short($dif_time,$vbulletin->options["microclassifieds_expirationformat"]);
		  $templater = vB_Template::create('microclassifieds_upcoming_items_bit');
          $templater->register('upcoming_id', $upcoming[id]);
          $templater->register('upcoming_title', $upcoming[title]);
          $templater->register('upcoming_expiration', $upcoming_expiration);
		  $upcoming_items_bit .= $templater->render();
    }
    $templater = vB_Template::create('microclassifieds_upcoming_items');
    $templater->register('upcoming_items_bit', $upcoming_items_bit);
    $upcoming_items .= $templater->render();
    return;
}

// Get Random Items
function getRandom($catid)
{
    global $db, $vbulletin, $random_items, $random_items_bit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    // Random Classifieds
    $maximum_random = $vbulletin->options["microclassifieds_random_items"];
    $sql_random = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE categoryid=$catid AND active=1 AND sold=0 ORDER BY rand() LIMIT $maximum_random");
    $total_random = $db->num_rows($sql_random);
    if($total_random == 0)
    {
       $sql_random = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_items WHERE active=1 AND sold=0 ORDER BY rand() LIMIT $maximum_random");
    }
    while($random = $db->fetch_array($sql_random)) {
          // Get Seller data
          $random_sellerid = getRecordById("user",$random["userid"],"userid");
          $random_seller = $random_sellerid["username"];
          // Format End Date
          $random_ends = date($vbulletin->options['microclassifieds_dateformat'], $random["ends"]);
          // Format Buynow Price
          $random_price = getFormatPrice($random[random]);
		  $templater = vB_Template::create('microclassifieds_random_items_bit');
          $templater->register('random_id', $random[id]);
          $templater->register('random_title', $random[title]);
          $templater->register('random_seller', $random_seller);
          $templater->register('random_ends', $random_ends);
          $templater->register('random_price', $random[price]);
          $templater->register('random_currency', $random[currency]);
		  $random_items_bit .= $templater->render();
    }
    $templater = vB_Template::create('microclassifieds_random_items');
    $templater->register('random_items_bit', $random_items_bit);
    $random_items .= $templater->render();
    return;
}



// Save New Category
function SaveCategory($catid)
{
    global $db, $vbulletin, $catid;
    // Let's clean inputs
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("INSERT INTO ". TABLE_PREFIX ."microclassifieds_categories
                      SET name='$name',
                          displayorder='0',
                          parentid='$catid'");
    $newid = $db->insert_id();

    return $catid;
}
// Remove Category and Subcategories
function DeleteCategory($catid)
{
  global $db, $vbulletin, $catid;
  // Now, let's remove Category
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE id=$catid");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getChildId($deletedId, $catid);
  $idList = "'". implode("','", $deletedId)."'";
  $db->query_write("DELETE FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE id IN ($idList)");
  // Go back
  $catid = $parentid;
  return $catid;
}
// Get Subcategories
function _getChildId(&$outArray, $parentId) {
	global $db, $vbulletin, $catid;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getChildId($outArray, $category['id']);
	}
}
// Update Category
function UpdateCategory($catid)
{
    global $db, $vbulletin, $catid;
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $parentid = $vbulletin->input->clean_gpc('r', 'parentid', TYPE_UINT);
    $db->query_write("UPDATE ". TABLE_PREFIX ."microclassifieds_categories
                      SET name='$name' WHERE id=$catid");
    // Go Back
    $catid = $parentid;
    return $catid;
}
// Update display order for Categories
function UpdateCategoriesOrder($catid)
{
  global $db, $vbulletin, $catid;
  $display = $_REQUEST["display"];
  $keys = array_keys($display);
  foreach($keys as $idx) {
    $order = $display[$idx];
    $db->query_write("UPDATE ".TABLE_PREFIX."microclassifieds_categories SET displayorder=$order WHERE id=$idx");
  }
  $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
  return $catid;
}


function getCategories($catid)
{
  global $db, $vbphrase, $html, $catid;
  $categories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  $html = '';
  if($db->num_rows($categories) != 0) {
     $html = '<table width="100%">';
     while($category = $db->fetch_array($categories)) {
           $id = $category["id"];
           $name = $category["name"];
           $title = sanitize_title($category["name"]);
           $html .= '<tr><td><div class="smallfont"><strong>&raquo;&nbsp;';
           $html .= '<a href=classifieds.php?'.$vbulletin->session->vars['sessionurl'].'do=directory&catid='.$category["id"].'&title='.$title.'>'.$category["name"].'</a>';
    	   $html .= '</strong></div></td></tr>';
     }
     $html .= '</table>';
  }
  return $html;
}

function getHorizontalCategories($catid,$blocks)
{
  global $db, $vbphrase, $catid, $horizontalcategories, $horizontalcategoriesbit, $totalclassifieds, $hcategoryname;
  $blockwidth = 100 / $blocks;
  $blockwidth = $blockwidth.'%';
  $total_hcategories = 0;
  $hcategories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  $activecategory = 0;
  while($hcategory = $db->fetch_array($hcategories)) {
        $activecategory = $hcategory["id"];
        $totalclassifieds = getCountRecords($activecategory);
        $total_hcategories ++;
        if($total_hcategories == $blocks)
        {
           $total_hcategories = 0;
           $changeline = 1;
        } else {
           $changeline = 0;
        }
		$templater = vB_Template::create('microclassifieds_horizontal_categories_bit');
		$templater->register('blockwidth', $blockwidth);
        $templater->register('changeline', $changeline);
		$templater->register('hcategoryid', $hcategory[id]);
		$templater->register('hcategoryname', $hcategory[name]);
        $templater->register('totalclassifieds', $totalclassifieds);
		$horizontalcategoriesbit .= $templater->render();
  }
  $templater = vB_Template::create('microclassifieds_horizontal_categories');
  $templater->register('horizontalcategoriesbit', $horizontalcategoriesbit);
  $horizontalcategories .= $templater->render();
  return;
}

function getCountRecords($activecategory)
{
  global $db, $vbulletin, $catid, $totalclassifieds;
  $totalclassifieds = 0;
  $get_records = '';
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE id='$activecategory' LIMIT 1");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getCountChild($deletedId, $activecategory);
  $idList = "'". implode("','", $deletedId)."'";
  $get_records = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microclassifieds_items WHERE categoryid IN ($idList) AND active=1");
  $totalclassifieds = $db->num_rows($get_records);
  // Go back
  $activecategory = $parentid;
  return $totalclassifieds;
}

function _getCountChild(&$outArray, $parentId) {
	global $db, $vbulletin, $activecategory;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getCountChild($outArray, $category['id']);
	}
}

// Get Classifieds Custom NavBar
function getClassifiedsNavBar(&$output, $catid) {
	global $db, $vbulletin, $output, $url;
	if($catid < 0) {
		$output = '';
		return $output;
	}
    $arrow_icon = '<img border="0" src="microclassifieds/images/navbit-arrow.png">';
	$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_categories WHERE id = $catid");
	$row = $db->fetch_array($qry);
	$url = 'classifieds.php?do=main&catid='.$row['id'];
	if(trim($output) == '')
    {
		$output = '<a href="'.$url.'">'.$row['name'].'</a>';
	} else {
		$output = '<a href="'.$url.'">'.$row['name'].'</a>&nbsp;&nbsp;'.$arrow_icon.'&nbsp;&nbsp;'.$output;
    }
	//- still have parents?
	if($row['parentid'] != 0) {
		getClassifiedsNavBar($output, $row['parentid']);
	} else {
		$output = $output;
	}
    return $output;
}


function getRecordById($tablename, $id, $rowname = 'id')
{
  global $db, $vbulletin;
  $result = $db->query_read("SELECT * FROM ".TABLE_PREFIX."".$tablename." WHERE ".$rowname."=".$id." LIMIT 1");
  if(!$result) return array ("id" => 0, "name" => '');
  if($db->num_rows($result) == 0) return array ("id" => 0, "name" => '');
  $ret = array();
  while($row = $db->fetch_array($result)) {
    $ret = $row;
  }
  $db->free_result($result);
  return $ret;
}




class SelectCategory {

	var $Name;
	var $SelectedId;
	var $IsMultiple;
	var $MultipleSize;
	var $ClassName;
	var $Id;
	var $Style;
	var $RootId;

	var $output;
	var $srcTable;
	var $firstOption;
	var $attributes;

	function SelectCategory($name, $table) {
		$this->Name = $name;
		$this->SelectedId = '';
		$this->IsMultiple = false;
		$this->MultipleSize = 5;
		$this->FirstOption = array('value' => '', 'text' => '');
		$this->ClassName = '' ;
		$this->Id = '';
		$this->Style = '';
		$this->RootId = 0;

		$this->output = '';
		$this->srcTable = $table;
	}

	function Output() {
		$options = '';
		$this->_getCategory($options, $this->RootId);

		$attributes = $this->_getAttributes();

		$output = '<select '.$attributes.'>'.$options.'</select>';

		return $output;
	}

	function SetFirstOption($text, $value) {
		$this->firstOption = array('value' => '', 'text' => '');
		$this->firstOption['value']	= $value;
		$this->firstOption['text'] = $text;
	}

	function SetMultiple($active, $rows) {
		$this->IsMultiple = $active;
		$this->MultipleSize = $rows;
	}

    function SetStyle($value)
    {
        $this->Style = $value;
    }

	function SetSelected($catid) {
		$this->SelectedId = $catid;
	}

	function _getAttributes() {
		$tmpAtt = array();

		$tmpAtt[] = 'name="'.$this->Name.'"';

		if($this->IsMultiple)
			$tmpAtt[] = 'multiple size="'.$this->MultipleSize.'"';

		if(trim($this->ClassName) != '')
			$tmpAtt[] = 'class="'.$this->ClassName.'"';

		if(trim($this->Style) != '')
			$tmpAtt[] = 'style="'.$this->Style.'"';

		if(count($tmpAtt) > 0)
        {
			$return = implode(', ', $tmpAtt);
		} else {
			$return = '';
        }
		return $return;
	}

	function _getCategory(&$options, $rootId, $level = 0) {
    global $db, $vbulletin, $catid;
		if(is_array($this->firstOption) && trim($options) == '') {
			$options .= '<option value="'.$this->firstOption['value'].'">'.
						$this->firstOption['text'].'</option>';
		}

		$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_categories WHERE parentid=$rootId ORDER BY displayorder ASC, name ASC");
			while($row = $db->fetch_array($qry)) {
              if(is_array($this->SelectedId))
              {
				if(in_array($row['id'],$this->SelectedId))
                {
					$selected = ' selected';
				} else {
					$selected = '';
                }
              } else {
        		if($row['id'] == $this->SelectedId)
                {
            	    $selected = ' selected';
				} else {
					$selected = '';
                }
              }
				$options .= '<option value="'.$row['id'].'" '.$selected.'>'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
				$this->_getCategory($options, $row['id'], $level+1);
			}

	}

}





function parseBbCode($bbcode, $limit = 0)
{
  global $vbulletin;
  require_once(DIR . '/includes/class_bbcode.php');
  $parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
  $text = $parser->do_parse($bbcode);
  if($limit != 0) {
  	if(strlen($text) > $limit)
  		$text = substr($text, 0, $limit).' ...';
  	}
    return $text;
}


// Function to get the extension a file.
function get_ext($key) {
	$key=strtolower(substr(strrchr($key, "."), 1));
	// Cause there the same right?
	$key=str_replace("jpeg","jpg",$key);
	return $key;
}


function fileExtension($filename)
{
  $path_info = pathinfo($filename);
  return $path_info['extension'];
}

function processUploadedPhoto($tmpfilename, $name, $existingfilename, $maxwidth = 0, $maxheigth = 0, $maxthumbwidth = 0, $maxthumbheigth = 0)
{
  global $db, $vbulletin;
  $image = &vB_Image::fetch_library($vbulletin);
  $imageinfo = $image->fetch_image_info($tmpfilename);
  if(!$imageinfo)
  {
     return "";
  }
  if(!empty($existingfilename))
  {
     @unlink(DIR . '/microclassifieds/photos/' . $existingfilename);
     @unlink(DIR . '/microclassifieds/photos/thumbs/' . $existingfilename);
  }
  $filename = md5(time() + rand()).'.'.fileExtension($name);
  if($imageinfo[0] > $maxwidth || $imageinfo[1] > $maxheight)
  {
     if($image->is_valid_resize_type($imageinfo[2]))
     {
        move_uploaded_file($tmpfilename, DIR . '/microclassifieds/photos/tmp/' . $filename);
        $resized = $image->fetch_thumbnail($filename, DIR . '/microclassifieds/photos/tmp/' . $filename, $maxwidth, $maxheight);
        @$file = fopen(DIR . '/microclassifieds/photos/' . $filename, 'w');
        @fwrite($file, $resized["filedata"]);
        @fclose($file);
        @unlink(DIR . '/microclassifieds/photos/tmp/' . $filename);
     } else {
        return "";
     }
  } else {
     move_uploaded_file($tmpfilename, DIR . '/microclassifieds/photos/' . $filename);
  }
  if($imageinfo[0] > $maxthumbwidth || $imageinfo[1] > $maxthumbheight)
  {
   	 $thumb = $image->fetch_thumbnail($filename, DIR . '/microclassifieds/photos/' . $filename, $maxthumbwidth, $maxthumbheight);
     @$file = fopen(DIR . '/microclassifieds/photos/thumbs/' . $filename, 'w');
     @fwrite($file, $thumb["filedata"]);
     @fclose($file);
  } else {
   	 @$file = fopen(DIR . '/microclassifieds/photos/thumbs/' . $filename, 'w');
     @fwrite($file, $image["filedata"]);
     @fclose($file);
  }
  return $filename;
}

function processUploadedFile($tmpfilename, $name, $existingfilename)
{
  global $db, $vbulletin;

  if(!empty($existingfilename))
  {
     @unlink(DIR . '/microclassifieds/files/' . $existingfilename);
  }
  $filename = md5(time() + rand()).'.'.fileExtension($name);
  move_uploaded_file($tmpfilename, DIR . '/microclassifieds/files/' . $filename);

  return $filename;
}


function getCountItemHits($item)
{
  global $db, $vbulletin;
  $totalrecords = 0;
  $result = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microclassifieds_item_hits WHERE itemid=$item");
  $totalrecords = $db->num_rows($result);
  if(!$result)
  {
      $totalrecords = 0;
  }
  return $totalrecords;
}



function getFormatPrice($price)
{
	global $vbulletin;
	$format = $vbulletin->options['microclassifieds_priceformat'];
	switch($format) {
		case 1:
		case 3:
			$printprice = number_format(floatval($price), 2);
			break;
		case 2:
		case 4:
			$printprice = number_format(floatval($price), 0);
			break;
	}
	return $printprice;
}

function time_duration($seconds, $use = null, $zeros = true)
{
   // Define time periods
   $periods = array (
             'years'     => 31556926,
             'Months'    => 2629743,
             'weeks'     => 604800,
             'days'      => 86400,
             'hours'     => 3600,
             'minutes'   => 60,
             'seconds'   => 1
             );
   // Break into periods
   $seconds = (float) $seconds;
   foreach ($periods as $period => $value) {
      if ($use && strpos($use, $period[0]) === false) {
          continue;
      }
      $count = floor($seconds / $value);
      if ($count == 0 && !$zeros) {
          continue;
      }
      $segments[strtolower($period)] = $count;
      $seconds = $seconds % $value;
   }
   // Build the string
   foreach ($segments as $key => $value) {
            $segment_name = substr($key, 0, -1);
            $segment = $value . ' ' . $segment_name;
            if ($value != 1) {
                $segment .= 's';
            }
            $array[] = $segment;
   }
   $str = implode(', ', $array);
   return $str;
}

function time_duration_short($seconds, $use = null, $zeros = false)
{
   // Define time periods
   $periods = array (
             'ye'     => 31556926,
             'Mo'    => 2629743,
             'we'     => 604800,
             'da'      => 86400,
             'ho'     => 3600,
             'mi'   => 60,
             'se'   => 1
             );
   // Break into periods
   $seconds = (float) $seconds;
   foreach ($periods as $period => $value) {
      if ($use && strpos($use, $period[0]) === false) {
          continue;
      }
      $count = floor($seconds / $value);
      if ($count == 0 && !$zeros) {
          continue;
      }
      $segments[strtolower($period)] = $count;
      $seconds = $seconds % $value;
   }
   // Build the string
   foreach ($segments as $key => $value) {
            $segment_name = substr($key, 0, -1);
            $segment = $value . ' ' . $segment_name;
            if ($value != 1) {
                $segment .= 's';
            }
            $array[] = $segment;
   }
   $str = implode(', ', $array);
   return $str;
}
?>
