<?php
/*======================================================================*\
|| #################################################################### ||
|| # Copyright &copy;2009 Quoord Systems Ltd. All Rights Reserved.    # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # This file is part of the Tapatalk package and should not be used # ||
|| # and distributed for any other purpose that is not approved by    # ||
|| # Quoord Systems Ltd.                                              # ||
|| # http://www.tapatalk.com | http://www.tapatalk.com/license.html   # ||
|| #################################################################### ||
\*======================================================================*/
chdir(CWD1);
chdir('../');	
// ####################### SET PHP ENVIRONMENT ###########################

@set_time_limit(0);

// #################### DEFINE IMPORTANT CONSTANTS #######################
define('GET_EDIT_TEMPLATES', true);
define('THIS_SCRIPT', 'newattachment');
define('CSRF_PROTECTION', false);

// ################### PRE-CACHE TEMPLATES AND DATA ######################
// get special phrase groups
$phrasegroups = array('posting');

// get special data templates from the datastore
$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array(

);

// pre-cache templates used by specific actions
$actiontemplates = array();

// ######################### REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/functions_newpost.php');
require_once(DIR . '/includes/functions_file.php');

// #######################################################################
// ######################## START MAIN SCRIPT ############################
// #######################################################################

function attach_image_func($xmlrpc_params)
{

	global $vbulletin;
	global $db;
	global $xmlrpcerruser;
	global $forumperms,$permissions;
    chdir(CWD1);
    chdir('../');
    
    
	$decode_params = php_xmlrpc_decode($xmlrpc_params);
	
    $image     = isset($decode_params[0]) ? $decode_params[0] : '';
    $name      = isset($decode_params[1]) ? $decode_params[1] : '';
    $type      = isset($decode_params[2]) ? $decode_params[2] : 'image/jpeg';
    $forumid  = isset($decode_params[3]) ? $decode_params[3] : '';
	if (!$vbulletin->userinfo['userid']) // Guests can not post attachments
	{
		$return = array(20,'security error (user may not have permission to access this feature)');
	         return return_fault($return);
	}

	// Variables that are reused in templates
require_once(DIR . '/packages/vbattach/attach.php');
if (
	!($attachlib =& vB_Attachment_Store_Library::fetch_library($vbulletin, 2, 0, array('f' => $forumid)))
		OR
	!$attachlib->verify_permissions()
)
{
		             $return = array(20,'security error (user may not have permission to access this feature)');
	         return return_fault($return);
}

if (!$attachlib->fetch_attachcount())
{
		             $return = array(20,'security error (user may not have permission to access this feature)');
	         return return_fault($return);
}
	
	$uploadids = $attachlib->upload($image, array(), array(1));
			$uploads = explode(',', $uploadids);

		// if $uploads > 1 then we are in a case where $currentattachment isn't used
		$currentattachment['attachmentid'] = $uploads[0];

		//($hook = vBulletinHook::fetch_hook('newattachment_attach')) ? eval($hook) : false;

		if (!empty($attachlib->errors))
		{
			$errorlist = '';
			foreach ($attachlib->errors AS $error)
			{
					$filename = htmlspecialchars_uni($error['filename']);
					$errorlist .= $error['error'];
			}
			
					$return = array(18,$errorlist);
	         return return_fault($return);
			//$show['errors'] = true;
		}
		else
		{
			    return new xmlrpcresp(
                        new xmlrpcval(
                                array(
                                        'attachment_id' => new xmlrpcval($currentattachment['attachmentid'],'string'),
                                ),
                                'struct'
                        )
                );
		}
		


          }


?>