<?php
/*======================================================================*\
|| #################################################################### ||
|| # Copyright &copy;2009 Quoord Systems Ltd. All Rights Reserved.    # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # This file is part of the Tapatalk package and should not be used # ||
|| # and distributed for any other purpose that is not approved by    # ||
|| # Quoord Systems Ltd.                                              # ||
|| # http://www.tapatalk.com | http://www.tapatalk.com/license.html   # ||
|| #################################################################### ||
\*======================================================================*/
chdir(CWD1);
chdir('../');	
$phrasegroups = array();


$specialtemplates = array();

// pre-cache templates used by all actions
$globaltemplates = array();

// pre-cache templates used by specific actions
$actiontemplates = array();

if(file_exists('./global.php'.SUFFIX)){
    require_once('./global.php'.SUFFIX);
} else {
	require_once('./global.php');
}



function get_new_topic_func(){
	global $vbulletin,$db,$show;
    global $permissions;
	global $vbphrase, $stylevar;
	global $newthreads, $dotthreads, $perpage, $ignore;
	global $search_core, $current_user;
    chdir(CWD1);
    chdir('../');
	
	$return_list =array();
	$forbidden_forums = get_forbidden_forums();
	
	$get_latest_updated_threads = $vbulletin->db->query_read("SELECT thread.threadid, thread.title AS threadtitle, thread.replycount, thread.forumid, thread.lastposter, thread.lastposterid, thread.lastpost, forum.title AS forumtitle, post.pagetext
		FROM " . TABLE_PREFIX . "thread AS thread
		LEFT JOIN " . TABLE_PREFIX . "forum AS forum ON (forum.forumid = thread.forumid)
		LEFT JOIN " . TABLE_PREFIX . "post AS post ON (post.postid = thread.lastpostid)
		WHERE thread.visible = 1
		" . (count($forbidden_forums) > 0 ?  "AND thread.forumid NOT IN (" . implode(',', $forbidden_forums) . ")" : "") . "
		ORDER BY thread.lastpost DESC
		LIMIT 20
	");
	
	while ($thread = $vbulletin->db->fetch_array($get_latest_updated_threads))
	{
		$return_topic = new xmlrpcval(
			array('forum_id'=>new xmlrpcval($thread[forumid],"string"),
		'forum_name'=>new xmlrpcval(mobiquo_encode($thread[forumtitle]),"base64"),
		'topic_id'=>new xmlrpcval($thread[threadid],"string"),
		'topic_title'=>new xmlrpcval(mobiquo_encode($thread[threadtitle]),"base64"),
		'post_author_id' => new xmlrpcval($thread['lastposterid'],"string"),
		'post_author_name'=>new xmlrpcval(mobiquo_encode($thread[lastposter]),"base64"),
		'reply_number'=>new xmlrpcval(($thread['replycount'] + 1),"int"),
		'new_post' =>new xmlrpcval(($thread['lastpost'] > $vbulletin->userinfo['lastvisit'] ? true : false),'boolean'),
		'short_content'=>new xmlrpcval(mobiquo_encode(mobiquo_chop(post_content_clean($thread['pagetext']))),"base64"),
		'post_time'=>new xmlrpcval(mobiquo_iso8601_encode($thread[lastpost]-$vbulletin->options['hourdiff'],$vbulletin->userinfo['tzoffset']),"dateTime.iso8601")),"struct");

		array_push($return_list,$return_topic);
	}
	
		 if (defined('NOSHUTDOWNFUNC'))
		{
			exec_shut_down();
		}
	
	return new xmlrpcresp(new xmlrpcval($return_list,"array"));
}


?>
