<?php


// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array('logging', 'marketadmin');
$specialtemplates = array();
$globaltemplates = array();
$actiontemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/functions_newpost.php');

// ############################# LOG ACTION ###############################
log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

   if (empty($_GET['do']))
{
    $_GET['do'] = 'category';
}




// ###################### Category Functions #######################
if ($_GET['do'] == 'category')
{
    print_cp_header($vbphrase['market_item_header']);

    print_form_header('market', 'doorder');
    print_table_header($vbphrase['market_item_header'], 3);
    print_description_row($vbphrase['market_main_description'], 0, 3);
    echo '<tr>
        <td class="thead">' . $vbphrase['dl2_category_name'] . '</td>
        <td class="thead" align="right" style="white-space:nowrap">' . $vbphrase['display_order'] . '</td>
        <td class="thead">' . $vbphrase['controls'] . '</td>
    </tr>';
    
    $result = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "market_items where `iscategory` = 1 ORDER BY `order`");
    while ($category = $db->fetch_array($result))
    {
        $class = fetch_row_bgclass();
        if ($category[active] != 1) {
        $active_0s = "<s>";
        $active_0e = "</s>";
        } else {
        $active_0s = "";
        $active_0e = "";
        }
        echo '<tr>
            <td class="' . $class . '" width="100%">&nbsp;<b>' . $active_0s . $spacer . htmlspecialchars_uni($category['name']) . $active_0e . '</b></td>
            <td class="' . $class . '" align="center"><input type="text" class="bginput" name="displayorder[' . $category['marketid'] . ']" value="' . $category['order'] . '" tabindex="1" size="2" title="' . $vbphrase['display_order'] . '" /></td>
            <td class="' . $class . '"><a href="market.php?' . $vbulletin->session->vars['sessionurl'] . 'do=edititem&amp;id=' . $category['marketid'] . '">' . $vbphrase['edit'] . '</a></td>
            </tr>';
        $result2 = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "market_items where `iscategory`=0 AND `parentid`='$category[marketid]' ORDER BY `order`");
        while ($item = $db->fetch_array($result2))
            {
            $class = fetch_row_bgclass();
            if ($item[active] != 1) {
                $active_0s = "<s>";
                $active_0e = "</s>";
            } else {
                $active_0s = "";
                $active_0e = "";
            }
            echo '<tr>
                <td class="' . $class . '" width="100%">&nbsp;---&nbsp;' . $active_0s . $spacer . htmlspecialchars_uni($item['name']) . $active_0e . '</td>
                <td class="' . $class . '" align="center"><input type="text" class="bginput" name="displayorder[' . $item['marketid'] . ']" value="' . $item['order'] . '" tabindex="1" size="2" title="' . $vbphrase['display_order'] . '" /></td>
                <td class="' . $class . '"><a href="market.php?' . $vbulletin->session->vars['sessionurl'] . 'do=edititem&amp;id=' . $item['marketid'] . '">' . $vbphrase['edit'] . '</a></td>
                </tr>';
            }
        $db->free_result($result2); 
    }
    $db->free_result($result); 
    
    print_submit_row($vbphrase['save_display_order'], $vbphrase['reset'], 4);



    print_cp_footer();
}

// ###################### Do Display Order #######################
if ($_POST['do'] == 'doorder')
{
    $vbulletin->input->clean_array_gpc('p', array(
        'displayorder'     => TYPE_NOCLEAN
    ));

    $catids = array();

    foreach ($vbulletin->GPC['displayorder'] AS $categoryid => $displayorder)
    {
        $vbulletin->GPC['displayorder']["$categoryid"] = intval($displayorder);
        $catids[] = "'" . $db->escape_string($categoryid) . "'";
    }

    $categories = $db->query_read("
        SELECT `marketid`, `order`
        FROM " . TABLE_PREFIX . "market_items");
    while ($cat = $db->fetch_array($categories))
    {
        if ($cat['order'] != $vbulletin->GPC['displayorder']["$cat[marketid]"])
        {
            $db->query_write("
                UPDATE " . TABLE_PREFIX . "market_items
                SET `order` = " . $vbulletin->GPC['displayorder']["$cat[marketid]"] . "
                WHERE marketid = '" . $db->escape_string($cat['marketid']) . "'
            ");
        }
    }

    define('CP_REDIRECT', 'market.php?do=category');
    print_stop_message('saved_display_order_successfully');
}

// ###################### Do Edit Item #########################
if ($_GET['do'] == 'edititem')
{
    $cleancatid = $vbulletin->input->clean_gpc('r', 'id', TYPE_UINT);
    $cat = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "market_items WHERE `marketid` = $cleancatid");


    print_cp_header($vbphrase['market_item_header']);
    print_form_header('market', 'doedititem');
    print_table_header(construct_phrase($vbphrase['x_y_id_z'], $vbphrase['market_item_rowhead'], htmlspecialchars_uni($cat['name']), $cat['marketid']));
    print_input_row($vbphrase['market_item_name'], 'name', $cat['name']);
    print_textarea_row($vbphrase['market_item_description_edit'], 'description', $cat['description'], 4, 40, true, false);
    print_textarea_row($vbphrase['market_item_instructions_edit'], 'instructions', $cat['instructions'], 4, 40, true, false);

    print_input_row($vbphrase['market_item_amount_info'], 'amount', $cat['amount']);    
    print_input_row($vbphrase['market_item_order_info'], 'order', $cat['order']);
    print_input_row($vbphrase['market_item_image'], 'image', $cat['image']); 

    print_select_row($vbphrase['market_item_active'], 'active', array('1' => $vbphrase['enabled'], '0' => $vbphrase['disabled']), $cat['active']);
    construct_hidden_code('marketid', $cat['marketid']);
    print_submit_row($vbphrase['save']);

    print_cp_footer();
}

// ###################### Do Edit Item #######################
if ($_POST['do'] == 'doedititem')
{
    $vbulletin->input->clean_array_gpc('p', array(
        'marketid'         => TYPE_UINT, 
        'name'             => TYPE_STR,
        'description'      => TYPE_STR,
        'instructions'     => TYPE_STR,
        'amount'           => TYPE_NUM,
        'image'            => TYPE_STR,
        'order'            => TYPE_INT,
        'active'           => TYPE_INT,
    ));

    if ($vbulletin->GPC['marketid'] == '')
    {
        print_stop_message('please_complete_required_fields');
    }
    else if ($vbulletin->GPC['name'] == '')
    {
        print_stop_message('please_complete_required_fields');
    }
    else
    {

        $db->query_write("
            UPDATE " . TABLE_PREFIX . "market_items SET 
                `name` = '" . $db->escape_string($vbulletin->GPC['name']) . "',
                `description` = '" . $db->escape_string($vbulletin->GPC['description']) . "',
                `instructions` = '" . $db->escape_string($vbulletin->GPC['instructions']) . "',
                `image` = '" . $db->escape_string($vbulletin->GPC['image']) . "',  
                `order` = '" . $db->escape_string($vbulletin->GPC['order']) . "', 
                `amount` = '" . $db->escape_string($vbulletin->GPC['amount']) . "',
                `active` = " . $vbulletin->GPC['active'] . "
            WHERE marketid = " . $vbulletin->GPC['marketid']
        );
        if ($vbulletin->GPC['active'] != 1) {
        $db->query_write("
            UPDATE " . TABLE_PREFIX . "market_items SET 
                `active` = " . $vbulletin->GPC['active'] . "
            WHERE parentid = " . $vbulletin->GPC['marketid']
        );
        }
        if ($db->affected_rows() > 0)
        {
            define('CP_REDIRECT', 'market.php?do=category');
            print_stop_message('market_item_saved_successfully');
        }
        else
        {
            define('CP_REDIRECT', 'market.php?do=category');
            print_stop_message('market_item_saved_successfully');   
//            print_stop_message('market_item_saved_failed');
        }
    }
}

?>
