<?php

   error_reporting(E_ALL & ~E_NOTICE);
   define('THIS_SCRIPT', 'addonchat');
   define('CSRF_PROTECTION', true);
   define('ADDONCHAT', true);
   
   require_once('./global.php');   
   
   /* Check to see if we're allowing unregistered guest access */
   if (!$vbulletin->userinfo['userid'] && (intval($addonchat['allow_unregistered_guests'])==0) )
   {
   	print_no_permission();
   }                
   
   global $addonchat;
   
   /* Populate username, password, auto-login values based on user preference */
   $addonchat['username'] = $vbulletin->userinfo['username'];
   $addonchat['password'] = $vbulletin->userinfo['password'];   

   /* Disable auto-login for unregistered users */   
   if( ($addonchat['username'] == "") || ($addonchat['username'] == $vbphrase['unregistered']) )
   {
      $addonchat['enable_auto_login'] = 0;
      $addonchat['username'] = "";
      $addonchat['password'] = "";
   }      
   
   if($_REQUEST['do']=='popup')
   {      
      // Reduce width and height to accomodate for window frames
      $addonchat['width_float'] -= 15;      
      $addonchat['height_float'] -= 8;
      $addonchat['exit_url'] = $vbulletin->options['bburl'] . "/addonchat_close.php";
      
      $acetempl = vB_Template::create('addonchat_popup');
      
      $acetempl->register_page_templates();
      $acetempl->register('addonchat', $addonchat);
      print_output($acetempl->render());
   }   
   else
   {            
	   $navbits = construct_navbits(
         array(
            'addonchat.php'  . $vbulletin->session->vars['sessionurl_q'] => $vbphrase['addonchat_nav_link_title'], 
         )
      );
      $navbar = render_navbar_template($navbits);
      
      $acetempl = vB_Template::create('addonchat_embed');
      
      $acetempl->register_page_templates();
      $acetempl->register('navbar', $navbar);
      $acetempl->register('addonchat', $addonchat);
      
      print_output($acetempl->render());
   }
?>
