<?php
/**
 * Header stuff
 */
error_reporting(E_ALL & ~E_NOTICE);
$phrasegroups = array('amefy', 'cprofilefield', 'ame_admincp');
$specialtemplates = array();
require_once('./global.php');


print_cp_header("AMEFY BABY");



function fetch_it_baby($id = 0)
{
	global $db;
	
	if ($id)
	{
		
		$where = "where id = $id";
		
	}
	
	$results = $db->query_read_slave("SELECT * FROM " . TABLE_PREFIX . "amefy $where ORDER BY position, ordinal, title");
	
	while($result = $db->fetch_array($results))
	{
		if (!$id)
		{
			$return["$result[id]"] = $result;
		}
		else 
		{
			
			$return = $result;
			
		}
		
	}
	
	return $return;
}



function fetch_valid_fields()
{
	
	global $vbulletin, $vbphrase;
	$return = array();
	
	$results = $vbulletin->db->query_read_slave("SELECT profilefieldid id FROM " . TABLE_PREFIX . "profilefield WHERE type='input' ORDER BY profilefieldid ASC");
	
	while ($result = $vbulletin->db->fetch_array($results))
	{
		
		$return[$result[id]] = $vbphrase["field$result[id]_title"];
		
	}
	
	return $return;
		
}



function fetch_the_damn_positions()
{
	global $vbphrase;
	
	return array(
	
		1 	=> $vbphrase['amefy_pos_1'],
		2 	=> $vbphrase['amefy_pos_2'],
		3 	=> $vbphrase['amefy_pos_3'],
		4 	=> $vbphrase['amefy_pos_4'],
		5 	=> $vbphrase['amefy_pos_5'],
		6 	=> $vbphrase['amefy_pos_6'],
		10 	=> $vbphrase['amefy_pos_10'],
		11	=> $vbphrase['amefy_pos_11'],
	
	);	
	
	
}


$do = ($_REQUEST['do'] ? $_REQUEST['do'] : ($_POST['do'] ? $_POST['do'] : "display"));



function redirect($do, $stopmessage, $var = '')
{
	
	define('CP_REDIRECT', "amefy.php?do=$do");
	print_stop_message($stopmessage, $var);
	
}



if ($do == "" || $do == "display")
{
	
	$existing = fetch_it_baby();
	$fields = fetch_valid_fields();
	
	print_form_header('amefy', 'save');
	print_table_header($vbphrase['amefy_entries'], 3);
	print_cells_row(array($vbphrase['amefy_field'], $vbphrase['amefy_position'], $vbphrase['options']), 1);
	
	if (count($existing))
	{
		
		foreach($existing as $id => $value)
		{
	
			$fieldname 		= "";
			$arr 			= explode(",", $value['fieldids']);
			
			foreach($arr as $fieldid)
			{
				
				$fieldname .= ($fieldname ? ", " : "") . $vbphrase['field' . $fieldid . '_title'];
								
			}
			
			$cells = array(
				"<a href=\"amefy.php?do=edit&id=$id\">$fieldname</a>",
				$vbphrase["amefy_pos_$value[position]"],
				"<a href=\"amefy.php?do=edit&id=$id\">" . $vbphrase['edit'] . "</a> | <a href=\"amefy.php?do=delete&amp;id=$id\">" . $vbphrase['delete'] . "</a>"
			);
				
			print_cells_row($cells);
				
			
		}
		
	}
	else 
	{
		
		print_description_row($vbphrase['amefy_noentries'], true, 3);
		
	}
	
	print_table_footer(3, construct_button_code($vbphrase['amefy_addnew'], "amefy.php?do=edit"));	
	
}



if ($do == "save")
{
	
	$vbulletin->input->clean_array_gpc('p', array(
		'id'		=> TYPE_UINT,
		'fieldids'	=> TYPE_ARRAY_UINT,
		'position'	=> TYPE_UINT,
		'width'		=> TYPE_STR,
		'height'	=> TYPE_STR,
		'title'		=> TYPE_STR,
		'ordinal'	=> TYPE_UINT,
		'typeid'	=> TYPE_UINT,
		'return'	=> TYPE_STR,
	));
	
	$id 		= $vbulletin->GPC['id'];
	$field 		= implode("," , $vbulletin->GPC['fieldids']);
	$position	= $vbulletin->GPC['position'];
	$width		= $db->escape_string($vbulletin->GPC['width']);
	$height		= $db->escape_string($vbulletin->GPC['height']);
	$title		= $db->escape_string($vbulletin->GPC['title']);
	$ordinal	= $vbulletin->GPC['ordinal'];
	$typeid		= $vbulletin->GPC['typeid'];
	
	if ($id)
	{
		
		$sql = "UPDATE " . TABLE_PREFIX . "amefy SET title='$title', fieldids='$field', typeid='$typeid', position='$position', width='$width', height='$height', ordinal='$ordinal' WHERE id=$id"; 
		$db->query_write($sql);
		
	}
	else 
	{
		
		$sql = "INSERT INTO " . TABLE_PREFIX . "amefy (title, fieldids, typeid, position, width, height, ordinal) VALUES ('$title', '$field', '$typeid', '$position', '$width', '$height', '$ordinal')";
		$db->query_write($sql);
		$id = $db->insert_id();
		
	}
	
	
    redirect(($vbulletin->GPC['return'] ? "edit&amp;id=$id" : "display"), construct_phrase("ame_saved_x", $vbulletin->GPC['title']));
	
}



if ($do == "edit")
{
	
	$vbulletin->input->clean_array_gpc('r', array(
		'id'	=> TYPE_UINT,	
	));
	
	$id 	= $vbulletin->GPC['id'];
	
	print_form_header('amefy', 'save');
	
	if (sizeof($errors))
	{
		
		print_table_header($vbphrase['ame_error_warning']);
		
		foreach ($errors as $value)
		{
			
			print_description_row($value);
			
		}
		
		print_table_break();
		
	}
	
	if ($id)
	{

		$existing	= fetch_it_baby($id);
		
	}
	else 
	{
		
		$existing 	= array();
		
	}
	
		
	$fields 		= fetch_valid_fields();
	$positions 		= fetch_the_damn_positions();
	$types			= array(
							0 => $vbphrase['amefy_typeid_0'],
							1 => $vbphrase['amefy_typeid_1']
						);		
	print_table_header($vbphrase['amefy_profile_field']);
	
	if ($id)
	{
		
		construct_hidden_code("id", $id);
		
	}

	print_input_row($vbphrase['amefy_title'], 'title', $existing['title']);
	print_input_row($vbphrase['amefy_width'], 'width', $existing['width']);
	print_input_row($vbphrase['amefy_height'], 'height', $existing['height']);		
	print_select_row($vbphrase['amefy_fieldid'], 'fieldids[]', $fields, explode(",", $existing['fieldids']), false, 0, true);
	print_select_row($vbphrase['amefy_typeid'], 'typeid', $types, $existing['typeid']);
	print_select_row($vbphrase['amefy_location'], 'position', $positions, $existing['position']);
	print_input_row($vbphrase['amefy_ordinal'], 'ordinal', $existing['ordinal']);
	
	print_submit_row($vbphrase['save'], '_default_', 2, '',
		"<input type=\"submit\" class=\"button\" tabindex=\"1\" name=\"return\" value=\"$vbphrase[ame_save_and_reload]\" accesskey=\"e\" />" .
		($id ? construct_button_code($vbphrase['delete'], 'amefy.php?do=delete&id=' . $id) : "")
	);		
	
	
}


if ($do == "delete")
{
	
	$vbulletin->input->clean_array_gpc('r', array(
		'id'	=> TYPE_STR,	
	));
	
	$id 	= $vbulletin->GPC['id'];

	$db->query_write("DELETE FROM " . TABLE_PREFIX . "amefy WHERE id=$id");
	
	redirect("display", "ame_saved_x");
	
	
}



?>