// #############################################################################
// Extensions to vB_AJAX_NameSuggest
// #############################################################################

function ldm_AJAX_doiSuggest(varname, textobjid, menukey) {
	if (use_suggest) {
		this.base_init(varname, textobjid, menukey);
		//issue 28733, the delimiter for names is a semi colon.
		this.set_primary_delimiter(";");
	}
}

ldm_AJAX_doiSuggest.prototype = new vB_AJAX_Suggest();

if (use_suggest) {
	ldm_AJAX_doiSuggest.prototype.get_search_url = function()
	{
		return this.rooturl + "local_links_ajax.php?do=doisearch";
	}

	ldm_AJAX_doiSuggest.prototype.get_search_post = function()
	{
		return SESSIONURL + "securitytoken=" + SECURITYTOKEN +
			"&do=doisearch&fragment=" + PHP.urlencode(this.fragment);
	}

	ldm_AJAX_doiSuggest.prototype.xmltag = 'key';
}

function ldm_AJAX_keySuggest(varname, textobjid, menukey) {
	this.base_init(varname, textobjid, menukey);
	this.set_primary_delimiter(",");
	this.allow_multiple = true;
	this.min_chars = 1;
}

ldm_AJAX_keySuggest.prototype = new vB_AJAX_Suggest();

if (use_suggest) {
	ldm_AJAX_keySuggest.prototype.get_search_url = function()
	{
		return this.rooturl + "local_links_ajax.php?do=keysearch";
	}

	ldm_AJAX_keySuggest.prototype.get_search_post = function()
	{
		return SESSIONURL + "securitytoken=" + SECURITYTOKEN +
			"&do=keysearch&fragment=" + PHP.urlencode(this.fragment);
	}

	ldm_AJAX_keySuggest.prototype.xmltag = 'key';
}


