<?php
/*======================================================================*\
|| #################################################################### ||
|| # BF - Easy Pages                                                  # ||
|| # Zafer BAHADIR                                                    # ||
|| # http://www.bizimforumlar.com                                     # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('CVS_REVISION', '$RCSfile$ - $Revision: 32878 $');

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array('cpuser');
$specialtemplates = array();
$actiontemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer('canadminusers'))
{
	print_cp_no_permission();
}

// ############################# LOG ACTION ###############################
log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

print_cp_header($vbphrase['bfeasypages_manager']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'bfeasypages_pagelist';
}


switch ($_REQUEST['do'])
{


	case 'add':
		print_cp_header($vbphrase['bfeasypages_add']);
		break;

	case 'del_ok':
		break;

	case 'deleted':
		print_cp_header($vbphrase['bfeasypages_deleted']);
		break;

	case 'recover':
		print_cp_header($vbphrase['bfeasypages_recover']);
		break;

	case 'add':
		print_cp_header($vbphrase['bfeasypages_add']);
		break;

	default:
		print_cp_header($vbphrase['bfeasypages_pagelist']);
}

// Get Page List
if ($_REQUEST['do'] == 'bfeasypages_pagelist')
{
 	$getpagelist =
        $db->query_read("
		SELECT *
		FROM " . TABLE_PREFIX . "bfeasypages
        WHERE status=1
        ORDER BY id DESC"
        );
	print_form_header();
	print_table_header($vbphrase['bfeasypages_yourpages']);
	while ($page = $db->fetch_array($getpagelist))
	{
      $hucre[1] .= "<a href='bfeasypages_admin.php?page=$page[id]'><b>$page[title]</b></a> <br /> Link: <a target='_new' href="
    . $vbulletin->options[bburl]."/bfeasypages.php?page=$page[id]>"
    . $vbulletin->options[bburl]."/bfeasypages.php?page=$page[id]</a>";
	  $hucre[2] .= "<a href='bfeasypages_admin.php?do=edit&id=$page[id]'>"
      . $vbphrase['bfeasypages_edit']."</a> | "
      . "<a href='bfeasypages_admin.php?do=delete&id=$page[id]'>" . $vbphrase['bfeasypages_delete']."</a>";
	  print_cells_row($hucre);
	  unset($hucre);
	}
	print_table_footer();
	print_cp_footer();
}

// Delete Page
if ($_REQUEST['do'] == 'deleted')
{
 	$getpagelist =
        $db->query_read("
		SELECT *
		FROM " . TABLE_PREFIX . "bfeasypages
        WHERE status=0
        ORDER BY id DESC"
        );
	print_form_header();
	print_table_header($vbphrase['bfeasypages_deleted']);
	while ($page = $db->fetch_array($getpagelist))
	{
      $hucre[1] .= "<a href='bfeasypages_admin.php?page=$page[id]'><b>$page[title]</b></a> <br /> Link: <a target='_new' href="
    . $vbulletin->options[bburl]."/bfeasypages.php?page=$page[id]>"
    . $vbulletin->options[bburl]."/bfeasypages.php?page=$page[id]</a>";
	  $hucre[2] .= "<a href='bfeasypages_admin.php?do=del_ok&id=$page[id]'>"
      . $vbphrase['bfeasypages_del_ok']."</a><br /><a href='bfeasypages_admin.php?do=recover&id=$page[id]'>"
      . $vbphrase['bfeasypages_recover']."</a>";
	  print_cells_row($hucre);
	  unset($hucre);
	}
	print_table_footer();
	print_cp_footer();
}


// Edit Page
if ($_REQUEST['do'] == 'edit')
{
	$id = $_REQUEST['id'];
 	$page = $db->query_first("
		SELECT * FROM " . TABLE_PREFIX . "bfeasypages
		WHERE id = $id LIMIT 1");

	print_form_header('bfeasypages_admin', 'edit_update');
	print_table_header($vbphrase['bfeasypages_edit']." : $page[title]");
	echo "<input type='hidden' name='id' value='$id'>";
	print_input_row($vbphrase['bfeasypages_title'], 'title', $page[title]);
	print_textarea_row($vbphrase['bfeasypages_content'], 'content', $page[content]);
	print_radio_row($vbphrase['bfeasypages_wrap'], 'vb4wrap', array( '1' => 'yes', '0' => 'no' ), $page[vb4wrap]);
	print_submit_row($vbphrase['bfeasypages_submit']);
	print_table_footer();
	print_cp_footer();

}

// Add Page
if ($_REQUEST['do'] == 'add')
{
	print_form_header('bfeasypages_admin', 'add_update');
	print_table_header($vbphrase['bfeasypages_add']);
	print_input_row($vbphrase['bfeasypages_title'], 'title');
	print_textarea_row($vbphrase['bfeasypages_content'], 'content', '','');
	print_radio_row($vbphrase['bfeasypages_wrap'], 'vb4wrap', array( '1' => 'yes', '0' => 'no' ),1);
	print_submit_row($vbphrase['bfeasypages_submit']);
	print_table_footer();
	print_cp_footer();
}

// Delete Page
if ($_REQUEST['do'] == 'delete')
{
    $vbulletin->db->query_write("
        UPDATE " . TABLE_PREFIX . "bfeasypages
		SET	status = 0
        WHERE id = " . $_REQUEST['id'] . ";
   		");
	print_cp_redirect('bfeasypages_admin.php');
}

// Recover Page
if ($_REQUEST['do'] == 'recover')
{
    $vbulletin->db->query_write("
        UPDATE " . TABLE_PREFIX . "bfeasypages
		SET	status = 1
        WHERE id = " . $_REQUEST['id'] . ";
   		");
	print_cp_redirect('bfeasypages_admin.php');
}

// Destroy Page
if ($_REQUEST['do'] == 'del_ok')
{
	$vbulletin->db->query_write("
        DELETE FROM " . TABLE_PREFIX . "bfeasypages
        WHERE id = '" . $_REQUEST['id'] . "' LIMIT 1");
	print_cp_redirect('bfeasypages_admin.php');
}

// Add Page Ok
if ($_REQUEST['do'] == 'add_update')
{
    $title = addslashes($_POST['title']);
    $content = addslashes($_POST['content']);
    $vbulletin->db->query_write("
        INSERT INTO " . TABLE_PREFIX . "bfeasypages
        SET	title = '$title', content = '$content', status='1', vb4wrap = '" . $_POST['vb4wrap'] . "'
        ");
    print_cp_redirect('bfeasypages_admin.php');
}

// Edit Page Ok
if ($_REQUEST['do'] == 'edit_update')
{
    $title = addslashes($_POST['title']);
    $content = addslashes($_POST['content']);
    $vbulletin->db->query_write("
        UPDATE " . TABLE_PREFIX . "bfeasypages
		SET	title = '$title',content = '$content',vb4wrap = '" . $_POST['vb4wrap'] . "'
        WHERE id = " . $_POST[id] . ";
   		");
	print_cp_redirect('bfeasypages_admin.php');
}

?>