<?php
// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array(
  'microclassifieds',
  'style'
);

$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/adminfunctions_template.php');
require_once(DIR . '/microclassifieds/includes/functions.php');
print_cp_header();
?>
<script type="text/javascript">
function actionCategory(box, id)
{
  var val = box.options[box.selectedIndex].value;
  if(val == 1)
    window.location = 'microclassifieds_admin.php?do=categories&action=index&catid=' + id;
  if(val == 2)
     window.location = 'microclassifieds_admin.php?do=categories&action=edit&catid=' + id;
  if(val == 3) {
    if(confirm('Delete Category? Subcategories will also removed.'))
      window.location = 'microclassifieds_admin.php?do=categories&action=delete&catid=' + id;
  }
}
</script>
<?php
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'categories';
}
if ($_REQUEST['do'] == 'categories') {
    $vbulletin->input->clean_array_gpc('r', array(
		'catid'    			=> TYPE_UINT,
		'action'			=> TYPE_STR
    ));
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
    } else {
       $catid = $_REQUEST["catid"];
    }
    if ($_REQUEST['action'] == 'insert')
    {
        print_form_header('microclassifieds_admin', 'categories', true);
    if($catid==0)
    {
	   print_table_header("New Top Category", 2);
    } else {
       $category = $db->query_first("SELECT name FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE id=$catid");
	   print_table_header("New Subcategory of ". $category["name"] ."", 2);
    }
    echo '<input type="hidden" name="action" value="save" />';
    echo '<input type="hidden" name="catid" value="'.$catid.'" />';
    print_input_row("Name", "name", "", 30, 50);
    print_submit_row();
    print_table_footer();
    return $catid;
  }
  if ($_REQUEST['action'] == 'save')
  {
      SaveCategory($catid);
  }
  if ($_REQUEST['action'] == 'edit')
  {
    print_form_header('microclassifieds_admin', 'categories', true);
 	print_table_header("Edit Category", 2);
    $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE id=$catid");
    $parentid = $category["parentid"];
	echo '<input type="hidden" name="action" value="update" />';
	echo '<input type="hidden" name="catid" value="'.$catid.'" />';
    echo '<input type="hidden" name="parentid" value="'.$parentid.'" />';
    print_input_row("Name", "name", $category["name"], 30, 50);
    print_submit_row();
    print_table_footer();
    return $catid;
  }

  if ($_REQUEST['action'] == 'update')
  {
    UpdateCategory($catid);
  }

  if ($_REQUEST['action'] == 'delete')
  {
      DeleteCategory($catid);
  }

  if ($_REQUEST['action'] == 'updateorder')
  {
      UpdateCategoriesOrder($catid);
  }

    print_form_header("microclassifieds_admin", "categories", true);
    if($catid==0)
    {
	   print_table_header("Top Level Categories", 3);
    } else {
       $category = $db->query_first("SELECT name FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE id=$catid");
	   print_table_header("Subcategories of ". $category["name"] ."", 3);
    }
	print_cells_row(array("Name", "Posts", "Action"), 1, 'tcat');

    $categories = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microclassifieds_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
    while($category = $db->fetch_array($categories)) {
          $cell[0] = $category["name"];
		  $cell[1] = '<input type="text" class="bginput" size="3" name="display['.$category["id"].']" value="'.$category["displayorder"].'">';
          $cell[2] = '<select class="bginput" name="action" onChange="actionCategory(this, '.$category["id"].')">
                      <option value="0">Select..</option>
                      <option value="1">Subcategories</option>
                      <option value="2">Edit</option>
                      <option value="3">Delete</option>
                      </select>';
 		  print_cells_row($cell);
    }
	echo '<input type="hidden" name="action" value="updateorder" />';
    echo '<input type="hidden" name="catid" value="'.$catid.'" />';
	print_table_footer(4, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\" Save Display Order \" accesskey=\"s\" />" . construct_button_code(" Add New Category ", "microclassifieds_admin.php?do=categories&action=insert&catid=$catid"));
}
print_cp_footer();
?>
