<?php

error_reporting(E_ALL & ~E_NOTICE);
define('THIS_SCRIPT', 'micromembers');

$phrasegroups = array(
	'posting',
	'postbit',
  'micromembers'
);

$specialtemplates = array();

$globaltemplates = array(
  	'micromembers_index',
  	'micromembers_letter',
  	'micromembers_users',
  	'micromembers_userbit',
    'micromembers_main',
    'micromembers_teambits',
    'micromembers_topposterbit',
    'micromembers_topposters',
    'micromembers_newuserbit',
    'micromembers_newusers',
    'im_aim',
    'im_icq',
    'im_msn',
    'im_skype',
    'im_yahoo',
    'im_send_aim',
    'im_send_icq',
    'im_send_msn',
    'im_send_skype',
    'im_send_yahoo',
    'im_message',
    'postbit_onlinestatus'
);

$actiontemplates = array();

require_once('./global.php');
require_once('./includes/functions_editor.php');
require_once('./includes/functions_wysiwyg.php');
require_once('./includes/functions_newpost.php');
require_once('./includes/functions_user.php');
require_once('./includes/class_bbcode.php');
require_once('./includes/class_image.php');
require_once('./includes/functions_bigthree.php');
require_once('./includes/class_bootstrap_framework.php');
vB_Bootstrap_Framework::init();

if(empty($_REQUEST['do']))
	$_REQUEST['do'] = 'main';

  $templatesets = array(
	//          userbit template              block template
	1 => array("micromembers_teambits", 				"micromembers_main"),
	2 => array("micromembers_topposterbit",		"micromembers_topposters"),
	3 => array("micromembers_newuserbit",			"micromembers_newusers")
  );

function printUsers($users, $title, $templateset, $totalposts = 0)
{
	global $db, $vbulletin, $vbphrase, $vboptions, $stylevar, $templatesets;
	$templates = $templatesets[$templateset];
	if($templateset != 3)
    {
		$cellwidth = count($users) > 0 ? round((1/count($users))*100) : 100;
	} else {
		$cellwidth = 100;
    }
    foreach($users as $user) {
        if($vbulletin->options['micromembers_type']== 1) {
           $avatarurl = fetch_avatar_url($user['userid']);
           if (!$avatarurl) {
    	      $teamavatar = 'micromembers/images/noavatar.gif';
           } else 	{
    	      $teamavatar = $vbulletin->options['bburl'] . '/' . $avatarurl[0];
           }
        } else {
		   $teamavatar = '';
		   $teamuserinfo = verify_id('user', $user['userid'], 1, 1, 47);
		   $showprofilepic = ($vbulletin->options['profilepicenabled'] AND
													$teamuserinfo['profilepic'] AND
												 	($permissions['genericpermissions'] &
												  	$vbulletin->bf_ugp_genericpermissions['canseeprofilepic'] OR
												  	$vbulletin->userinfo['userid'] == $teamuserinfo['userid'])) ? true : false;
		   if($vbulletin->options['usefileavatar'])
           {
		      $teamavatar = $vbulletin->options['profilepicurl'] . '/profilepic' . $teamuserinfo['userid'] . '_' . $teamuserinfo['profilepicrevision'] . '.gif';
		   } else {
			  $teamavatar = 'image.php?' . $vbulletin->session->vars['sessionurl'] . 'u=' . $teamuserinfo['userid'] . "&amp;dateline=$teamuserinfo[profilepicdateline]&amp;type=profile";
		   }
           if(empty($teamavatar) || !$showprofilepic)
           {
    	      $avatarurl = fetch_avatar_url($user['userid']);
              if(!$avatarurl) {
    	         $teamavatar = 'micromembers/images/nophoto.gif';
              } else {
    	         $teamavatar = $vbulletin->options['bburl'] . '/' . $avatarurl[0];
              }
            }
        }
		$userinfo = verify_id('user', $user['userid'], 1, 1);
	    $userinfo['lastvisitdate'] = iif($vbulletin->options['micromembers_dateformat'] == 1, date('d/m/Y', $userinfo['lastvisit']), date('m/d/Y', $userinfo['lastvisit']));
        $userinfo['lastvisittime'] = vbdate($vbulletin->options['timeformat'], $userinfo['lastvisit']);
        $userinfo['joindate'] = iif($vbulletin->options['micromembers_dateformat'] == 1, date('d/m/Y', $userinfo['joindate']), date('m/d/Y', $userinfo['joindate']));
	    $useronline = fetch_online_status($userinfo, true);
        $userinfo['onlinestatuskey'] = $userinfo['onlinestatus'];
        $totalcount ++;
		$postpercents = 0;
		if($totalposts != 0)
        {
		   $postpercents = round(($user['postcount']/$totalposts) * 100);
        }
	    $members_featured = '<td align="center" valign="top" class="blockrow">';
        if($vboptions[micromembers_type]==2)
        {
		   $members_type = '<a href="'.$teamavatar.'" rel="thumbnail">
    <img border="0" src="'.$teamavatar.'" width="'.$vboptions[micromembers_imagewidth].'"/></a><br />';
		} else {
		   $members_type = '<img border="0" src="'.$teamavatar.'"><br />';
		}
        if($vboptions[micromembers_rating]==1){
		   if($user[rating] > 0){
		      $members_rating = '<img class="inlineimg" src="images/rating/rating-15_'.$user[rating].'.png" /><br />';
		   }
		}
        if($vboptions[micromembers_online]==1){
		   $members_online = $userinfo[onlinestatuskey].'<br />';
		}
        $templater = vB_Template::create($templates[0]);
        $templater->register('members_featured', $members_featured);
		$templater->register('members_type', $members_type);
		$templater->register('userid', $user[userid]);
		$templater->register('username', $user[username]);
		$templater->register('usertitle', $user[usertitle]);
		$templater->register('postcount', $user[postcount]);
		$templater->register('totalposts', $totalposts);
		$templater->register('postpercents', $postpercents);
		$templater->register('members_rating', $members_rating);
		$templater->register('members_online', $members_online);
		$templater->register('joindate', $userinfo[joindate]);
		$templater->register('lastvisitdate', $userinfo[lastvisitdate]);
		$teambits .= $templater->render();
  }
  unset($teamarray);
  $plugin = 0;
  $templater = vB_Template::create($templates[1]);
  $templater->register('title', $title);
  $templater->register('teambits', $teambits);
  $meetteams .= $templater->render();
  return $meetteams;
}

function getMenu()
{
	global $db, $vbphrase;

	$usergroups_get = $db->query_read("
		SELECT ".TABLE_PREFIX."usergroup.usergroupid, ".TABLE_PREFIX."usergroup.title,
			COUNT(".TABLE_PREFIX."user.userid) AS membercount
		FROM ".TABLE_PREFIX."usergroup
		LEFT JOIN ".TABLE_PREFIX."user
			ON ".TABLE_PREFIX."user.usergroupid=".TABLE_PREFIX."usergroup.usergroupid
			OR FIND_IN_SET(".TABLE_PREFIX."usergroup.usergroupid, ".TABLE_PREFIX."user.membergroupids)
		WHERE ".TABLE_PREFIX."usergroup.ismicromembers=1
		GROUP BY ".TABLE_PREFIX."usergroup.usergroupid
		ORDER BY ".TABLE_PREFIX."usergroup.title
	");
	$menulinks = '';
	while($ugroup = $db->fetch_array($usergroups_get)) {
		if(!empty($menulinks))
			$menulinks .= '&nbsp;';
		$menulinks .= '<a href="memberlist.php?do=usergrouplisting&groupid='.$ugroup['usergroupid'].'"><b>'.$ugroup['title'].'</b></a> (<b>'.$ugroup['membercount'].'</b>)&nbsp;&nbsp;&nbsp;';
	}
	return $menulinks;
}

if($_REQUEST['do'] == 'main') {

  // Build Usergroup Menu
	$menulinks = getMenu();

  // Get some variables
  $limit = $vbulletin->options['micromembers_count'];
  $admingroup = $vbulletin->options['micromembers_admins_group'];
  $admingroup2 = $vbulletin->options['micromembers_admins2_group'];

  // Build Admins Block
  if ($vbulletin->options[micromembers_admins] == '1') {
     $teammembers_get = $vbulletin->db->query_read("
     SELECT ".TABLE_PREFIX."user.userid, ".TABLE_PREFIX."user.username, ".TABLE_PREFIX."user.usertitle
     FROM ".TABLE_PREFIX."user
  	 JOIN ".TABLE_PREFIX."usergroup AS ugroup
			ON ugroup.usergroupid=".TABLE_PREFIX."user.usergroupid
		 LEFT JOIN ".TABLE_PREFIX."usergroup
			ON (FIND_IN_SET(".TABLE_PREFIX."usergroup.usergroupid, ".TABLE_PREFIX."user.membergroupids))
 		 WHERE ugroup.usergroupid=$admingroup OR ".TABLE_PREFIX."usergroup.usergroupid=$admingroup
		 GROUP BY ".TABLE_PREFIX."user.userid
     ORDER BY RAND()
     LIMIT $limit
     ");
	   $teammembers = array();
	   while($teammember = $db->fetch_array($teammembers_get))
		       $teammembers[] = $teammember;
	   $admins = printUsers($teammembers, $vbulletin->options['micromembers_admins_text'], 1);
  }

  // Build 2nd Block if user wants it
  if ($vbulletin->options[micromembers_admins2] == '1') {
     $teammembers2_get = $vbulletin->db->query_read("
     SELECT ".TABLE_PREFIX."user.userid, ".TABLE_PREFIX."user.username, ".TABLE_PREFIX."user.usertitle
     FROM ".TABLE_PREFIX."user
  	 JOIN ".TABLE_PREFIX."usergroup AS ugroup
			ON ugroup.usergroupid=".TABLE_PREFIX."user.usergroupid
		 LEFT JOIN ".TABLE_PREFIX."usergroup
			ON (FIND_IN_SET(".TABLE_PREFIX."usergroup.usergroupid, ".TABLE_PREFIX."user.membergroupids))
 		 WHERE ugroup.usergroupid=$admingroup2 OR ".TABLE_PREFIX."usergroup.usergroupid=$admingroup2
		 GROUP BY ".TABLE_PREFIX."user.userid
     ORDER BY RAND()
     LIMIT $limit
     ");
	   $teammembers2 = array();
	   while($teammember2 = $db->fetch_array($teammembers2_get))
		       $teammembers2[] = $teammember2;
	   $admins2 = printUsers($teammembers2, $vbulletin->options['micromembers_admins2_text'], 1);
  }

  // Top Pated
  if ($vbulletin->options[micromembers_rating] == '1') {
	    $topusers_get = $db->query_read("
  		SELECT ".TABLE_PREFIX."user.userid, username, usertitle,
			AVG(".TABLE_PREFIX."micromembers_ratings.rating) AS rating
  		FROM ".TABLE_PREFIX."user
  		JOIN ".TABLE_PREFIX."micromembers_ratings
			ON ".TABLE_PREFIX."micromembers_ratings.rateduserid=".TABLE_PREFIX."user.userid
  		GROUP BY ".TABLE_PREFIX."user.userid
  		ORDER BY rating DESC
  		LIMIT $limit
    	");
    	$toprated = array();
    	while($topuser = $db->fetch_array($topusers_get)) {
  		$topuser['rating'] = intval(round($topuser['rating']));
  		$toprated[] = $topuser;
	    }
    	$toprated = printUsers($toprated, $vbulletin->options['micromembers_toprated_text'], 3);
  }

  // Just Joined us
  if ($vbulletin->options[micromembers_newest] == '1') {
	    $newusers_get = $db->query_read("
                  		SELECT userid, username, usertitle
                  		FROM ".TABLE_PREFIX."user
                  		WHERE usergroupid=2 OR FIND_IN_SET(2, membergroupids)
                  		ORDER BY joindate DESC
                  		LIMIT $limit");
    	$users = array();
    	while($newuser = $db->fetch_array($newusers_get))
  		$users[] = $newuser;
    	$newusers = printUsers($users, $vbulletin->options['micromembers_newest_text'], 3);
    	unset($users);
  }

  // Week's Top Posters
  if ($vbulletin->options[micromembers_week] == '1') {
	  $timelimit = time() - 7 * 24 * 60 * 60;
      $mostactiveweek_get = $db->query_read("
	  SELECT COUNT(post.dateline) AS postcount, post.userid,
	  user.userid, user.username, user.lastpostid, user.posts, user.usergroupid
	  FROM " . TABLE_PREFIX . "post AS post
        JOIN " . TABLE_PREFIX . "user AS user ON (post.userid = user.userid)
      WHERE user.posts != '0' AND user.usergroupid=2 AND post.dateline>'".$timelimit."'
      GROUP BY post.userid
      ORDER BY postcount DESC
  	  LIMIT $limit
	  ");
      $users = array();
      while($user = $db->fetch_array($mostactiveweek_get))
      {
  	      	$users[] = $user;
    	    $totalposts = $db->query_first("SELECT COUNT(postid) AS postcount FROM ".TABLE_PREFIX."post WHERE dateline>'".$timelimit."'");
    	    $mostactiveusersweek = printUsers($users, $vbulletin->options['micromembers_week_text'], 2, $totalposts['postcount']);
    	    unset($users);
      }
  }
  // Month's Top Posters
  if ($vbulletin->options[micromembers_month] == '1') {
	    $timelimit = time() - 30 * 24 * 60 * 60;
    	$mostactivemonth_get = $db->query_read("
  		SELECT ".TABLE_PREFIX."user.userid, ".TABLE_PREFIX."user.username, ".TABLE_PREFIX."user.usertitle,
			COUNT(".TABLE_PREFIX."post.postid) AS postcount
  		FROM ".TABLE_PREFIX."user
  		LEFT JOIN ".TABLE_PREFIX."post
 			ON ".TABLE_PREFIX."post.userid=".TABLE_PREFIX."user.userid
 		  AND dateline>'".$timelimit."'
  		WHERE usergroupid=2
  		GROUP BY ".TABLE_PREFIX."user.userid
  		ORDER BY postcount DESC
  		LIMIT $limit");
    	$users = array();
    	while($user = $db->fetch_array($mostactivemonth_get))
  		$users[] = $user;
    	$totalposts = $db->query_first("SELECT COUNT(postid) AS postcount FROM ".TABLE_PREFIX."post WHERE dateline>'".$timelimit."'");
    	$mostactiveusersmonth = printUsers($users, $vbulletin->options['micromembers_month_text'], 2, $totalposts['postcount']);
    	unset($users);
  }

  // Overall Top Posters
  if ($vbulletin->options[micromembers_overall] == '1') {
	    $mostactive_get = $db->query_read("
  		SELECT userid, username, usertitle, posts AS postcount
  		FROM ".TABLE_PREFIX."user
  		WHERE usergroupid=2
  		ORDER BY posts DESC
  		LIMIT $limit");
    	$users = array();
    	while($user = $db->fetch_array($mostactive_get))
  		$users[] = $user;
    	$totalposts = $db->query_first("SELECT COUNT(postid) AS postcount FROM ".TABLE_PREFIX."post");
    	$mostactiveusers = printUsers($users, $vbulletin->options['micromembers_overall_text'], 2, $totalposts['postcount']);
    	unset($users);
  }


	if($vbulletin->options[micromembers_rating]==1){
		if(!empty($toprated)){
			$templater = vB_Template::create('micromembers_index_toprated');
			$templater->register('toprated', $toprated);
			$members_rating .= $templater->render();

		}
	}

	if($vbulletin->options[micromembers_admins]==1){
		if(!empty($admins)){
		$members_admins = $admins;
		}
	}

	if($vbulletin->options[micromembers_admins2]==1){
		if(!empty($admins2)){
		$members_admins2 = $admins2;
		}
	}

	if($vbulletin->options[micromembers_rating]==1){
		if(!empty($topusers)){
		$members_rating1 = $topusers;
		}
	}

	if(!empty($users)){
		$members_users = $users.$pagenav;
	}

	if($vbulletin->options[micromembers_week]==1){
		if(!empty($mostactiveusersweek)){
		$members_week = $mostactiveusersweek;
		}
	}

	if($vbulletin->options[micromembers_month]==1){
		if(!empty($mostactiveusersmonth)){
		$members_month = $mostactiveusersmonth;
		}
	}

	if($vbulletin->options[micromembers_overall]==1){
		if(!empty($mostactiveusers)){
		$members_overall = $mostactiveusers;
		}
	}

	if($vbulletin->options[micromembers_newest]==1){
		if(!empty($newusers)){
			$templater = vB_Template::create('micromembers_index_newusers');
					$templater->register('newusers', $newusers);
					$members_newest .= $templater->render();
		}
	}

	$templater = vB_Template::create('micromembers_index');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("memberlist.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['micromembers_navbar_text']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('lettersoutput', $lettersoutput);
	$templater->register('menulinks', $menulinks);
	$templater->register('usergroupoptions', $usergroupoptions);
	$templater->register('members_rating', $members_rating);
	$templater->register('members_admins', $members_admins);
	$templater->register('members_admins2', $members_admins2);
	$templater->register('members_rating1', $members_rating1);
	$templater->register('members_users', $members_users);
	$templater->register('members_week', $members_week);
	$templater->register('members_month', $members_month);
	$templater->register('members_overall', $members_overall);
	$templater->register('members_newest', $members_newest);
	print_output($templater->render());

}


if($_REQUEST['do'] == 'usergrouplisting') {
  $groupid = $vbulletin->input->clean_gpc('r', 'groupid', TYPE_UINT);
	$group = $db->query_first("SELECT usergroupid, title FROM ".TABLE_PREFIX."usergroup WHERE usergroupid=$groupid");
	if(!$group)
		print_no_permission();

	if($_REQUEST['action'] == 'rateuser') {
	  $rateduserid = $vbulletin->input->clean_gpc('r', 'userid', TYPE_UINT);
	  $vote = $vbulletin->input->clean_gpc('r', 'vote', TYPE_UINT);
		$userid = $vbulletin->userinfo['userid'];
		$rating = $db->query_first("SELECT rating FROM ".TABLE_PREFIX."micromembers_ratings WHERE userid=$userid AND rateduserid=$rateduserid");
		if($rating || $vote < 1 || $vote > 5)
			print_no_permission();
		$db->query_write("INSERT INTO ".TABLE_PREFIX."micromembers_ratings (userid, rateduserid, rating)
			                VALUES ($userid, $rateduserid, $vote)");
	}

  $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
  if (empty($pagenumber))
  {
      $pagenumber = 1;
  }
  $letter = $db->escape_string($vbulletin->input->clean_gpc('r', 'ltr', TYPE_NOHTML));
	$where = '';
	if($letter == '#')
		$letter = '';
	if(!empty($letter))
		$where = "AND ".TABLE_PREFIX."user.username LIKE '$letter%' ";
	  $cols = $vbulletin->options['micromembers_usercols'];
  	$cellwidth = round((1/$cols)*100);
  	$rows = $vbulletin->options['micromembers_userrows'];
    $recperpage = $cols * $rows;
    $totalrecords = $db->query_first("
    SELECT COUNT(*) AS totalrecords
		FROM ".TABLE_PREFIX."user
		WHERE (".TABLE_PREFIX."user.usergroupid=$groupid
			OR FIND_IN_SET($groupid, ".TABLE_PREFIX."user.membergroupids)) $where
  	");
    $limitlower = ($pagenumber - 1) * $recperpage + 1;
    $limitupper = $pagenumber * $recperpage;
    if($limitupper > $totalrecords['totalrecords']) {
       $limitupper = $totalrecords['totalrecords'];
    if($limitlower > $totalrecords['totalrecords'])
       $limitlower = $totalrecords['totalrecords'] - $recperpage;
    }
    if($limitlower <= 0) {
       $limitlower = 1;
    }
  	$users_get = $db->query_read("
		SELECT ".TABLE_PREFIX."user.userid, username, usertitle,
			AVG(".TABLE_PREFIX."micromembers_ratings.rating) AS rating
		FROM ".TABLE_PREFIX."user
		LEFT JOIN ".TABLE_PREFIX."micromembers_ratings
			ON ".TABLE_PREFIX."micromembers_ratings.rateduserid=".TABLE_PREFIX."user.userid
		WHERE (".TABLE_PREFIX."user.usergroupid=$groupid
			OR FIND_IN_SET($groupid, ".TABLE_PREFIX."user.membergroupids)) $where
			GROUP BY ".TABLE_PREFIX."user.userid
		ORDER BY ".TABLE_PREFIX."user.username
		LIMIT " . ($limitlower - 1) . ", $recperpage
  	");
  	$pagenav = construct_page_nav($pagenumber, $recperpage, $totalrecords['totalrecords'], "memberlist.php?" . $vbulletin->session->vars['sessionurl'] . "do=usergrouplisting&groupid=$groupid&ltr=$letter");
  	$userbits1 = "";
  	$idx = 0;
  	$cnt = 0;
  	$cols = $vbulletin->options['micromembers_usercols'];
  	while($user = $db->fetch_array($users_get)) {
      		$user['rating'] = intval(round($user['rating']));
		if($idx == 0)
     	 $userbits .= '<tr>';
    if($vbulletin->options['micromembers_type']== 1) {
       $avatarurl = fetch_avatar_url($user['userid']);
       if (!$avatarurl) {
      	  $teamavatar = 'micromembers/images/noavatar.gif';
       } else 	{
      	  $teamavatar = $vbulletin->options['bburl'] . '/' . $avatarurl[0];
       }
    } else {
			$teamavatar = '';
			$teamuserinfo = verify_id('user', $user['userid'], 1, 1, 47);
			$showprofilepic = ($vbulletin->options['profilepicenabled'] AND
													$teamuserinfo['profilepic'] AND
												 	($permissions['genericpermissions'] &
												  	$vbulletin->bf_ugp_genericpermissions['canseeprofilepic'] OR
												  	$vbulletin->userinfo['userid'] == $teamuserinfo['userid'])) ? true : false;
			if($vbulletin->options['usefileavatar'])	{
				$teamavatar = $vbulletin->options['profilepicurl'] . '/profilepic' . $teamuserinfo['userid'] . '_' . $teamuserinfo['profilepicrevision'] . '.gif';
			}	else {
				$teamavatar = 'image.php?' . $vbulletin->session->vars['sessionurl'] . 'u=' . $teamuserinfo['userid'] . "&amp;dateline=".$teamuserinfo['profilepicdateline']."&amp;type=profile";
			}
      if(empty($teamavatar) || !$showprofilepic) {
    	  $avatarurl = fetch_avatar_url($user['userid']);
        if(!$avatarurl) {
    	    $teamavatar = 'micromembers/images/nophoto.gif';
        } else {
    	    $teamavatar = $vbulletin->options['bburl'] . '/' . $avatarurl[0];
        }
      }
    }
		$userinfo = verify_id('user', $user['userid'], 1, 1);
	  $userinfo['lastvisitdate'] = iif($vbulletin->options['micromembers_dateformat'] == 1, date('d/m/Y', $userinfo['lastvisit']), date('m/d/Y', $userinfo['lastvisit']));
    $userinfo['lastvisittime'] = vbdate($vbulletin->options['timeformat'], $userinfo['lastvisit']);
    $userinfo['joindate'] = iif($vbulletin->options['micromembers_dateformat'] == 1, date('d/m/Y', $userinfo['joindate']), date('m/d/Y', $userinfo['joindate']));
	  $useronline = fetch_online_status($userinfo, true);
    $userinfo['onlinestatuskey'] = $userinfo['onlinestatus'];
		$showrating = 1;
		$myuserid = $vbulletin->userinfo['userid'];
		$rating = $db->query_first("SELECT rating FROM ".TABLE_PREFIX."micromembers_ratings WHERE userid='".$myuserid."' AND rateduserid=".$user['userid']);
		$alreadyrated = $rating ? true : false;
		$returnaddress = urlencode($_SERVER["QUERY_STRING"]);

		if($vbulletin->options[micromembers_online]=='1'){
			$statuskey = $userinfo[onlinestatuskey];
		}

		if($vbulletin->options[micromembers_rating]=='1'){
			if(!($permissions['micromembers'] & $vbulletin->bf_ugp['micromembers']['canrate'])){
			}else{
				if($showrating){
					if($rating){
						$ratedornot = '<img class="inlineimg" border="0" src="images/rating/rating-15_'.$user[rating].'.png" />';
					}else{
						$ratedornot = $vbphrase[micromembers_rate_user];
					}
				if($alreadyrated == 1){
					$hasornotrateduser = '<td width="40%" align="right">'.$ratedornot.'</td>';
				}else{
					unset($hasornotrateduser);
					$templater = vB_Template::create('micromembers_userrating_bit');
					$templater->register('userruserid', $user[userid]);
					$templater->register('pagenumber', $pagenumber);
					$templater->register('groupid', $groupid);
					$templater->register('ratedornot', $ratedornot);
					$hasornotrateduser .= $templater->render();
				}
				}
			}
		}
		$myoutput = '';
		if($permissions[micromembers] & $vbulletin->bf_ugp[micromembers][cancontact]){
			$myoutput .= '<td width="100%" align="left">';
			$myoutput .= '<td width="18">
                <a target="_blank" href="member.php?u='.$userinfo[userid].'">
                <img border="0" src="micromembers/images/profile_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_alt_profile].'"></a></td>
              <td width="18">
                <a target="_blank" href="private.php?do=newpm&u='.$userinfo[userid].'">
                <img border="0" src="micromembers/images/contact_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_alt_contact].'"></a></td>
              <td width="18">
                <a target="_blank" href="profile.php?do=addlist&userlist=buddy&u='.$userinfo[userid].'">
                <img border="0" src="micromembers/images/buddy_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_alt_buddy].'"></a></td>
              <td width="18">';
			  if ($userinfo[homepage]<>''){
			  $myoutput .= '<a target="_blank" href="'.$userinfo[homepage].'">
                  <img border="0" src="micromembers/images/homepage_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_alt_homepage].'"></a></td>';
			  }else{
				  $myoutput .= '<img border="0" src="micromembers/images/homepage_off.gif" width="18" height="18"></td>';
			  }
			  $myoutput .= '<td width="18">';
			  if($userinfo[icq]<>''){
			  $myoutput .= '<a href="#">
                  <img border="0" src="micromembers/images/icq_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_send_message_via_icq_to_x].'&nbsp;'.$userinfo[username].'"></a></td>';
			  }else{
			  $myoutput .= '<img border="0" src="micromembers/images/icq_off.gif" width="18" height="18"></td>';
			  }
			  $myoutput .= '<td width="18">';
			  if($userinfo[aim]<>''){
			  $myoutput .= '<a href="#">
                  <img border="0" src="micromembers/images/aim_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_send_message_via_aim_to_x].'&nbsp;'.$userinfo[username].'"></a></td>';
			  }else{
			  $myoutput .= '<img border="0" src="micromembers/images/aim_off.gif" width="18" height="18"></td>';
			  }
			  $myoutput .= '<td width="18">';
			  if($userinfo[msn]<>''){
			  $myoutput .= '<a href="#">
                  <img border="0" src="micromembers/images/msn_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_send_message_via_msn_to_x].'&nbsp;'.$userinfo[username].'"></a></td>';
			  }else{
			  $myoutput .= '<img border="0" src="micromembers/images/msn_off.gif" width="18" height="18"></td>';
			  }
			  $myoutput .= '<td width="18">';
			  if($userinfo[yahoo]<>''){
			  $myoutput .= '<a href="#">
                  <img border="0" src="micromembers/images/yahoo_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_send_message_via_yahoo_to_x].'&nbsp;'.$userinfo[username].'"></a></td>';
			  }else{
			  $myoutput .= '<img border="0" src="micromembers/images/yahoo_off.gif" width="18" height="18"></td>';
			  }
			  $myoutput .= '<td width="18">';
			  if($userinfo[skype]<>''){
			  $myoutput .= '<a href="#">
                  <img border="0" src="micromembers/images/skype_on.gif" width="18" height="18" alt="'.$vbphrase[micromembers_send_message_via_skype_to_x].'&nbsp;'.$userinfo[username].'"></a></td>';
			  }else{
			  $myoutput .= '<img border="0" src="micromembers/images/skype_off.gif" width="18" height="18"></td>';
			  }
		}else{
			$myoutput .= '<td width="100%" align="left">
                &nbsp;
              <td width="18">
                <img border="0" src="micromembers/images/profile_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/contact_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/buddy_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/homepage_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/icq_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/aim_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/msn_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/yahoo_off.gif" width="18" height="18"></td>
              <td width="18">
                <img border="0" src="micromembers/images/skype_off.gif" width="18" height="18"></td>';
		}


					$templater = vB_Template::create('micromembers_userbit');
					$templater->register('cellwidth', $cellwidth);
					$templater->register('useruserid', $user[userid]);
					$templater->register('userusername', $user[username]);
					$templater->register('statuskey', $statuskey);
					$templater->register('hasornotrateduser', $hasornotrateduser);
					$templater->register('teamavatar', $teamavatar);
					$templater->register('usertitle', $user[usertitle]);
					$templater->register('joindate', $userinfo[joindate]);
					$templater->register('lastvisitdate', $userinfo[lastvisitdate]);
					$templater->register('userinfouserid', $userinfo[userid]);
					$templater->register('userinfoposts', $userinfo[posts]);
					$templater->register('username', $userinfo[username]);
					$templater->register('returnaddress', $returnaddress);
					$templater->register('userinfohomepage', $userinfo[homepage]);
					$templater->register('myoutput', $myoutput);
					$userbits .= $templater->render();

		$idx++;
		if($idx == $cols) {
			$userbits1 .= '</tr>';
			$idx = 0;
		}
		$cnt++;
	}
	if($cnt > 0 && $idx != $cols) {
		for($i = $idx; $i<$cols; $i++)
			$userbits1 .= '<td width="'.$cellwidth.'%">&nbsp;</td>';
		$userbits1 .= '</tr>';
	}

					$templater = vB_Template::create('micromembers_users');
					$templater->register('userbits', $userbits);
					$templater->register('userbits1', $userbits1);
					$users .= $templater->render();

  $limit = $vbulletin->options['micromembers_count'];
	$topusers_get = $db->query_read("
		SELECT ".TABLE_PREFIX."user.userid, username, usertitle,
			AVG(".TABLE_PREFIX."micromembers_ratings.rating) AS rating
		FROM ".TABLE_PREFIX."user
		JOIN ".TABLE_PREFIX."micromembers_ratings
			ON ".TABLE_PREFIX."micromembers_ratings.rateduserid=".TABLE_PREFIX."user.userid
		WHERE ".TABLE_PREFIX."user.usergroupid=$groupid
			OR FIND_IN_SET($groupid, ".TABLE_PREFIX."user.membergroupids)
		GROUP BY ".TABLE_PREFIX."user.userid
		ORDER BY rating DESC
		LIMIT $limit
	");
	$topusers = array();
	while($topuser = $db->fetch_array($topusers_get)) {
		$topuser['rating'] = intval(round($topuser['rating']));
		$topusers[] = $topuser;
	}
	$topusers = printUsers($topusers, "Top members", 1);
	$currentletter = '#';
	$linkletter = urlencode('#');
	$selectedletter = $letter;
	if($selectedletter == ''){
		$selectedletter = $currentletter;
	}else{
	$selectedletter = $letter;
	}
	$show['selectedletter'] = $selectedletter == '#' ? true : false;

	if($show['selectedletter']){
		$letter_html = '<td align="center" class="blocksubhead" width="3%">[<strong>'.$currentletter.'</strong>]</td>';
	}else{
		$letter_html = '<td align="center" width="3%"><a href="memberlist.php?'.$session[sessionurl].'do=usergrouplisting&amp;ltr='.$linkletter.'&amp;groupid='.$groupid.'&amp;pagenumber='.$pagenumber.'">'.$currentletter.'</a></td>';
	}
					$templater = vB_Template::create('micromembers_letter');
					$templater->register('letter_html', $letter_html);
					$lettersoutput .= $templater->render();
	for ($i=65; $i < 91; $i++) {
		$currentletter = chr($i);
		$linkletter =& $currentletter;
		$show['selectedletter'] = $selectedletter == $currentletter ? true : false;

	if($show['selectedletter']){
		$letter_html = '<td align="center" class="blocksubhead" width="3%">[<strong>'.$currentletter.'</strong>]</td>';
	}else{
		$letter_html = '<td align="center" width="3%"><a href="memberlist.php?'.$session[sessionurl].'do=usergrouplisting&amp;ltr='.$linkletter.'&amp;groupid='.$groupid.'&amp;pagenumber='.$pagenumber.'">'.$currentletter.'</a></td>';
	}

					$templater = vB_Template::create('micromembers_letter');
					$templater->register('letter_html', $letter_html);
					$lettersoutput .= $templater->render();
	}

	$menulinks = getMenu();




	if($vbulletin->options[micromembers_rating]==1){
		if(!empty($toprated)){
			$templater = vB_Template::create('micromembers_index_toprated');
					$templater->register('toprated', $toprated);
					$members_rating .= $templater->render();

		}
	}

	if($vbulletin->options[micromembers_admins]==1){
		if(!empty($admins)){
		$members_admins = $admins;
		}
	}

	if($vbulletin->options[micromembers_admins2]==1){
		if(!empty($admins2)){
		$members_admins2 = $admins2;
		}
	}

	if($vbulletin->options[micromembers_rating]==1){
		if(!empty($topusers)){
		$members_rating1 = $topusers;
		}
	}
	
	if(!empty($users)){
		$members_users = $users.$pagenav;
	}
	
	if($vbulletin->options[micromembers_week]==1){
		if(!empty($mostactiveusersweek)){
		$members_week = $mostactiveusersweek;
		}
	}
	
	if($vbulletin->options[micromembers_month]==1){
		if(!empty($mostactiveusersmonth)){
		$members_month = $mostactiveusersmonth;
		}
	}
	
	if($vbulletin->options[micromembers_overall]==1){
		if(!empty($mostactiveusers)){
		$members_overall = $mostactiveusers;
		}
	}
	
	if($vbulletin->options[micromembers_newest]==1){
		if(!empty($newusers)){
			$templater = vB_Template::create('micromembers_index_newusers');
					$templater->register('newusers', $newusers);
					$members_newest .= $templater->render();
		}
	}
	
	$templater = vB_Template::create('micromembers_index');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("memberlist.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['micromembers_navbar_text'],
		"" => $group['title']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('lettersoutput', $lettersoutput);
	$templater->register('menulinks', $menulinks);
	$templater->register('usergroupoptions', $usergroupoptions);
	$templater->register('mypopup', $mypopup);
	$templater->register('mypopup1', $mypopup1);
	$templater->register('mypopup2', $mypopup2);
	$templater->register('mypopup3', $mypopup3);
	$templater->register('mypopup4', $mypopup4);
	$templater->register('mypopup5', $mypopup5);
	$templater->register('mypopup6', $mypopup6);
	$templater->register('mypopup7', $mypopup7);
	$templater->register('members_rating', $members_rating);
	$templater->register('members_admins', $members_admins);
	$templater->register('members_admins2', $members_admins2);
	$templater->register('members_rating1', $members_rating1);
	$templater->register('members_users', $members_users);
	$templater->register('members_week', $members_week);
	$templater->register('members_month', $members_month);
	$templater->register('members_overall', $members_overall);
	$templater->register('members_newest', $members_newest);
	$templater->register('members_users', $users);
    $templater->register('pagenav', $pagenav);
	print_output($templater->render()); 
	
}

function getBirthday($age)
{
	$btime = time() - 60*60*24*365*$age;
	return date('Y-m-d', $btime);
}

function getTime($date, $plus = 0)
{
	list($year, $month, $day) = split('-', $date);
	if($plus) $day++;
	return(mktime(0, 0, 0, $month, $day, $year));
}

?>
