<?php
// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array(
  'microsupport',
  'style'
);

$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/adminfunctions_template.php');
require_once(DIR . '/microsupport/includes/functions.php');
print_cp_header();
?>
<script type="text/javascript">
function actionCategory(box, id)
{
  var val = box.options[box.selectedIndex].value;
  if(val == 1)
    window.location = 'microsupport_admin.php?do=categories&action=index&catid=' + id;
  if(val == 2)
     window.location = 'microsupport_admin.php?do=categories&action=edit&catid=' + id;
  if(val == 3) {
    if(confirm('Delete Category? Subcategories will also removed.'))
      window.location = 'microsupport_admin.php?do=categories&action=delete&catid=' + id;
  }
}
</script>
<script type="text/javascript">
function actionDepartment(box, id)
{
  var val = box.options[box.selectedIndex].value;
  if(val == 1)
     window.location = 'microsupport_admin.php?do=departments&action=edit&departmentid=' + id;
  if(val == 2) {
    if(confirm('Delete Department?'))
      window.location = 'microsupport_admin.php?do=departments&action=delete&departmentid=' + id;
  }
}
</script>
<script type="text/javascript">
function actionProduct(box, id)
{
  var val = box.options[box.selectedIndex].value;
  if(val == 1)
     window.location = 'microsupport_admin.php?do=products&action=edit&productid=' + id;
  if(val == 2) {
    if(confirm('Delete Product?'))
      window.location = 'microsupport_admin.php?do=products&action=delete&productid=' + id;
  }
}
</script>
<script type="text/javascript">
function actionStatus(box, id)
{
  var val = box.options[box.selectedIndex].value;
  if(val == 1)
     window.location = 'microsupport_admin.php?do=statuses&action=edit&statusid=' + id;
}
</script>
<?php
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'categories';
}
if ($_REQUEST['do'] == 'categories') {
    $vbulletin->input->clean_array_gpc('r', array(
		'catid'    			=> TYPE_UINT,
		'action'			=> TYPE_STR
    ));
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
    } else {
       $catid = $_REQUEST["catid"];
    }
    if ($_REQUEST['action'] == 'insert')
    {
        print_form_header('microsupport_admin', 'categories', true);
    if($catid==0)
    {
	   print_table_header("". $vbphrase['microsupport_admin_new_top_category'] . "", 2);
    } else {
       $category = $db->query_first("SELECT name FROM ". TABLE_PREFIX ."microsupport_categories WHERE id=$catid");
	   print_table_header("". $vbphrase['microsupport_admin_new_sub_category'] . $category["name"] ."", 2);
    }
    echo '<input type="hidden" name="action" value="save" />';
    echo '<input type="hidden" name="catid" value="'.$catid.'" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", "", 30, 50);
    print_submit_row();
    print_table_footer();
    return $catid;
  }
  if ($_REQUEST['action'] == 'save')
  {
      SaveCategory($catid);
  }
  if ($_REQUEST['action'] == 'edit')
  {
    print_form_header('microsupport_admin', 'categories', true);
 	print_table_header("". $vbphrase['microsupport_admin_edit_category'] . "", 2);
    $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microsupport_categories WHERE id=$catid");
    $parentid = $category["parentid"];
	echo '<input type="hidden" name="action" value="update" />';
	echo '<input type="hidden" name="catid" value="'.$catid.'" />';
    echo '<input type="hidden" name="parentid" value="'.$parentid.'" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", $category["name"], 30, 50);
    print_submit_row();
    print_table_footer();
    return $catid;
  }

  if ($_REQUEST['action'] == 'update')
  {
    UpdateCategory($catid);
  }

  if ($_REQUEST['action'] == 'delete')
  {
      DeleteCategory($catid);
  }

  if ($_REQUEST['action'] == 'updateorder')
  {
      UpdateCategoriesOrder($catid);
  }

    print_form_header("microsupport_admin", "categories", true);
    if($catid==0)
    {
	   print_table_header("". $vbphrase['microsupport_admin_top_categories'] . "", 3);
    } else {
       $category = $db->query_first("SELECT name FROM ". TABLE_PREFIX ."microsupport_categories WHERE id=$catid");
	   print_table_header("". $vbphrase['microsupport_admin_sub_categories'] ."&nbsp;". $category["name"] ."", 3);
    }
	print_cells_row(array("". $vbphrase['microsupport_admin_category'] . "", "". $vbphrase['microsupport_admin_order'] . "", "". $vbphrase['microsupport_admin_action'] . ""), 1, 'tcat');

    $categories = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microsupport_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
    while($category = $db->fetch_array($categories)) {
          $cell[0] = $category["name"];
		  $cell[1] = '<input type="text" class="bginput" size="3" name="display['.$category["id"].']" value="'.$category["displayorder"].'">';
          $cell[2] = '<select class="bginput" name="action" onChange="actionCategory(this, '.$category["id"].')">
                      <option value="0">'. $vbphrase['microsupport_admin_select'] . '</option>
                      <option value="1">'. $vbphrase['microsupport_admin_sub_categories'] .'</option>
                      <option value="2">'. $vbphrase['microsupport_admin_edit'] .'</option>
                      <option value="3">'. $vbphrase['microsupport_admin_remove'] .'</option>
                      </select>';
 		  print_cells_row($cell);
    }
	echo '<input type="hidden" name="action" value="updateorder" />';
    echo '<input type="hidden" name="catid" value="'.$catid.'" />';
	print_table_footer(3, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['microsupport_admin_save_display_order'] . "\" accesskey=\"s\" />" . construct_button_code($vbphrase['microsupport_admin_new_category'], "microsupport_admin.php?do=categories&action=insert&catid=$catid"));
}
//////////////////// Departments ///////////////////////////////////////////////
if ($_REQUEST['do'] == 'departments') {

  $vbulletin->input->clean_array_gpc('r', array(
		'departmentid'		=> TYPE_UINT,
		'action'			=> TYPE_STR
  ));

  if ($_REQUEST['action'] == 'insert')
  {
    print_form_header('microsupport_admin', 'departments', true);
    print_table_header("". $vbphrase['microsupport_admin_new_department'] . "", 2);

    echo '<input type="hidden" name="action" value="save" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", "", 30, 50);
    print_submit_row();
    print_table_footer();
    return $departmentid;
  }

  if ($_REQUEST['action'] == 'save')
  {
      SaveDepartment($departmentid);
  }

  if ($_REQUEST['action'] == 'edit')
  {
    $departmentid = $vbulletin->input->clean_gpc('r', 'departmentid', TYPE_UINT);
    print_form_header('microsupport_admin', 'departments', true);
 	print_table_header("". $vbphrase['microsupport_admin_edit_department'] . "", 2);
    $department = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microsupport_departments WHERE id=$departmentid");
	echo '<input type="hidden" name="action" value="update" />';
	echo '<input type="hidden" name="departmentid" value="'.$departmentid.'" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", $department["name"], 30, 50);
    print_submit_row();
    print_table_footer();
    return $departmentid;
  }

  if ($_REQUEST['action'] == 'update')
  {
    UpdateDepartment($departmentid);
  }

  if ($_REQUEST['action'] == 'delete')
  {
      $departmentid = $vbulletin->input->clean_gpc('r', 'departmentid', TYPE_UINT);
      DeleteDepartment($departmentid);
  }

  if ($_REQUEST['action'] == 'updateorder')
  {
      UpdateDepartmentOrder($departmentid);
  }

    print_form_header("microsupport_admin", "departments", true);
    print_table_header("". $vbphrase['microsupport_admin_departments'] . "", 3);
	print_cells_row(array("". $vbphrase['microsupport_admin_name'] . "", "". $vbphrase['microsupport_admin_order'] . "", "". $vbphrase['microsupport_admin_action'] . ""), 1, 'tcat');

    $departments = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microsupport_departments ORDER BY displayorder ASC, name ASC");
    while($department = $db->fetch_array($departments)) {
          $cell[0] = $department["name"];
		  $cell[1] = '<input type="text" class="bginput" size="3" name="display['.$department["id"].']" value="'.$department["displayorder"].'">';
          $cell[2] = '<select class="bginput" name="action" onChange="actionDepartment(this, '.$department["id"].')">
                      <option value="0">'. $vbphrase['microsupport_admin_select'] .'</option>
                      <option value="1">'. $vbphrase['microsupport_admin_edit'] .'</option>
                      <option value="2">'. $vbphrase['microsupport_admin_remove'] .'</option>
                      </select>';
 		  print_cells_row($cell);
    }
	echo '<input type="hidden" name="action" value="updateorder" />';
    echo '<input type="hidden" name="departmentid" value="'.$departmentid.'" />';
	print_table_footer(3, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['microsupport_admin_save_display_order'] . "\" accesskey=\"s\" />" . construct_button_code($vbphrase['microsupport_admin_new_department'], "microsupport_admin.php?do=departments&action=insert"));
}
///////////////////////////// Supported Products ///////////////////////////////
if ($_REQUEST['do'] == 'products') {

  $vbulletin->input->clean_array_gpc('r', array(
		'productid'		=> TYPE_UINT,
		'action'			=> TYPE_STR
  ));

  if ($_REQUEST['action'] == 'insert')
  {
    print_form_header('microsupport_admin', 'products', true);
    print_table_header("". $vbphrase['microsupport_admin_new_product'] . "", 2);

    echo '<input type="hidden" name="action" value="save" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", "", 30, 50);
    print_submit_row();
    print_table_footer();
    return $productid;
  }

  if ($_REQUEST['action'] == 'save')
  {
      SaveProduct($productid);
  }

  if ($_REQUEST['action'] == 'edit')
  {
    $productid = $vbulletin->input->clean_gpc('r', 'productid', TYPE_UINT);
    print_form_header('microsupport_admin', 'products', true);
 	print_table_header("". $vbphrase['microsupport_admin_edit_product'] . "", 2);
    $product = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microsupport_products WHERE id=$productid");
	echo '<input type="hidden" name="action" value="update" />';
	echo '<input type="hidden" name="productid" value="'.$productid.'" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", $product["name"], 30, 50);
    print_submit_row();
    print_table_footer();
    return $productid;
  }

  if ($_REQUEST['action'] == 'update')
  {
    UpdateProduct($productid);
  }

  if ($_REQUEST['action'] == 'delete')
  {
      $productid = $vbulletin->input->clean_gpc('r', 'productid', TYPE_UINT);
      DeleteProduct($productid);
  }

  if ($_REQUEST['action'] == 'updateorder')
  {
      UpdateProductOrder($productid);
  }

    print_form_header("microsupport_admin", "products", true);
    print_table_header("". $vbphrase['microsupport_admin_products'] . "", 3);
	print_cells_row(array("". $vbphrase['microsupport_admin_name'] . "", "". $vbphrase['microsupport_admin_order'] . "", "". $vbphrase['microsupport_admin_action'] . ""), 1, 'tcat');

    $products = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microsupport_products ORDER BY displayorder ASC, name ASC");
    while($product = $db->fetch_array($products)) {
          $cell[0] = $product["name"];
		  $cell[1] = '<input type="text" class="bginput" size="3" name="display['.$product["id"].']" value="'.$product["displayorder"].'">';
          $cell[2] = '<select class="bginput" name="action" onChange="actionProduct(this, '.$product["id"].')">
                      <option value="0">'. $vbphrase['microsupport_admin_select'] .'</option>
                      <option value="1">'. $vbphrase['microsupport_admin_edit'] .'</option>
                      <option value="2">'. $vbphrase['microsupport_admin_remove'] .'</option>
                      </select>';
 		  print_cells_row($cell);
    }
	echo '<input type="hidden" name="action" value="updateorder" />';
    echo '<input type="hidden" name="productid" value="'.$productid.'" />';
	print_table_footer(3, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['microsupport_admin_save_display_order'] . "\" accesskey=\"s\" />" . construct_button_code($vbphrase['microsupport_admin_new_product'], "microsupport_admin.php?do=products&action=insert"));
}
////////////////////////////// Ticket Status ///////////////////////////////////
if ($_REQUEST['do'] == 'statuses') {

  $vbulletin->input->clean_array_gpc('r', array(
		'statusid'		=> TYPE_UINT,
		'action'			=> TYPE_STR
  ));

  if ($_REQUEST['action'] == 'insert')
  {
    print_form_header('microsupport_admin', 'statuses', true);
    print_table_header("". $vbphrase['microsupport_admin_new_status'] . "", 2);

    echo '<input type="hidden" name="action" value="save" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", "", 30, 50);
    print_submit_row();
    print_table_footer();
    return $statusid;
  }

  if ($_REQUEST['action'] == 'save')
  {
      SaveStatus($statusid);
  }

  if ($_REQUEST['action'] == 'edit')
  {
    $statusid = $vbulletin->input->clean_gpc('r', 'statusid', TYPE_UINT);
    print_form_header('microsupport_admin', 'statuses', true);
 	print_table_header("". $vbphrase['microsupport_admin_edit_status'] . "", 2);
    $status = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microsupport_ticket_status WHERE id=$statusid");
	echo '<input type="hidden" name="action" value="update" />';
	echo '<input type="hidden" name="statusid" value="'.$statusid.'" />';
    print_input_row("". $vbphrase['microsupport_admin_name'] . "", "name", $status["name"], 30, 50);
    print_submit_row();
    print_table_footer();
    return $statusid;
  }

  if ($_REQUEST['action'] == 'update')
  {
    UpdateStatus($statusid);
  }

  if ($_REQUEST['action'] == 'updateorder')
  {
      UpdateStatusOrder($statusid);
  }

    print_form_header("microsupport_admin", "statuses", true);
    print_table_header("". $vbphrase['microsupport_admin_statuses'] . "", 3);
	print_cells_row(array("". $vbphrase['microsupport_admin_name'] . "", "". $vbphrase['microsupport_admin_order'] . "", "". $vbphrase['microsupport_admin_action'] . ""), 1, 'tcat');

    $statuses = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microsupport_ticket_status ORDER BY displayorder ASC, name ASC");
    while($status = $db->fetch_array($statuses)) {
          $cell[0] = $status["name"];
		  $cell[1] = '<input type="text" class="bginput" size="3" name="display['.$status["id"].']" value="'.$status["displayorder"].'">';
          $cell[2] = '<select class="bginput" name="action" onChange="actionStatus(this, '.$status["id"].')">
                      <option value="0">'. $vbphrase['microsupport_admin_select'] .'</option>
                      <option value="1">'. $vbphrase['microsupport_admin_edit'] .'</option>
                      </select>';
 		  print_cells_row($cell);
    }
	echo '<input type="hidden" name="action" value="updateorder" />';
    echo '<input type="hidden" name="statusid" value="'.$statusid.'" />';
	print_table_footer(3, "<input type=\"submit\" class=\"button\" tabindex=\"1\" value=\"" . $vbphrase['microsupport_admin_save_display_order'] . "\" accesskey=\"s\" />");
}
print_cp_footer();
?>
