<?php
/////////////////////// Categories /////////////////////////////////////////////
// Save New Category
function SaveCategory($catid)
{
    global $db, $vbulletin, $catid;
    // Let's clean inputs
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("INSERT INTO ". TABLE_PREFIX ."microsupport_categories
                      SET name='$name',
                          displayorder='0',
                          parentid='$catid'");
    $newid = $db->insert_id();

    return $catid;
}
// Remove Category and Subcategories
function DeleteCategory($catid)
{
  global $db, $vbulletin, $catid;
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microsupport_categories WHERE id=$catid");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getChildId($deletedId, $catid);
  $idList = "'". implode("','", $deletedId)."'";
  $db->query_write("DELETE FROM ". TABLE_PREFIX ."microsupport_categories WHERE id IN ($idList)");
  // Go back
  $catid = $parentid;
  return $catid;
}
// Get Subcategories
function _getChildId(&$outArray, $parentId) {
	global $db, $vbulletin, $catid;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."microsupport_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getChildId($outArray, $category['id']);
	}
}
// Update Category
function UpdateCategory($catid)
{
    global $db, $vbulletin, $catid;
    $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $parentid = $vbulletin->input->clean_gpc('r', 'parentid', TYPE_UINT);
    $db->query_write("UPDATE ". TABLE_PREFIX ."microsupport_categories
                      SET name='$name' WHERE id=$catid");
    // Go Back
    $catid = $parentid;
    return $catid;
}
// Update display order for Categories
function UpdateCategoriesOrder($catid)
{
  global $db, $vbulletin, $catid;
  $display = $_REQUEST["display"];
  $keys = array_keys($display);
  foreach($keys as $idx) {
  $order = $display[$idx];
  $db->query_write("UPDATE ".TABLE_PREFIX."microsupport_categories SET displayorder=$order WHERE id=$idx");
  }
  $catid = $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
  return $catid;
}
//////////////////////// Departments ///////////////////////////////////////////
// Insert Department Category
function SaveDepartment($departmentid)
{
    global $db, $vbulletin, $departmentid;
    // Let's clean inputs
    $departmentid = $vbulletin->input->clean_gpc('r', 'departmentid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("INSERT INTO ". TABLE_PREFIX ."microsupport_departments
                      SET name='$name',
                          displayorder='0'");
    $newid = $db->insert_id();
    return $departmentid;
}
// Remove Department Category
function DeleteDepartment($departmentid)
{
  global $db, $vbulletin, $departmentid;
  $db->query_write("DELETE FROM ". TABLE_PREFIX ."microsupport_departments WHERE id=$departmentid");
  return $departmentid;
}
// Update Department Category
function UpdateDepartment($departmentid)
{
    global $db, $vbulletin, $departmentid;
    $departmentid = $vbulletin->input->clean_gpc('r', 'departmentid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("UPDATE ". TABLE_PREFIX ."microsupport_departments
                      SET name='$name' WHERE id=$departmentid");
    return $departmentid;
}
// Update display order for Departments
function UpdateDepartmentOrder()
{
  global $db, $vbulletin;
  $display = $_REQUEST["display"];
  $keys = array_keys($display);
  foreach($keys as $idx) {
    $order = $display[$idx];
    $db->query_write("UPDATE ".TABLE_PREFIX."microsupport_departments SET displayorder=$order WHERE id=$idx");
  }
  return;
}
//////////////////////////// Supported Products ////////////////////////////////
// Insert Product Category
function SaveProduct($productid)
{
    global $db, $vbulletin, $productid;
    // Let's clean inputs
    $productid = $vbulletin->input->clean_gpc('r', 'productid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("INSERT INTO ". TABLE_PREFIX ."microsupport_products
                      SET name='$name',
                          displayorder='0'");
    $newid = $db->insert_id();
    return $productid;
}
// Remove Product Category
function DeleteProduct($productid)
{
  global $db, $vbulletin, $productid;
  $db->query_write("DELETE FROM ". TABLE_PREFIX ."microsupport_products WHERE id=$productid");
  return $productid;
}
// Update Product Category
function UpdateProduct($productid)
{
    global $db, $vbulletin, $productid;
    $productid = $vbulletin->input->clean_gpc('r', 'productid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("UPDATE ". TABLE_PREFIX ."microsupport_products
                      SET name='$name' WHERE id=$productid");
    return $productid;
}
// Update display order for Products
function UpdateProductOrder()
{
  global $db, $vbulletin;
  $display = $_REQUEST["display"];
  $keys = array_keys($display);
  foreach($keys as $idx) {
    $order = $display[$idx];
    $db->query_write("UPDATE ".TABLE_PREFIX."microsupport_products SET displayorder=$order WHERE id=$idx");
  }
  return;
}
///////////////////////////// Ticket Status ////////////////////////////////////
// Insert Status Category
function SaveStatus($statusid)
{
    global $db, $vbulletin, $statusid;
    // Let's clean inputs
    $statusid = $vbulletin->input->clean_gpc('r', 'statusid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("INSERT INTO ". TABLE_PREFIX ."microsupport_ticket_status
                      SET name='$name',
                          displayorder='0'");
    $newid = $db->insert_id();
    return $statusid;
}
// Remove Status Category
function DeleteStatus($statusid)
{
  global $db, $vbulletin, $statusid;
  $db->query_write("DELETE FROM ". TABLE_PREFIX ."microsupport_ticket_status WHERE id=$statusid");
  return $statusid;
}
// Update Status Category
function UpdateStatus($statusid)
{
    global $db, $vbulletin, $statusid;
    $statusid = $vbulletin->input->clean_gpc('r', 'statusid', TYPE_UINT);
    $name = $vbulletin->input->clean_gpc('r', 'name', TYPE_STR);
    $db->query_write("UPDATE ". TABLE_PREFIX ."microsupport_ticket_status
                      SET name='$name' WHERE id=$statusid");
    return $statusid;
}
// Update display order for Statuses
function UpdateStatusOrder()
{
  global $db, $vbulletin;
  $display = $_REQUEST["display"];
  $keys = array_keys($display);
  foreach($keys as $idx) {
    $order = $display[$idx];
    $db->query_write("UPDATE ".TABLE_PREFIX."microsupport_ticket_status SET displayorder=$order WHERE id=$idx");
  }
  return;
}
// Get Categories
function getCategories($catid)
{
  global $db, $vbphrase, $html, $catid;
  $categories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  $html = '';
  if($db->num_rows($categories) != 0) {
     $html = '<table width="100%">';
     while($category = $db->fetch_array($categories)) {
           $id = $category["id"];
           $name = $category["name"];
           $title = sanitize_title($category["name"]);
           $html .= '<tr><td><div class="smallfont"><strong>&raquo;&nbsp;';
           $html .= '<a href=support.php?'.$vbulletin->session->vars['sessionurl'].'do=main&catid='.$category["id"].'&title='.$title.'>'.$category["name"].'</a>';
    	   $html .= '</strong></div></td></tr>';
     }
     $html .= '</table>';
  }
  return $html;
}
// Get Categories for Horizontal Block
function getHorizontalCategories($catid,$blocks)
{
  global $db, $vbphrase, $catid, $horizontalcategories, $horizontalcategoriesbit, $faqs;
  $blockwidth = 100 / $blocks;
  $blockwidth = $blockwidth.'%';
  $total_hcategories = 0;
  $activecategory = 0;
  $hcategories = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_categories WHERE parentid=$catid ORDER BY displayorder ASC, name ASC");
  while($hcategory = $db->fetch_array($hcategories)) {
        $activecategory = $hcategory["id"];
        $total_faq = getCountRecords($activecategory);
        $total_hcategories ++;
        if($total_hcategories == $blocks)
        {
           $total_hcategories = 0;
           $changeline = 1;
        } else {
           $changeline = 0;
        }
  		$templater = vB_Template::create('microsupport_horizontal_categories_bit');
  		$templater->register('blockwidth', $blockwidth);
        $templater->register('changeline', $changeline);
  		$templater->register('hcategoryid', $hcategory[id]);
  		$templater->register('hcategoryname', $hcategory[name]);
        $templater->register('totalfaq', $total_faq);
  		$horizontalcategoriesbit .= $templater->render();
  }
  $templater = vB_Template::create('microsupport_horizontal_categories');
  $templater->register('horizontalcategoriesbit', $horizontalcategoriesbit);
  $horizontalcategories .= $templater->render();
  return;
}


function getCountRecords($activecategory)
{
  global $db, $vbulletin, $catid, $totalitems;
  $totalitems = 0;
  $get_records = '';
  $category = $db->query_first("SELECT * FROM ". TABLE_PREFIX ."microsupport_categories WHERE id='$activecategory' LIMIT 1");
  $parentid = $category["parentid"];
  // Remove subcategories too
  $deletedId = array();
  _getCountChild($deletedId, $activecategory);
  $idList = "'". implode("','", $deletedId)."'";
  $get_records = $db->query_read("SELECT * FROM ". TABLE_PREFIX ."microsupport_faq WHERE categoryid IN ($idList)");
  $totalitems = $db->num_rows($get_records);
  // Go back
  $activecategory = $parentid;
  return $totalitems;
}

function _getCountChild(&$outArray, $parentId) {
	global $db, $vbulletin, $activecategory;
	if($parentId > 0)
		$outArray[] = $parentId;
	$subcategories = $db->query_read("SELECT id FROM ". TABLE_PREFIX ."microsupport_categories WHERE parentid=".$parentId."");
	if(!$subcategories)
    {
		return;
    }
	while($category = $db->fetch_array($subcategories)) {
			_getCountChild($outArray, $category['id']);
	}
}


// Get Questions
function getQuestions($catid)
{
  global $db, $vbphrase, $catid, $browsequestions;
  $questions = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_faq WHERE categoryid=$catid ORDER BY id DESC");
  while($question = $db->fetch_array($questions)) {
					$templater = vB_Template::create('microsupport_browse_questions');
					$templater->register('vcategoryid', $vcategory[id]);
					$templater->register('vcategoryname', $vcategory[name]);
					$browsequestions .= $templater->render();
        eval('$browsequestions .= "' . fetch_template('microsupport_browse_questions') . '";');
  }
  return;
}
// Get Support Custom NavBar
function getMyNavBar(&$output, $catid) {
	global $db, $vbulletin, $output, $url;
	if($catid < 0) {
		$output = '';
		return $output;
	}
    $arrow_icon = '<img border="0" src="microsupport/images/navbit-arrow.png">';
	$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_categories WHERE id = $catid");
	$row = $db->fetch_array($qry);
	$url = 'support.php?do=main&catid='.$row['id'];
	if(trim($output) == '')
    {
		$output = '<a href="'.$url.'">'.$row['name'].'</a>';
	} else {
		$output = '<a href="'.$url.'">'.$row['name'].'</a>&nbsp;&nbsp;'.$arrow_icon.'&nbsp;&nbsp;'.$output;
    }
	//- still have parents?
	if($row['parentid'] != 0) {
		getMyNavBar($output, $row['parentid']);
	} else {
		$output = $output;
	}
    return $output;
}

// Get Important FAQs
function getImportants($catid)
{
    global $db, $vbulletin, $importantquestions, $importantquestionsbit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    $maximum = $vbulletin->options["microsupport_limit"];
    $importants = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_faq WHERE categoryid=$catid AND important=1 ORDER BY id DESC LIMIT $maximum");
    $total_importants = $db->num_rows($importants);
    if($total_importants == 0)
    {
       $importants = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_faq WHERE important=1 ORDER BY id DESC LIMIT $maximum");
    }
    while($important = $db->fetch_array($importants)) {
 		  $templater = vB_Template::create('microsupport_important_questions_bit');
		  $templater->register('importantid', $important[id]);
		  $templater->register('question', $important[question]);
		  $importantquestionsbit .= $templater->render();
    }
	$templater = vB_Template::create('microsupport_important_questions');
	$templater->register('importantquestionsbit', $importantquestionsbit);
	$importantquestions .= $templater->render();
    return;
}

// Get Latest FAQs
function getLatest($catid)
{
    global $db, $vbulletin, $latestquestions, $latestquestionsbit, $catid;

    if (empty($catid))
    {
        $catid = 0;
    }
    $maximum = $vbulletin->options["microsupport_limit"];
    $latests = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_faq WHERE categoryid=$catid ORDER BY id DESC LIMIT $maximum");
    $total_latests = $db->num_rows($latests);
    if($total_latests == 0)
    {
       $latests = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_faq ORDER BY id DESC LIMIT $maximum");
    }
    while($latest = $db->fetch_array($latests)) {
		  $templater = vB_Template::create('microsupport_latest_questions_bit');
		  $templater->register('latestid', $latest[id]);
		  $templater->register('latestquestion', $latest[question]);
		  $latestquestionsbit .= $templater->render();
    }
	$templater = vB_Template::create('microsupport_latest_questions');
	$templater->register('latestquestionsbit', $latestquestionsbit);
	$latestquestions .= $templater->render();
    return;
}


// Get record by Id
function getRecordById($tablename, $id, $rowname = 'id')
{
  global $db, $vbulletin;
  $result = $db->query_read("SELECT * FROM ".TABLE_PREFIX."".$tablename." WHERE ".$rowname."=".$id." LIMIT 1");
  if(!$result) return array ("id" => 0, "name" => '');
  if(mysql_num_rows($result) == 0) return array ("id" => 0, "name" => '');
  $ret = array();
  while($row = mysql_fetch_assoc($result)) {
    $ret = $row;
  }
  mysql_free_result($result);
  return $ret;
}
// Calculate response time
function getResponseTime()
{
  global $db, $vbulletin, $vbphrase, $h_avg, $m_avg;
  $result = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE created<>updated ORDER BY id DESC LIMIT 30");
  $tnum = $db->num_rows($result);
  if($tnum>0)
  {
     $i=0;
     $seconds = 0;
     while ($r = $db->fetch_array($result)){
            $q = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_ticket_replies WHERE ticketid='". $r[id] ."' ORDER BY created ASC LIMIT 1");
            $qnum = $db->fetch_array($q);
            $updated = $qnum['created'];
            $created = $r['created'];
            $seconds += ($updated - $created);
            $i++;
     }
     if($i>0)
     {
        $avg = $seconds / $i;
        $h_avg = round($avg/3600);
        $resttime = $avg - ($h_avg*3600);
        $m_avg = round($resttime/60);
     } else {
        $h_avg = 0;
        $m_avg = 0;
     }
  } else {
     $h_avg = 0;
     $m_avg = 0;
  }

  return;
}
// get Departments
function getDepartments($departmentid)
{
  global $db, $vbulletin, $vbphrase;
  $departments = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_departments ORDER BY displayorder ASC, name ASC");
  while ($department = $db->fetch_array($departments)) {
         // Set Option Values
	     $option = $department['name'];
	     $optionid = $department['id'];
         // Make Option Selected If Needed
		 unset ($optionselected);
		 if ($department['id'] == $originid){
             $optionselected = " selected=selected";
		 }
         // Create List
        $departmentoptions .= '<option value="' . $optionid . '"' . $optionselected . '>' . $option . '</option>';
  }
  return $departmentoptions;
}
// Get Products
function getProducts($productid)
{
  global $db, $vbulletin, $vbphrase;
  $products = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_products ORDER BY displayorder ASC, name ASC");
  while ($product = $db->fetch_array($products)) {
         // Set Option Values
	     $option = $product['name'];
	     $optionid = $product['id'];
         // Make Option Selected If Needed
		 unset ($optionselected);
		 if ($product['id'] == $originid){
             $optionselected = " selected=selected";
		 }
         // Create List
        $productoptions .= '<option value="' . $optionid . '"' . $optionselected . '>' . $option . '</option>';
  }
  return $productoptions;
}
// Search Departments
function getSearchDepartments()
{
  global $db, $vbulletin, $vbphrase;
  $departments = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_departments ORDER BY displayorder ASC, name ASC");
  $departmentoptions = '<option value=0 selected=selected>'.$vbphrase["microsupport_all"].'</option>';
  while ($department = $db->fetch_array($departments)) {
         // Set Option Values
	     $option = $department['name'];
	     $optionid = $department['id'];
         // Create List
         $departmentoptions .= '<option value="' . $optionid . '">' . $option . '</option>';
  }
  return $departmentoptions;
}
// Search products
function getSearchProducts()
{
  global $db, $vbulletin, $vbphrase;
  $products = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_products ORDER BY displayorder ASC, name ASC");
  $productoptions = '<option value=0 selected=selected>'.$vbphrase["microsupport_all"].'</option>';
  while ($product = $db->fetch_array($products)) {
         // Set Option Values
	     $option = $product['name'];
	     $optionid = $product['id'];
         // Create List
         $productoptions .= '<option value="' . $optionid . '">' . $option . '</option>';
  }
  return $productoptions;
}
// Search Status
function getSearchStatus()
{
  global $db, $vbulletin, $vbphrase;
  $statuses = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_ticket_status ORDER BY displayorder ASC, name ASC");
  $statusoptions = '<option value=0 selected=selected>'.$vbphrase["microsupport_all"].'</option>';
  while ($status = $db->fetch_array($statuses)) {
         // Set Option Values
	     $option = $status['name'];
	     $optionid = $status['id'];
         // Create List
         $statusoptions .= '<option value="' . $optionid . '">' . $option . '</option>';
  }
  return $statusoptions;
}
// Count Replies
function getCountReplies($ticketid)
{
    global $db, $vbulletin, $vbphrase;
    $total_replies = 0;
    $count_replies = $db->query_read("
                     SELECT * FROM " . TABLE_PREFIX . "microsupport_ticket_replies
                     WHERE ticketid=$ticketid
                     ");
    $total_replies = $db->num_rows($count_replies);
    return $total_replies;
}
// Class for multilevel categories
class SelectCategory {
	var $Name;
	var $SelectedId;
	var $IsMultiple;
	var $MultipleSize;
	var $ClassName;
	var $Id;
	var $Style;
	var $RootId;
	var $output;
	var $srcTable;
	var $firstOption;
	var $attributes;
	function SelectCategory($name, $table) {
		$this->Name = $name;
		$this->SelectedId = '';
		$this->IsMultiple = false;
		$this->MultipleSize = 5;
		$this->FirstOption = array('value' => '', 'text' => '');
		$this->ClassName = '' ;
		$this->Id = '';
		$this->Style = '';
		$this->RootId = 0;
		$this->output = '';
		$this->srcTable = $table;
	}
	function Output() {
		$options = '';
		$this->_getCategory($options, $this->RootId);
		$attributes = $this->_getAttributes();
		$output = '<select '.$attributes.'>'.$options.'</select>';
		return $output;
	}
	function SetFirstOption($text, $value) {
		$this->firstOption = array('value' => '', 'text' => '');
		$this->firstOption['value']	= $value;
		$this->firstOption['text'] = $text;
	}
	function SetMultiple($status, $rows) {
		$this->IsMultiple = $status;
		$this->MultipleSize = $rows;
	}
    function SetStyle($value)
    {
        $this->Style = $value;
    }
	function SetSelected($catid) {
		$this->SelectedId = $catid;
	}
	function _getAttributes() {
		$tmpAtt = array();
		$tmpAtt[] = 'name="'.$this->Name.'"';
		if($this->IsMultiple)
			$tmpAtt[] = 'multiple size="'.$this->MultipleSize.'"';
		if(trim($this->ClassName) != '')
			$tmpAtt[] = 'class="'.$this->ClassName.'"';
		if(trim($this->Style) != '')
			$tmpAtt[] = 'style="'.$this->Style.'"';
		if(count($tmpAtt) > 0)
        {
			$return = implode(', ', $tmpAtt);
		} else {
			$return = '';
        }
		return $return;
	}
	function _getCategory(&$options, $rootId, $level = 0) {
    global $db, $vbulletin, $catid;
		if(is_array($this->firstOption) && trim($options) == '') {
			$options .= '<option value="'.$this->firstOption['value'].'">'.
						$this->firstOption['text'].'</option>';
		}
		$qry = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_categories WHERE parentid=$rootId ORDER BY displayorder ASC, name ASC");
			while($row = $db->fetch_array($qry)) {
              if(is_array($this->SelectedId))
              {
				if(in_array($row['id'],$this->SelectedId))
                {
					$selected = ' selected';
				} else {
					$selected = '';
                }
              } else {
        		if($row['id'] == $this->SelectedId)
                {
            	    $selected = ' selected';
				} else {
					$selected = '';
                }
              }
				$options .= '<option value="'.$row['id'].'" '.$selected.'>'.str_repeat('&nbsp;', $level*4).'- '.$row['name']."</option>\n";
				$this->_getCategory($options, $row['id'], $level+1);
			}
	}
}
// Parse vB Code
function parseBbCode($bbcode, $limit = 0)
{
  global $vbulletin;
  require_once(DIR . '/includes/class_bbcode.php');
  $parser =& new vB_BbCodeParser($vbulletin, fetch_tag_list());
  $text = $parser->do_parse($bbcode);
  if($limit != 0) {
  	if(strlen($text) > $limit)
  		$text = substr($text, 0, $limit).' ...';
  	}
    return $text;
}
// Function to get the extension a file.
function get_ext($key) {
	$key=strtolower(substr(strrchr($key, "."), 1));
	// Cause there the same right?
	$key=str_replace("jpeg","jpg",$key);
	return $key;
}
// File extention
function fileExtension($filename)
{
  $path_info = pathinfo($filename);
  return $path_info['extension'];
}
// sanitize title
function sanitize_title($title) {
	$title = strip_tags($title);
	// Preserve escaped octets.
	$title = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '---$1---', $title);
	// Remove percent signs that are not part of an octet.
	$title = str_replace('%', '', $title);
	// Restore octets.
	$title = preg_replace('|---([a-fA-F0-9][a-fA-F0-9])---|', '%$1', $title);
	$title = remove_accents($title);
	if (seems_utf8($title)) {
		if (function_exists('mb_strtolower')) {
			$title = mb_strtolower($title, 'UTF-8');
		}
		$title = utf8_uri_encode($title);
	}
	$title = strtolower($title);
    $title = preg_replace('/&.+?;/', '', $title); // kill entities
	$title = preg_replace('/[^%a-z0-9 _-]/', '', $title);
	$title = preg_replace('/\s+/', '-', $title);
	$title = preg_replace('|-+|', '-', $title);
	$title = trim($title, '-');
	return $title;
}
// remove accents
function remove_accents($string) {
	if (seems_utf8($string)) {
		$chars = array(
		// Decompositions for Latin-1 Supplement
		chr(195).chr(128) => 'A', chr(195).chr(129) => 'A',
		chr(195).chr(130) => 'A', chr(195).chr(131) => 'A',
		chr(195).chr(132) => 'A', chr(195).chr(133) => 'A',
		chr(195).chr(135) => 'C', chr(195).chr(136) => 'E',
		chr(195).chr(137) => 'E', chr(195).chr(138) => 'E',
		chr(195).chr(139) => 'E', chr(195).chr(140) => 'I',
		chr(195).chr(141) => 'I', chr(195).chr(142) => 'I',
		chr(195).chr(143) => 'I', chr(195).chr(145) => 'N',
		chr(195).chr(146) => 'O', chr(195).chr(147) => 'O',
		chr(195).chr(148) => 'O', chr(195).chr(149) => 'O',
		chr(195).chr(150) => 'O', chr(195).chr(153) => 'U',
		chr(195).chr(154) => 'U', chr(195).chr(155) => 'U',
		chr(195).chr(156) => 'U', chr(195).chr(157) => 'Y',
		chr(195).chr(159) => 's', chr(195).chr(160) => 'a',
		chr(195).chr(161) => 'a', chr(195).chr(162) => 'a',
		chr(195).chr(163) => 'a', chr(195).chr(164) => 'a',
		chr(195).chr(165) => 'a', chr(195).chr(167) => 'c',
		chr(195).chr(168) => 'e', chr(195).chr(169) => 'e',
		chr(195).chr(170) => 'e', chr(195).chr(171) => 'e',
		chr(195).chr(172) => 'i', chr(195).chr(173) => 'i',
		chr(195).chr(174) => 'i', chr(195).chr(175) => 'i',
		chr(195).chr(177) => 'n', chr(195).chr(178) => 'o',
		chr(195).chr(179) => 'o', chr(195).chr(180) => 'o',
		chr(195).chr(181) => 'o', chr(195).chr(182) => 'o',
		chr(195).chr(182) => 'o', chr(195).chr(185) => 'u',
		chr(195).chr(186) => 'u', chr(195).chr(187) => 'u',
		chr(195).chr(188) => 'u', chr(195).chr(189) => 'y',
		chr(195).chr(191) => 'y',
		// Decompositions for Latin Extended-A
		chr(196).chr(128) => 'A', chr(196).chr(129) => 'a',
		chr(196).chr(130) => 'A', chr(196).chr(131) => 'a',
		chr(196).chr(132) => 'A', chr(196).chr(133) => 'a',
		chr(196).chr(134) => 'C', chr(196).chr(135) => 'c',
		chr(196).chr(136) => 'C', chr(196).chr(137) => 'c',
		chr(196).chr(138) => 'C', chr(196).chr(139) => 'c',
		chr(196).chr(140) => 'C', chr(196).chr(141) => 'c',
		chr(196).chr(142) => 'D', chr(196).chr(143) => 'd',
		chr(196).chr(144) => 'D', chr(196).chr(145) => 'd',
		chr(196).chr(146) => 'E', chr(196).chr(147) => 'e',
		chr(196).chr(148) => 'E', chr(196).chr(149) => 'e',
		chr(196).chr(150) => 'E', chr(196).chr(151) => 'e',
		chr(196).chr(152) => 'E', chr(196).chr(153) => 'e',
		chr(196).chr(154) => 'E', chr(196).chr(155) => 'e',
		chr(196).chr(156) => 'G', chr(196).chr(157) => 'g',
		chr(196).chr(158) => 'G', chr(196).chr(159) => 'g',
		chr(196).chr(160) => 'G', chr(196).chr(161) => 'g',
		chr(196).chr(162) => 'G', chr(196).chr(163) => 'g',
		chr(196).chr(164) => 'H', chr(196).chr(165) => 'h',
		chr(196).chr(166) => 'H', chr(196).chr(167) => 'h',
		chr(196).chr(168) => 'I', chr(196).chr(169) => 'i',
		chr(196).chr(170) => 'I', chr(196).chr(171) => 'i',
		chr(196).chr(172) => 'I', chr(196).chr(173) => 'i',
		chr(196).chr(174) => 'I', chr(196).chr(175) => 'i',
		chr(196).chr(176) => 'I', chr(196).chr(177) => 'i',
		chr(196).chr(178) => 'IJ',chr(196).chr(179) => 'ij',
		chr(196).chr(180) => 'J', chr(196).chr(181) => 'j',
		chr(196).chr(182) => 'K', chr(196).chr(183) => 'k',
		chr(196).chr(184) => 'k', chr(196).chr(185) => 'L',
		chr(196).chr(186) => 'l', chr(196).chr(187) => 'L',
		chr(196).chr(188) => 'l', chr(196).chr(189) => 'L',
		chr(196).chr(190) => 'l', chr(196).chr(191) => 'L',
		chr(197).chr(128) => 'l', chr(197).chr(129) => 'L',
		chr(197).chr(130) => 'l', chr(197).chr(131) => 'N',
		chr(197).chr(132) => 'n', chr(197).chr(133) => 'N',
		chr(197).chr(134) => 'n', chr(197).chr(135) => 'N',
		chr(197).chr(136) => 'n', chr(197).chr(137) => 'N',
		chr(197).chr(138) => 'n', chr(197).chr(139) => 'N',
		chr(197).chr(140) => 'O', chr(197).chr(141) => 'o',
		chr(197).chr(142) => 'O', chr(197).chr(143) => 'o',
		chr(197).chr(144) => 'O', chr(197).chr(145) => 'o',
		chr(197).chr(146) => 'OE',chr(197).chr(147) => 'oe',
		chr(197).chr(148) => 'R',chr(197).chr(149) => 'r',
		chr(197).chr(150) => 'R',chr(197).chr(151) => 'r',
		chr(197).chr(152) => 'R',chr(197).chr(153) => 'r',
		chr(197).chr(154) => 'S',chr(197).chr(155) => 's',
		chr(197).chr(156) => 'S',chr(197).chr(157) => 's',
		chr(197).chr(158) => 'S',chr(197).chr(159) => 's',
		chr(197).chr(160) => 'S', chr(197).chr(161) => 's',
		chr(197).chr(162) => 'T', chr(197).chr(163) => 't',
		chr(197).chr(164) => 'T', chr(197).chr(165) => 't',
		chr(197).chr(166) => 'T', chr(197).chr(167) => 't',
		chr(197).chr(168) => 'U', chr(197).chr(169) => 'u',
		chr(197).chr(170) => 'U', chr(197).chr(171) => 'u',
		chr(197).chr(172) => 'U', chr(197).chr(173) => 'u',
		chr(197).chr(174) => 'U', chr(197).chr(175) => 'u',
		chr(197).chr(176) => 'U', chr(197).chr(177) => 'u',
		chr(197).chr(178) => 'U', chr(197).chr(179) => 'u',
		chr(197).chr(180) => 'W', chr(197).chr(181) => 'w',
		chr(197).chr(182) => 'Y', chr(197).chr(183) => 'y',
		chr(197).chr(184) => 'Y', chr(197).chr(185) => 'Z',
		chr(197).chr(186) => 'z', chr(197).chr(187) => 'Z',
		chr(197).chr(188) => 'z', chr(197).chr(189) => 'Z',
		chr(197).chr(190) => 'z', chr(197).chr(191) => 's',
		// Euro Sign
		chr(226).chr(130).chr(172) => 'E');
		$string = strtr($string, $chars);
	} else {
		// Assume ISO-8859-1 if not UTF-8
		$chars['in'] = chr(128).chr(131).chr(138).chr(142).chr(154).chr(158)
			.chr(159).chr(162).chr(165).chr(181).chr(192).chr(193).chr(194)
			.chr(195).chr(196).chr(197).chr(199).chr(200).chr(201).chr(202)
			.chr(203).chr(204).chr(205).chr(206).chr(207).chr(209).chr(210)
			.chr(211).chr(212).chr(213).chr(214).chr(216).chr(217).chr(218)
			.chr(219).chr(220).chr(221).chr(224).chr(225).chr(226).chr(227)
			.chr(228).chr(229).chr(231).chr(232).chr(233).chr(234).chr(235)
			.chr(236).chr(237).chr(238).chr(239).chr(241).chr(242).chr(243)
			.chr(244).chr(245).chr(246).chr(248).chr(249).chr(250).chr(251)
			.chr(252).chr(253).chr(255);
		$chars['out'] = "EfSZszYcYuAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy";
		$string = strtr($string, $chars['in'], $chars['out']);
		$double_chars['in'] = array(chr(140), chr(156), chr(198), chr(208), chr(222), chr(223), chr(230), chr(240), chr(254));
		$double_chars['out'] = array('OE', 'oe', 'AE', 'DH', 'TH', 'ss', 'ae', 'dh', 'th');
		$string = str_replace($double_chars['in'], $double_chars['out'], $string);
	}
	return $string;
}
function seems_utf8($Str) { # by bmorel at ssi dot fr
	for ($i=0; $i<strlen($Str); $i++) {
		if (ord($Str[$i]) < 0x80) continue; # 0bbbbbbb
		elseif ((ord($Str[$i]) & 0xE0) == 0xC0) $n=1; # 110bbbbb
		elseif ((ord($Str[$i]) & 0xF0) == 0xE0) $n=2; # 1110bbbb
		elseif ((ord($Str[$i]) & 0xF8) == 0xF0) $n=3; # 11110bbb
		elseif ((ord($Str[$i]) & 0xFC) == 0xF8) $n=4; # 111110bb
		elseif ((ord($Str[$i]) & 0xFE) == 0xFC) $n=5; # 1111110b
		else return false; # Does not match any model
		for ($j=0; $j<$n; $j++) { # n bytes matching 10bbbbbb follow ?
			if ((++$i == strlen($Str)) || ((ord($Str[$i]) & 0xC0) != 0x80))
			return false;
		}
	}
	return true;
}
function utf8_uri_encode( $utf8_string ) {
  $unicode = '';
  $values = array();
  $num_octets = 1;
  for ($i = 0; $i < strlen( $utf8_string ); $i++ ) {
    $value = ord( $utf8_string[ $i ] );
    if ( $value < 128 ) {
      $unicode .= chr($value);
    } else {
      if ( count( $values ) == 0 ) $num_octets = ( $value < 224 ) ? 2 : 3;
      $values[] = $value;
      if ( count( $values ) == $num_octets ) {
      	if ($num_octets == 3) {
      	  $unicode .= '%' . dechex($values[0]) . '%' . dechex($values[1]) . '%' . dechex($values[2]);
      	} else {
      	  $unicode .= '%' . dechex($values[0]) . '%' . dechex($values[1]);
     	}
        $values = array();
        $num_octets = 1;
      }
    }
  }
  return $unicode;
}
?>
