<?php
// Setup PHP Enviropment
error_reporting(E_ALL & ~E_NOTICE);
// Define Contants
define('THIS_SCRIPT', 'support');
define('GET_EDIT_TEMPLATES', 'add,edit');
// Cache Templates & Variables
// get special phrase groups
$phrasegroups = array(
	'microsupport',
	'postbit',
	'posting'
);
$specialtemplates = array(
    'smiliecache',
	'bbcodecache',
	'attachmentcache',
);
$globaltemplates = array(
    'microsupport_main',
    'microsupport_addedit_question',
    'microsupport_view_question',
    'microsupport_browse_questions',
    'microsupport_browse_questions_bit',
    'microsupport_category_questions_bit',
    'microsupport_vertical_categories',
    'microsupport_vertical_categories_bit',
    'microsupport_horizontal_categories',
    'microsupport_horizontal_categories_bit',
    'microsupport_member_menu',
    'microsupport_tech_menu',
    'microsupport_reply_info',
    'microsupport_important_questions',
    'microsupport_important_questions_bit',
    'microsupport_latest_questions',
    'microsupport_latest_questions_bit',
    'microsupport_submit_ticket',
    'microsupport_browse_tickets',
    'microsupport_browse_tickets_bit',
    'microsupport_reply_ticket',
    'microsupport_browse_replies',
    'microsupport_browse_my_tickets',
    'microsupport_browse_my_tickets_bit',
    'microsupport_tabmenu',
	'bbcode_code',
	'bbcode_html',
	'bbcode_php',
	'bbcode_quote',
    'editor_toolbar_on'
);
$actiontemplates = array();
// Include Globals
require_once('./global.php');
require_once('./includes/functions_editor.php');
require_once('./includes/functions_wysiwyg.php');
require_once('./includes/functions_newpost.php');
require_once('./includes/functions_user.php');
require_once('./includes/class_bbcode.php');
require_once('./includes/class_image.php');
require_once('./includes/class_postbit.php');
require_once('./includes/functions_bigthree.php');
require_once('./microsupport/includes/functions.php');
require_once('./includes/class_bootstrap_framework.php');
vB_Bootstrap_Framework::init();

// Don't remove it, unless if you know what you're doing.
$copyright = "<div class='smallfont' align='center'><a target='_blank' href='http://www.microhellas.com/'><b>microSUPPORT<b></a> &copy;2009 by <a target='_blank' href='http://www.microhellas.com/'><b>Mary<b></a></div>";

// Main Script
if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['access'])){
    print_no_permission();
}
if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'main';
}
if ($_REQUEST['do'] == 'main'){
    $vbulletin->input->clean_gpc('r', 'catid', TYPE_UINT);
    if(!isset($_REQUEST['catid']))
    {
       $catid = 0;
    } else {
       $catid = $_REQUEST["catid"];
       // Get Category's name
       $category_get = getRecordById("microsupport_categories",$catid);
       $category = $category_get["name"];
    }
    // Custom Navbar
    $mynavbar = '';
    $mynavbar = getMyNavBar($mynavbar, $catid);
    $blocks = $vbulletin->options["microsupport_blocks"];
    $hcategories = getHorizontalCategories($catid,$blocks);
    $limit = $vbulletin->options["microsupport_limit"];
    // Get Important FAQ
    $faq_important = getImportants($catid);

    // Get Latest FAQ
    $faq_latest = getLatest($catid);
    if($catid != 0)
    {
       $totalquestions = 0;
       //$perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
       $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
       $totalrecords = $db->query_first("
                       SELECT COUNT(`id`) AS `totalrecords`
                       FROM `" . TABLE_PREFIX . "microsupport_faq`
                       WHERE categoryid=$catid
                       ");

	   $records = $totalrecords['totalrecords'];
       $perpage= $vbulletin->options['microsupport_perpage'];
       $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	   if(empty($pagenumber))
       {
          $pagenumber = 1;
       }
       $limitlower = ($pagenumber - 1) * $perpage+1;
       $limitupper = ($pagenumber) * $perpage;
       $counter = 0;
       if ($limitupper > $records)
	   {
		   $limitupper = $records;
           if ($limitlower > $records)
		   {
			   $limitlower = $records-$perpage;
		   }
	   }
	   if ($limitlower <= 0)
	   {
		   $limitlower = 1;
	   }
       $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'support.php?' . $vbulletin->session->vars['sessionurl'] . 'do=main&catid&='.$catid);
       $questions = $vbulletin->db->query_read("
	                        SELECT *
	                        FROM " . TABLE_PREFIX . "microsupport_faq
                            WHERE categoryid=$catid
	                        ORDER BY id DESC
                            LIMIT " . ($limitlower-1) . ", $perpage");
       // Build Question Bits
       while ($question = $vbulletin->db->fetch_array($questions)){
			  $templater = vB_Template::create('microsupport_category_questions_bit');
			  $templater->register('questionid', $question[id]);
			  $templater->register('questionquestion', $question[question]);
			  $categoryquestionsbit .= $templater->render();
       }
    }
    if($vbulletin->options["microsupport_average"]==1)
    {
       $averagetime = getResponseTime();
       $templater = vB_Template::create('microsupport_reply_info');
	   $templater->register('m_avg', $m_avg);
	   $templater->register('h_avg', $h_avg);
	   $replyinfo .= $templater->render();
    }
	$templater = vB_Template::create('microsupport_main');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] . ""=> $vbulletin->options['microsupport_navbar'], '', $mynavbar));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    if($vbulletin->options["microsupport_average"]==1)
    {
	   $templater->register('replyinfo', $replyinfo);
    }
	$templater->register('horizontalcategories', $horizontalcategories);
	$templater->register('category', $category);
	$templater->register('categoryquestionsbit', $categoryquestionsbit);
	$templater->register('importantquestions', $importantquestions);
	$templater->register('latestquestions', $latestquestions);
    $templater->register('copyright', $copyright);
	print_output($templater->render()); 
}

//  #######################################################################
//  ######################### Add / Edit Question #########################
//  #######################################################################
if ($_REQUEST['do'] == 'addeditfaq')
{
    // Check for access permission
    if(!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["moderate"]))
    {
         print_no_permission();
    }
    $faqid = $vbulletin->input->clean_gpc('r', 'faqid', TYPE_UINT);
    // Then, check if Question id exists or not
    if(!$faqid)
    {
       // Question id dosen't exists, let's populate empty or default values
       $question["categoryid"] = 0;
       $question["question"] = '';
       $question["answer"] = '';
       $question["important"] = 0;
       // Setup Editor
       require_once(DIR . '/includes/functions_editor.php');
       $editorid = construct_edit_toolbar($question['answer'], false, 'nonforum', $vbulletin->options['allowsmilies']);
       // Get Question Categories
       $tablename = "".TABLE_PREFIX."microsupport_categories";
       $selectCat = new SelectCategory('categoryid', $tablename);
       $selectCat->SetMultiple(false, 30);
       $selectCat->SetStyle('width:300px;');
       $selectcategory = $selectCat->Output();
    } else {
       // Find Question
       $questions = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_faq WHERE id=$faqid LIMIT 1");
       $question = $db->fetch_array($questions);
       // Setup Editor
       require_once(DIR . '/includes/functions_editor.php');
       $editorid = construct_edit_toolbar($question['answer'], false, 'nonforum', $vbulletin->options['allowsmilies']);
       // Get Categories
       $tablename = "".TABLE_PREFIX."microsupport_categories";
       $selectCat = new SelectCategory('categoryid', $tablename);
       $selectCat->SetMultiple(false, 30);
       $selectCat->SetStyle('width:300px;');
       $selectCat->SetSelected($categoryid);
       $selectcategory = $selectCat->Output();
    }
	$templater = vB_Template::create('microsupport_addedit_question');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_addedit_question']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    $templater->register('editorid', $editorid);
    $templater->register('messagearea', $messagearea);
	$templater->register('questionid', $question[id]);
	$templater->register('questionquestion', $question[question]);
    $templater->register('questionanswer', $question[answer]);
    $templater->register('questionimportant', $question[important]);
	$templater->register('selectcategory', $selectcategory);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}
// #######################################################################
// ########################## SAVE/UPDATE QUESTION #######################
// #######################################################################
if ($_REQUEST['do'] == 'saveupdatefaq'){
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
         print_no_permission();
    }
    $faqid = $vbulletin->input->clean_gpc('r', 'faqid', TYPE_UINT);
    $vbulletin->input->clean_array_gpc('p', array(
		'wysiwyg'     => TYPE_BOOL,
		'message'	  => TYPE_STR,
		'question'	  => TYPE_STR,
        'categoryid'  => TYPE_UINT,
        'important'   => TYPE_UINT
	));
    // Get Values
	$question = $db->escape_string($vbulletin->GPC['question']);
	if ($vbulletin->GPC['wysiwyg'])
	{
		require_once(DIR . '/includes/functions_wysiwyg.php');
		$vbulletin->GPC['message'] = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message'], 0);
	}
	require_once(DIR . '/includes/functions_newpost.php');
	$vbulletin->GPC['message'] = convert_url_to_bbcode($vbulletin->GPC['message']);
    $answer = $db->escape_string($vbulletin->GPC['message']);
    $categoryid = $vbulletin->GPC['categoryid'];
    $important = $vbulletin->GPC['important'];
    if($faqid != 0)
    {
       // Update Question
       $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microsupport_faq
                                    SET categoryid = '$categoryid',
                                        question = '$question',
                                        answer = '$answer',
                                        important = '$important' WHERE id=$faqid");
    } else {
       // Save New Question
       $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "microsupport_faq
                                    SET categoryid = '$categoryid',
                                        question = '$question',
                                        answer = '$answer',
                                        important = '$important'");
       $questionid=$vbulletin->GPC['requestid'] = $db->insert_id();
    }
    $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=faqs";
    eval(print_standard_redirect('microsupport_action_ok', true, true));
}

// #######################################################################
// ############################ VIEW QUESTION ############################
// #######################################################################
if ($_REQUEST['do'] == 'viewquestion'){

    $faqid = $vbulletin->input->clean_gpc('r', 'faqid', TYPE_UINT);
    if(!$faqid)
    {
      $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microsupport_invalid_data', true, true));
    }
    $questions = $db->query_read("SELECT * FROM ".TABLE_PREFIX."microsupport_faq WHERE id=$faqid LIMIT 1");
    $question = $db->fetch_array($questions);
    $catid = $question["categoryid"];
    $mynavbar = '';
    $mynavbar = getMyNavBar($mynavbar, $catid);
    // Get Important FAQ
    $faq_important = getImportants($catid);
    // Get Latest FAQ
    $faq_latest = getLatest($catid);
    // If enabled, get Average Responce Time
    if($vbulletin->options["microsupport_average"]==1)
    {
       $averagetime = getResponseTime();
       $templater = vB_Template::create('microsupport_reply_info');
	   $templater->register('m_avg', $m_avg);
	   $templater->register('h_avg', $h_avg);
	   $replyinfo .= $templater->render();
    }
    // Check Moderation Permissions
    if($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate'])
    {
       $isadmin = 1;
    } else {
       $isadmin = 0;
    }
    require_once(DIR . '/includes/class_bbcode.php');
	$bbcode_parser = new vB_BbCodeParser($vbulletin, fetch_tag_list());
	$answer = $bbcode_parser->parse($question['answer']);

	$templater = vB_Template::create('microsupport_view_question');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] . "" => $vbulletin->options['microsupport_navbar'],''.$mynavbar.'', '' => $question['question']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
    if($vbulletin->options["microsupport_average"]==1)
    {
       $templater->register('replyinfo', $replyinfo);
    }
    $templater->register('questionid', $question[id]);
	$templater->register('questionquestion', $question[question]);
	$templater->register('answer', $answer);
	$templater->register('importantquestions', $importantquestions);
	$templater->register('latestquestions', $latestquestions);
    $templater->register('isadmin', $isadmin);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}


// #######################################################################
// ##########################  F.A.Q LISTING  ############################
// #######################################################################
if ($_REQUEST['do'] == 'faqs')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
         print_no_permission();
    }
    $totalquestions = 0;
    //$perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
    //$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    $totalrecords = $db->query_first("
                    SELECT COUNT(`id`) AS `totalrecords`
                    FROM `" . TABLE_PREFIX . "microsupport_faq`
                    ");
    $records = $totalrecords['totalrecords'];
	$perpage= $vbulletin->options['microsupport_perpage'];
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	if (empty($pagenumber))
    {
        $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
		if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'support.php?' . $vbulletin->session->vars['sessionurl'] . 'do=faqs');
    $questions = $vbulletin->db->query_read("
	                        SELECT *
	                        FROM " . TABLE_PREFIX . "microsupport_faq
	                        ORDER BY id DESC
                            LIMIT " . ($limitlower-1) . ", $perpage");
    // Build Question Bits
    while ($question = $vbulletin->db->fetch_array($questions)){
		   $templater = vB_Template::create('microsupport_browse_questions_bit');
		   $templater->register('questionid', $question[id]);
		   $templater->register('questionquestion', $question[question]);
		   $browsequestionsbit .= $templater->render();
    }
	$templater = vB_Template::create('microsupport_browse_questions');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_all_questions']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('browsequestionsbit', $browsequestionsbit);
	$templater->register('pagenav', $pagenav);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

// #######################################################################
// ##########################  DELETE QUESTION  ##########################
// #######################################################################
if ($_REQUEST['do'] == 'deletefaq')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
         print_no_permission();
    }
    $faqid = $vbulletin->input->clean_gpc('r', 'faqid', TYPE_UINT);
    if($faqid)
    {
       $vbulletin->db->query_write("DELETE FROM " . TABLE_PREFIX . "microsupport_faq WHERE id=$faqid LIMIT 1");
       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=faqs";
       eval(print_standard_redirect('microsupport_action_ok', true, true));
    } else {
       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
       eval(print_standard_redirect('microsupport_invalid_data', true, true));
    }
}

//  #######################################################################
//  ###########################  SUBMIT TICKET  ###########################
//  #######################################################################
if ($_REQUEST['do'] == 'newticket')
{
    // Check for access permission
    if(!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["ticket"]))
    {
         print_no_permission();
    }
    $catid = 0;
    // Assign Default Values
    $ticket["userid"] = 0;
    $ticket["departmentid"] = 0;
    $ticket["productid"] = 0;
    $ticket["title"] = '';
    $ticket["bodytext"] = '';
    $ticket["attachment"] = '';
    $ticket["created"] = 0;
    $ticket["updated"] = 0;
    $ticket["needaction"] = 0;
    $ticket["priority"] = 3;
    $ticket["status"] = 1;
    // Setup Editor
	$editorid = construct_edit_toolbar('',1,'',0,1,($vbulletin->userinfo['userid']));
    if($vbulletin->options["microsupport_products"])
    {
       $products = getProducts($ticket["productid"]);
	   $products_html = '<b>'.$vbphrase[microsupport_product].'</b>';
	   $products_options_html = '<select name="productid" style="width:170px;">'.$products.'</select>';
	}else{
	   $products_html = '&nbsp;';
	   $products_options_html = '&nbsp;';
	}
    if($vbulletin->options["microsupport_departments"])
    {
       $departments = getDepartments($ticket["departmentid"]);
       $departments_html = '<b>'.$vbphrase[microsupport_department].'</b>';
	   $departments_options_html = '<select name="departmentid" style="width:170px;">'.$departments.'</select>';
	}else{
	   $departments_html = '&nbsp;';
	   $departments_options_html = '&nbsp;';
	}
    // Get Important FAQ
    $faq_important = getImportants($catid);
    // Get Latest FAQ
    $faq_latest = getLatest($catid);
    // If enabled, get Average Responce Time
    if($vbulletin->options["microsupport_average"]==1)
    {
       $averagetime = getResponseTime();
       $templater = vB_Template::create('microsupport_reply_info');
	   $templater->register('m_avg', $m_avg);
	   $templater->register('h_avg', $h_avg);
	   $replyinfo .= $templater->render();
    }
	if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['attach']))
    {
       $can_attach = 0;
	}else{
	   $can_attach = 1;
	}
	$templater = vB_Template::create('microsupport_submit_ticket');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_addedit_question']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('departments', $departments);
	$templater->register('products', $products);
	$templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
	$templater->register('departments_html', $departments_html);
	$templater->register('departments_options_html', $departments_options_html);
	$templater->register('products_html', $products_html);
	$templater->register('products_options_html', $products_options_html);
	$templater->register('canattach', $can_attach);
    $templater->register('importantquestions', $importantquestions);
	$templater->register('latestquestions', $latestquestions);
	$templater->register('replyinfo', $replyinfo);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}
// #######################################################################
// ################################  SAVE TICKET  ########################
// #######################################################################
if ($_REQUEST['do'] == 'saveticket'){
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['ticket']))
    {
         print_no_permission();
    }
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
		'title'    		=> TYPE_STR,
        'message'		=> TYPE_STR,
        'flyer'	        => TYPE_STR,
        'productid'     => TYPE_UINT,
        'departmentid'  => TYPE_UINT,
        'created'       => TYPE_INT,
        'updated'       => TYPE_INT,
        'needaction'    => TYPE_UINT,
        'priority'      => TYPE_UINT,
        'status'        => TYPE_UINT,
        'flyer'		    => TYPE_STR,
        'userid'        => TYPE_UINT
	));
    // Get Values
	$title = $db->escape_string($vbulletin->GPC['title']);
    if($vbulletin->GPC['wysiwyg']) {
		$bodytext = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message']);
    } else {
  	    $bodytext = $vbulletin->GPC['message'];
    }
	$bodytext = $db->escape_string($bodytext);
    $productid = $vbulletin->GPC['productid'];
    $departmentid = $vbulletin->GPC['departmentid'];
    $userid = $vbulletin->userinfo['userid'];
    $priority = $permissions['supportpriority'];
    $status = 1;
    $needaction = 1;
    $created = time();
    $updated = time();
    // Manage Attachment
    $flyer_name = '';
    if($_FILES['flyer']['name']) {
      $ext=get_ext($_FILES['flyer']['name']);
      // Check for allowed Attachment Types
	  $typesallowed = explode(",", $vbulletin->options['microsupport_upload_type']);
	  if (!in_array($ext, $typesallowed)) {
          $flyer_name = '';
      } else {
          $flyername  = $_FILES['flyer']["name"];
          if ($flyername=='') {
              $flyer_name = '';
          } else {
              $flyer_name=time()+rand(0,100000).".".$ext;
              $folder="microsupport/attachments/";
              If(!@move_uploaded_file($_FILES['flyer']['tmp_name'],$folder.$flyer_name)) {
			     $flyer_name = '';
		      }
          }
      }
    }
    // Submit New Ticket
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "microsupport_tickets
                                 SET title='$title',
                                     bodytext='$bodytext',
                                     attachment='$flyer_name',
                                     departmentid='$departmentid',
                                     productid='$productid',
                                     userid='$userid',
                                     priority='$priority',
                                     status='$status',
                                     needaction='$needaction',
                                     created='$created',
                                     updated='$updated'");
    $ticketid=$vbulletin->GPC['ticketid'] = $db->insert_id();
    // Email preparation
    $priority = $vbulletin->options["microsupport_email_priority"];
    $headers  ="From: ".$vbulletin->options["bbtitle"]." <".$vbulletin->options["webmasteremail"].">\n";
    $headers .="Reply-To: ".$vbulletin->options["bbtitle"]." <".$vbulletin->options["webmasteremail"].">\n";
    $headers .="MIME-Version: 1.0\n";
    $headers .="Content-type: text/html; charset=utf-8\n";
    $headers .="X-Sender: ".$_SERVER['REMOTE_ADDR']."\n";
    $headers .="X-Mailer: PHP/".phpversion()."\n";
    $headers .="X-Priority: ".$priority."\n";
    $headers .="Return-Path: <".$vbulletin->options["webmasteremail"].">\n";
    // Send Email to Client
    $touser = getRecordById("user",$userid,"userid");
    $toemail = $touser["email"];
    $tousername = $touser["username"];
    $subject = $vbulletin->options["microsupport_email_subject"];
    $message  = "<font face='Tahoma' size='2'>";
    $message .= $vbulletin->options["microsupport_email_salutation"]."&nbsp;<b>".$tousername."</b>,";
    $message .= "<p align=\"justify\">";
    $message .= $vbulletin->options["microsupport_email_body1"];
    $message .= "</p><p>".$vbulletin->options["microsupport_email_footer"]."</p>";
    mail($toemail, $subject, $message, $headers);
    // Notify Technician
    if(!empty($vbulletin->options["microsupport_email_tech"]))
    {
       $toemail = $vbulletin->options["microsupport_email_tech"];
       $subject = $vbulletin->options["microsupport_email_subject"];
       $message = "A new ticket has been opened. Please get action.";
       mail($toemail, $subject, $message, $headers);
    }
    $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
    eval(print_standard_redirect('microsupport_action_ok', true, true));
}

//  #######################################################################
//  #########################  ADD REPLY TO TICKET  #######################
//  #######################################################################
if ($_REQUEST['do'] == 'replyticket')
{
    // Check for access permission
    if(!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["ticket"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $ticketid = $vbulletin->input->clean_gpc('r', 'ticketid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    // Find Ticket
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id=$ticketid LIMIT 1");
    $ticket = $db->fetch_array($qry);
    // Who is the owner?
    $owner = $ticket["userid"];
    // Check if active user is the owner or if he has moderator permissions
    if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["moderate"])))
    {
        // Check failed. Send him back
        print_no_permission();
    }
    $bodytext = parseBbCode($ticket["bodytext"]);
    if($vbulletin->options["microsupport_departments"]==1)
    {
       $department = getRecordById("microsupport_departments",$ticket["departmentid"]);
       $departments_html = $vbphrase[microsupport_department];
	   $departments_title_html = $department[name];
	}else{
	   $departments_html = '&nbsp;';
	   $departments_title_html = '&nbsp;';
	}
    if($vbulletin->options["microsupport_products"]==1)
    {
       $product = getRecordById("microsupport_products",$ticket["productid"]);
	   $products_html = $vbphrase[microsupport_product];
	   $products_title_html = $product[name];
	}else{
	   $products_html = '&nbsp;';
	   $products_title_html = '&nbsp;';
    }
    $poster = getRecordById("user",$ticket["userid"],'userid');
    $status = getRecordById("microsupport_ticket_status",$ticket["status"]);
    $created = date($vbulletin->options['microsupport_dateformat'], $ticket['created']);
    $updated = date($vbulletin->options['microsupport_dateformat'], $ticket['updated']);
    if(!empty($ticket["attachment"]))
    {
        $attachmentexists = 1;
        $ext=get_ext($ticket["attachment"]);
        if ($ext=='gif' OR $ext=='jpeg' OR $ext=='jpg' OR $ext=='png')
        {
            $isphoto = 1;
        }
    }
    // Get Replies to Ticket
    $replies = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_ticket_replies WHERE ticketid=$ticketid ORDER BY created ASC");
    while ($reply = $vbulletin->db->fetch_array($replies)){
           $r_bodytext = parseBbCode($reply["bodytext"]);
           $r_poster = getRecordById("user",$reply["userid"],'userid');
           $r_created = date($vbulletin->options['microsupport_dateformat'], $reply['created']);
           if($reply["userid"] == $vbulletin->userinfo['userid'])
           {
              $iconfile = "client.gif";
           } else {
              $iconfile = "tech.gif";
           }
           $templater = vB_Template::create('microsupport_browse_replies');
		   $templater->register('iconfile', $iconfile);
		   $templater->register('r_posterusername', $r_poster[username]);
		   $templater->register('r_created', $r_created);
		   $templater->register('r_bodytext', $r_bodytext);
		   $templater->register('attachment', $reply[attachment]);
		   $browsereplies .= $templater->render();
    }
    // Setup Editor
    $editorid = construct_edit_toolbar('',1,'',0,1,($vbulletin->userinfo['userid']));
    // Functions for Templates
    $catid = 0;
   	if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['attach']))
    {
       $can_attach = 0;
	}else{
	   $can_attach = 1;
	}
   	if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
       $can_close = 0;
	}else{
	   $can_close = 1;
	}
    // Get Important FAQ
    $faq_important = getImportants($catid);
    // Get Latest FAQ
    $faq_latest = getLatest($catid);
    if($vbulletin->options["microsupport_average"]==1)
    {
       $averagetime = getResponseTime();
       $templater = vB_Template::create('microsupport_reply_info');
	   $templater->register('m_avg', $m_avg);
	   $templater->register('h_avg', $h_avg);
	   $replyinfo .= $templater->render();
    }
	// Prepare Template
	$templater = vB_Template::create('microsupport_reply_ticket');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_ticket_reply']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('verticalcategories', $verticalcategories);
	$templater->register('replyinfo', $replyinfo);
	$templater->register('tickettitle', $ticket[title]);
	$templater->register('ticketid', $ticket[id]);
	$templater->register('departments_html', $departments_html);
	$templater->register('editorid', $editorid);
	$templater->register('messagearea', $messagearea);
	$templater->register('departments_title_html', $departments_title_html);
	$templater->register('products_html', $products_html);
	$templater->register('products_title_html', $products_title_html);
	$templater->register('created', $created);
	$templater->register('updated', $updated);
	$templater->register('bodytext', $bodytext);
	$templater->register('hasattachment', $ticket[attachment]);
	$templater->register('browsereplies', $browsereplies);
	$templater->register('attach_html', $attach_html);
	$templater->register('moderate_html', $moderate_html);
    $templater->register('importantquestions', $importantquestions);
	$templater->register('latestquestions', $latestquestions);
    $templater->register('canattach', $can_attach);
    $templater->register('canclose', $can_close);
    $templater->register('status', $ticket[status]);
    $templater->register('copyright', $copyright);
	print_output($templater->render());

}

// #######################################################################
// ################################  SAVE REPLY  #########################
// #######################################################################
if ($_REQUEST['do'] == 'savereply')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['ticket']))
    {
         print_no_permission();
    }
    $ticketid = $vbulletin->input->clean_gpc('r', 'ticketid', TYPE_UINT);
    $vbulletin->input->clean_array_gpc('p', array(
   		'wysiwyg'       => TYPE_BOOL,
        'message'		=> TYPE_STR,
        'flyer'	        => TYPE_STR,
        'created'       => TYPE_INT,
        'closeticket'   => TYPE_UINT,
        'userid'        => TYPE_UINT
	));
    if($vbulletin->GPC['wysiwyg'])
    {
		$bodytext = convert_wysiwyg_html_to_bbcode($vbulletin->GPC['message']);
    } else {
  	    $bodytext = $vbulletin->GPC['message'];
    }
	$bodytext = $db->escape_string($bodytext);
    $closeticket = $vbulletin->GPC['closeticket'];
    $userid = $vbulletin->userinfo['userid'];
    $created = time();
    // Manage Attachment
    $flyer_name = '';
    if($_FILES['flyer']['name']) {
      $ext=get_ext($_FILES['flyer']['name']);
      // Check for allowed Attachment Types
	  $typesallowed = explode(",", $vbulletin->options['microsupport_upload_type']);
	  if (!in_array($ext, $typesallowed)) {
          $flyer_name = '';
      } else {
          $flyername  = $_FILES['flyer']["name"];
          if ($flyername=='') {
              $flyer_name = '';
          } else {
              $flyer_name=time()+rand(0,100000).".".$ext;
              $folder="microsupport/attachments/";
              If(!@move_uploaded_file($_FILES['flyer']['tmp_name'],$folder.$flyer_name)) {
			     $flyer_name = '';
		      }
          }
      }
    }
    // Save Reply
	$userid = $vbulletin->userinfo['userid'];
    $vbulletin->db->query_write("INSERT INTO " . TABLE_PREFIX . "microsupport_ticket_replies
                                 SET bodytext='".$bodytext."',
                                     ticketid='".$ticketid."',
                                     attachment='".$flyer_name."',
                                     userid='".$userid."',
                                     created='".$created."'");
    $replyid=$vbulletin->GPC['replyid'] = $db->insert_id();
    // Update Ticket
   // $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id='".$ticketid."' LIMIT 1");
   // $ticket = $db->fetch_array($qry);
	
   $ticket = $db->query_first("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id='" . $ticketid ."'");
    // Who is the owner?
   $owner = $ticket['userid'];
    // Check if active user is the owner or if he has moderator permissions
    if($owner == $vbulletin->userinfo['userid'])
    {
       $needaction = 1;
       $emailclient = 0;
    } else {
       $needaction = 0;
       $emailclient = 1;
    }
    if($emailclient == 1)
    {
       //Headers
       $priority = $vbulletin->options["microsupport_email_priority"];
       $headers  ="From: ".$vbulletin->options["bbtitle"]." <".$vbulletin->options["webmasteremail"].">\n";
       $headers .="Reply-To: ".$vbulletin->options["bbtitle"]." <".$vbulletin->options["webmasteremail"].">\n";
       $headers .="MIME-Version: 1.0\n";
       $headers .="Content-type: text/html; charset=utf-8\n";
       $headers .="X-Sender: ".$_SERVER['REMOTE_ADDR']."\n";
       $headers .="X-Mailer: PHP/".phpversion()."\n";
       $headers .="X-Priority: ".$priority."\n";
       $headers .="Return-Path: <".$vbulletin->options["webmasteremail"].">\n";
       $touser = getRecordById("user",$owner,"userid");
       $toemail = $touser["email"];
       $tousername = $touser["username"];
       $subject = $vbulletin->options["microsupport_email_subject"];
       $message  = "<font face='Tahoma' size='2'>";
       $message .= $vbulletin->options["microsupport_email_salutation"]."&nbsp;<b>".$tousername."</b>,";
       $message .= "<p align=\"justify\">";
       $message .= $vbulletin->options["microsupport_email_body2"];
       $message .= "</p><p>".$vbulletin->options["microsupport_email_footer"]."</p>";
       mail($toemail, $subject, $message, $headers);
    } else {
       //Headers
       $priority = $vbulletin->options["microsupport_email_priority"];
       $headers  ="From: ".$vbulletin->options["bbtitle"]." <".$vbulletin->options["webmasteremail"].">\n";
       $headers .="Reply-To: ".$vbulletin->options["bbtitle"]." <".$vbulletin->options["webmasteremail"].">\n";
       $headers .="MIME-Version: 1.0\n";
       $headers .="Content-type: text/html; charset=utf-8\n";
       $headers .="X-Sender: ".$_SERVER['REMOTE_ADDR']."\n";
       $headers .="X-Mailer: PHP/".phpversion()."\n";
       $headers .="X-Priority: ".$priority."\n";
       $headers .="Return-Path: <".$vbulletin->options["webmasteremail"].">\n";
       $toemail = $vbulletin->options["microsupport_email_tech"];
       $subject = $vbulletin->options["microsupport_email_subject"];
       $message = "A new reply has been post. Please get action.";
       mail($toemail, $subject, $message, $headers);
    }
    if($closeticket == 1)
    {
       $status = 3;
    } else {
       $status = 2;
    }
    $updated = time();
    // Save Updates
    $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microsupport_tickets
                                 SET status='$status',
                                     needaction='$needaction',
                                     updated='$updated' WHERE id=$ticketid");
    if($owner == $vbulletin->userinfo['userid'])
    {
       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=mytickets";
       eval(print_standard_redirect('microsupport_action_ok', true, true));
    } else {
       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=tickets";
       eval(print_standard_redirect('microsupport_action_ok', true, true));
    }
}


// #######################################################################
// ##########################  TICKET LISTING  ###########################
// #######################################################################
if ($_REQUEST['do'] == 'tickets')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
         print_no_permission();
    }
    // Values for Search
    if($vbulletin->options["microsupport_departments"]==1)
    {
       $departments = getSearchDepartments();
	   $departments_html = '<td class="blockrow" align="center" nowrap><b>
                           '.$vbphrase[microsupport_department].'</b></td>
                            <td class="blockrow" align="center" nowrap>
                            <select name="departmentid" style="width:100px;">
                           '.$departments.'
                             </select></td>';
       $use_departments = 1;
    } else {
       $use_departments = 0;
    }
    if($vbulletin->options["microsupport_products"]==1)
    {
       $products = getSearchProducts();
       $products_html = '<td class="blockrow" align="center" nowrap><b>
                        '.$vbphrase[microsupport_product].'</b></td>
                         <td class="blockrow" align="center" nowrap>
                         <select name="productid" style="width:100px;">
                        '.$products.'
                         </select></td>';
       $use_products = 1;
    } else {
       $use_products = 0;
    }
    $ticketstatus = getSearchStatus();
    // Listing All
    $totaltickets = 0;
    //$perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
	$totalrecords = $db->query_first("
		SELECT COUNT(*) AS totalrecords
		FROM " . TABLE_PREFIX . "microsupport_tickets AS microsupport_tickets
		WHERE needaction=1 AND status<>3
	");
	$records = $totalrecords['totalrecords'];
	$perpage= $vbulletin->options['microsupport_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	if (empty($pagenumber))
    {
       $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
    	if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'support.php?' . $vbulletin->session->vars['sessionurl'] . 'do=tickets');
	$tickets = $vbulletin->db->query_read_slave("
	                        SELECT *
	                        FROM " . TABLE_PREFIX . "microsupport_tickets
	                        WHERE needaction=1 AND status<>3
                            ORDER BY priority ASC, updated ASC
                            LIMIT " . ($limitlower-1) . ", $perpage");
    // Build Ticket Bits
    while ($ticket = $vbulletin->db->fetch_array($tickets) AND $counter++ < $perpage){
           $department = getRecordById("microsupport_departments",$ticket["departmentid"]);
           $product = getRecordById("microsupport_products",$ticket["productid"]);
           $poster = getRecordById("user",$ticket["userid"],'userid');
           $replies = getCountReplies($ticket["id"]);
           $pagenav = construct_page_nav($pagenumber, $perpage, $totalrecords['totalrecords'], 'support.php?' . $vbulletin->session->vars['sessionurl'] . 'do=tickets');
		   if ($ticket[status]==3){
			   $status_html = '<option value="support.php?do=openticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_reopen].'</option>
			   <option value="support.php?do=deleteticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_delete].'</option>';
		   }else{
			   $status_html = '<option value="support.php?do=replyticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_view].'</option>
<option value="support.php?do=closeticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_close].'</option>
<option value="support.php?do=deleteticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_delete].'</option>';
		   }
		   $templater = vB_Template::create('microsupport_browse_tickets_bit');
		   $templater->register('ticketpriority', $ticket[priority]);
		   $templater->register('departmentname', $department[name]);
		   $templater->register('productname', $product[name]);
           $templater->register('ticketid', $ticket[id]);
		   $templater->register('tickettitle', $ticket[title]);
		   $templater->register('posterusername', $poster[username]);
		   $templater->register('replies', $replies);
		   $templater->register('status_html', $status_html);
           $templater->register('usedepartments', $use_departments);
           $templater->register('useproducts', $use_products);
		   $browseticketsbit .= $templater->render();
    }
	$templater = vB_Template::create('microsupport_browse_tickets');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_tickets_todo']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('departments_html', $departments_html);
	$templater->register('products_html', $products_html);
	$templater->register('ticketstatus', $ticketstatus);
	$templater->register('browseticketsbit', $browseticketsbit);
	$templater->register('pagenav', $pagenav);
    $templater->register('usedepartments', $use_departments);
    $templater->register('useproducts', $use_products);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

// #######################################################################
// ##########################  TICKET FILTERING  #########################
// #######################################################################
if ($_REQUEST['do'] == 'searchresults')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
         print_no_permission();
    }
    // Values for Search
    if($vbulletin->options["microsupport_departments"]==1)
    {
       $departments = getSearchDepartments();
	   $departments_html = '<td class="blockrow" align="center" nowrap><b>
                           '.$vbphrase[microsupport_department].'</b></td>
                            <td class="blockrow" align="center" nowrap>
                            <select name="departmentid" style="width:100px;">
                           '.$departments.'
                             </select></td>';
       $use_departments = 1;
    } else {
       $use_departments = 0;
    }
    if($vbulletin->options["microsupport_products"]==1)
    {
       $products = getSearchProducts();
       $products_html = '<td class="blockrow" align="center" nowrap><b>
                        '.$vbphrase[microsupport_product].'</b></td>
                         <td class="blockrow" align="center" nowrap>
                         <select name="productid" style="width:100px;">
                        '.$products.'
                         </select></td>';
       $use_products = 1;
    } else {
       $use_products = 0;
    }
    $ticketstatus = getSearchStatus();
    // Clean and Get values
    $departmentid = $vbulletin->input->clean_gpc('r', 'departmentid', TYPE_UINT);
    $productid = $vbulletin->input->clean_gpc('r', 'productid', TYPE_UINT);
    $statusid = $vbulletin->input->clean_gpc('r', 'statusid', TYPE_UINT);

    // Build WHERE for Query
    $where = "id>0";
    if($departmentid != 0)
    {
       $where .= " AND departmentid=$departmentid";
    }
    if($productid != 0)
    {
       $where .= " AND productid=$productid";
    }
    if($statusid != 0)
    {
       $where .= " AND status=$statusid";
    }
    $postvalues .= "&departmentid=".$departmentid;
    $postvalues .= "&productid=".$productid;
    $postvalues .= "&statusid=".$statusid;
    $totaltickets = 0;
    $perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    $totalrecords = $db->query_first("
                    SELECT COUNT(`id`) AS `totalrecords`
                    FROM `" . TABLE_PREFIX . "microsupport_tickets`
                    WHERE $where
                    ");
	$records = $totalrecords['totalrecords'];
	$perpage= $vbulletin->options['microsupport_perpage'];
	$pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
	if (empty($pagenumber))
    {
       $pagenumber = 1;
    }
	$limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
    $counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
    	if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'support.php?' . $vbulletin->session->vars['sessionurl'] . 'do=searchresults'.$postvalues.'');
    $tickets = $vbulletin->db->query_read("
	                        SELECT *
	                        FROM " . TABLE_PREFIX . "microsupport_tickets
	                        WHERE $where
                            ORDER BY priority ASC, updated ASC
                            LIMIT " . ($limitlower-1) . ", $perpage");
    // Build Ticket Bits
    while ($ticket = $vbulletin->db->fetch_array($tickets) AND $counter++ < $perpage){
           $department = getRecordById("microsupport_departments",$ticket["departmentid"]);
           $product = getRecordById("microsupport_products",$ticket["productid"]);
           $poster = getRecordById("user",$ticket["userid"],'userid');
           $replies = getCountReplies($ticket["id"]);
		   if ($ticket[status]==3){
			   $status_html = '<option value="support.php?do=openticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_reopen].'</option>
			   <option value="support.php?do=deleteticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_delete].'</option>';
		   }else{
			   $status_html = '<option value="support.php?do=replyticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_view].'</option>
<option value="support.php?do=closeticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_close].'</option>
<option value="support.php?do=deleteticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_delete].'</option>';
		   }
 		   $templater = vB_Template::create('microsupport_browse_tickets_bit');
		   $templater->register('ticketpriority', $ticket[priority]);
           $templater->register('ticketid', $ticket[id]);
		   $templater->register('departmentname', $department[name]);
		   $templater->register('productname', $product[name]);
		   $templater->register('tickettitle', $ticket[title]);
		   $templater->register('posterusername', $poster[username]);
		   $templater->register('replies', $replies);
		   $templater->register('status_html', $status_html);
           $templater->register('usedepartments', $use_departments);
           $templater->register('useproducts', $use_products);
		   $browseticketsbit .= $templater->render();
    }
    // Get Categories for Menu
	if($vboptions[microsupport_departments]==1){
		$departments_html = '<td class="blockrow" align="center" nowrap>
              <div class="smallfont"><strong>
              '.$vbphrase[microsupport_department].'</strong></div>
            </td>
            <td class="blockrow" align="center" nowrap>
              <select name="departmentid" style="width:100px;">
              '.$departments.'
              </select>
            </td>';
	}
	if($vboptions[microsupport_products]==1){
		$products_html = '<td class="blockrow" align="center" nowrap>
              <div class="smallfont"><strong>
              '.$vbphrase[microsupport_product].'</strong></div>
            </td>
            <td class="blockrow" align="center" nowrap>
              <select name="productid" style="width:100px;">
              '.$products.'
              </select>
            </td>';
	}
	$templater = vB_Template::create('microsupport_browse_tickets');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_tickets_todo']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('departments_html', $departments_html);
	$templater->register('products_html', $products_html);
	$templater->register('ticketstatus', $ticketstatus);
	$templater->register('browseticketsbit', $browseticketsbit);
    $templater->register('usedepartments', $use_departments);
    $templater->register('useproducts', $use_products);
	$templater->register('pagenav', $pagenav);
	print_output($templater->render());
}

// #######################################################################
// #############################  MY TICKETS  ############################
// #######################################################################
if ($_REQUEST['do'] == 'mytickets')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['ticket']))
    {
         print_no_permission();
    }
    // Use Departments?
    if($vbulletin->options["microsupport_departments"])
    {
       $departments = 1;
    } else {
       $departments = 0;
    }
    // Use Products?
    if($vbulletin->options["microsupport_products"])
    {
       $products = 1;
    } else {
       $products = 0;
    }
    $userid = $vbulletin->userinfo['userid'];
    $totaltickets = 0;
    $perpage = $vbulletin->input->clean_gpc('r', 'perpage', TYPE_UINT);
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
    $totalrecords = $db->query_first("
                    SELECT COUNT(`id`) AS `totalrecords`
                    FROM `" . TABLE_PREFIX . "microsupport_tickets`
                    WHERE userid=$userid
                    ");
    $records = $totalrecords['totalrecords'];
 	$perpage= $vbulletin->options['microsupport_perpage'];
    $pagenumber = $vbulletin->input->clean_gpc('r', 'pagenumber', TYPE_UINT);
 	if (empty($pagenumber))
    {   $pagenumber = 1;
    }
    $limitlower = ($pagenumber - 1) * $perpage+1;
	$limitupper = ($pagenumber) * $perpage;
	$counter = 0;
	if ($limitupper > $records)
	{
		$limitupper = $records;
		if ($limitlower > $records)
		{
			$limitlower = $records-$perpage;
		}
	}
	if ($limitlower <= 0)
	{
		$limitlower = 1;
	}
    $pagenav = construct_page_nav($pagenumber, $perpage, $records, 'support.php?' . $vbulletin->session->vars['sessionurl'] . 'do=mytickets');
    $tickets = $vbulletin->db->query_read("
	                        SELECT *
	                        FROM " . TABLE_PREFIX . "microsupport_tickets
	                        WHERE userid=$userid
                            ORDER BY updated DESC
                            LIMIT " . ($limitlower-1) . ", $perpage");
    // Build Ticket Bits
    while ($ticket = $vbulletin->db->fetch_array($tickets) AND $counter++ < $perpage){
           $department = getRecordById("microsupport_departments",$ticket["departmentid"]);
           $product = getRecordById("microsupport_products",$ticket["productid"]);
           $this_ticket = $ticket["id"];
           $replier = $vbulletin->db->query_first("SELECT * FROM " . TABLE_PREFIX . "microsupport_ticket_replies WHERE ticketid=$this_ticket ORDER BY created DESC LIMIT 1");
           $lastreplier = $replier["userid"];
           $poster = $vbulletin->db->query_first("SELECT * FROM " . TABLE_PREFIX . "user WHERE userid='$lastreplier' ORDER BY userid ASC LIMIT 1");
           $lastposter = $poster["username"];
           $status = getRecordById("microsupport_ticket_status",$ticket["status"]);
		   if ($status[id]==3){
			   $status_html = '<option value="support.php?do=openticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_reopen].'</option>
			   <option value="support.php?do=deleteticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_delete].'</option>';
		   }else{
			   $status_html = '<option value="support.php?do=replyticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_view].'</option>
<option value="support.php?do=closeticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_ticket_close].'</option>
<option value="support.php?do=deleteticket&ticketid='.$ticket[id].'">'.$vbphrase[microsupport_delete].'</option>';
		   }
		   $templater = vB_Template::create('microsupport_browse_my_tickets_bit');
		   $templater->register('rowbg', $rowbg);
		   $templater->register('departmentname', $department[name]);
		   $templater->register('productname', $product[name]);
		   $templater->register('ticketid', $ticket[id]);
		   $templater->register('tickettitle', $ticket[title]);
		   $templater->register('lastposter', $lastposter);
		   $templater->register('statusname', $status[name]);
		   $templater->register('status_html', $status_html);
           $templater->register('departments', $departments);
           $templater->register('products', $products);
		   $browsemyticketsbit .= $templater->render();
    }
    // Get Categories for Menu
    $catid = 0;
    // Get Important FAQ
    $faq_important = getImportants($catid);
    // Get Latest FAQ
    $faq_latest = getLatest($catid);
    if($vbulletin->options["microsupport_average"]==1)
    {
       $averagetime = getResponseTime();
       $templater = vB_Template::create('microsupport_reply_info');
	   $templater->register('m_avg', $m_avg);
	   $templater->register('h_avg', $h_avg);
	   $replyinfo .= $templater->render();
    }
    // Prepare Template
	$templater = vB_Template::create('microsupport_browse_my_tickets');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_my_tickets']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('browsemyticketsbit', $browsemyticketsbit);
	$templater->register('pagenav', $pagenav);
    $templater->register('importantquestions', $importantquestions);
	$templater->register('latestquestions', $latestquestions);
	$templater->register('replyinfo', $replyinfo);
    $templater->register('departments', $departments);
    $templater->register('products', $products);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}

// #######################################################################
// ############################  CLOSE TICKET  ###########################
// #######################################################################
if ($_REQUEST['do'] == 'closeticket')
{
    $ticketid = $vbulletin->input->clean_gpc('r', 'ticketid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    if($ticketid != 0)
    {
       // Find Ticket
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id=$ticketid LIMIT 1");
       $ticket = $db->fetch_array($qry);
       // Who is the owner?
       $owner = $ticket["userid"];
       // Check if active user is the owner or if he has moderator permissions
       if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["moderate"])))
       {
           // Check failed. Send him back
           print_no_permission();
       } else {
           $status = 3;
           $updated = time();
           $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microsupport_tickets SET status='$status', updated='$updated' WHERE id=$ticketid");
           if($owner == $vbulletin->userinfo['userid'])
           {
	          $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=mytickets";
	          eval(print_standard_redirect('microsupport_action_ok', true, true));
           } else {
	          $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=tickets";
	          eval(print_standard_redirect('microsupport_action_ok', true, true));
           }
       }
    } else {
	       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
	       eval(print_standard_redirect('microsupport_invalid_data', true, true));
    }
}

// #######################################################################
// ##############################  RE-OPEN TICKET  #######################
// #######################################################################
if ($_REQUEST['do'] == 'openticket')
{
    $ticketid = $vbulletin->input->clean_gpc('r', 'ticketid', TYPE_UINT);
    $activeuser = $vbulletin->userinfo['userid'];
    if($ticketid != 0)
    {
       // Find Ticket
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id=$ticketid LIMIT 1");
       $ticket = $db->fetch_array($qry);
       // Who is the owner?
       $owner = $ticket["userid"];
       // Check if active user is the owner or if he has moderator permissions
       if(($owner != $vbulletin->userinfo['userid']) AND (!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["moderate"])))
       {
           // Check failed. Send him back
           print_no_permission();
       } else {
           $status = 2;
           $updated = time();
           $vbulletin->db->query_write("UPDATE " . TABLE_PREFIX . "microsupport_tickets SET status='$status', updated='$updated' WHERE id=$ticketid");
           $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=replyticket&ticketid=$ticketid";
	       eval(print_standard_redirect('microsupport_action_ok', true, true));
       }
    } else {
	       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
	       eval(print_standard_redirect('microsupport_invalid_data', true, true));
    }
}

//  #######################################################################
//  ######################  Confirm Tickets's Deletion  ###################
//  #######################################################################
if ($_REQUEST['do'] == 'deleteticket')
{
    // Check for access permission
    if(!($permissions["microsupport"] & $vbulletin->bf_ugp["microsupport"]["moderate"]))
    {
         print_no_permission();
    }
    // First, let's clean input
    $ticketid = $vbulletin->input->clean_gpc('r', 'ticketid', TYPE_UINT);
    // Then, check for missing vales
    if(!$ticketid)
    {
      $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
      eval(print_standard_redirect('microsupport_invalid_data', true, true));
    }
    // Find Ticket
    $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id=$ticketid LIMIT 1");
    $ticket = $db->fetch_array($qry);
    // Everything is ok, lets prepare the confirmation form
    // Prepare Template
	$templater = vB_Template::create('microsupport_delete_ticket');
	$templater->register_page_templates();
    $navbits = construct_navbits(array("support.php?" . $vbulletin->session->vars['sessionurl'] => $vbulletin->options['microsupport_navbar'], '' => $vbphrase['microsupport_deletion_navbar']));
  	$navbar = render_navbar_template($navbits);
	$templater->register('navbar', $navbar);
	$templater->register('ticketid', $ticket[id]);
    $templater->register('title', $ticket[title]);
    $templater->register('copyright', $copyright);
	print_output($templater->render());
}


// #######################################################################
// ############################  DELETE TICKET  ##########################
// #######################################################################
if ($_REQUEST['do'] == 'yesdelete')
{
    if(!($permissions['microsupport'] & $vbulletin->bf_ugp['microsupport']['moderate']))
    {
         print_no_permission();
    }
    $ticketid = $vbulletin->input->clean_gpc('r', 'ticketid', TYPE_UINT);
    if($ticketid != 0)
    {
       // Find Ticket
       $qry = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id=$ticketid LIMIT 1");
       $ticket = $db->fetch_array($qry);
       // Remove Replies
       $replies = $db->query_read("SELECT * FROM " . TABLE_PREFIX . "microsupport_ticket_replies WHERE ticketid=$ticketid");
       while ($reply = $vbulletin->db->fetch_array($tour_replies)){
              $replyid = $reply["id"];
              if(!empty($reply["attachment"]))
              {
                 $replyattachment = $reply["attachment"];
                 unlink("microsupport/attachments/$replyattachment");
              }
              $vbulletin->db->query_first("DELETE FROM " . TABLE_PREFIX . "microsupport_ticket_replies WHERE id = $replyid");
       }
       if(!empty($ticket["attachment"]))
       {
          $ticketattachment = $ticket["attachment"];
          unlink("microsupport/attachments/$ticketattachment");
       }
       $vbulletin->db->query_first("DELETE FROM " . TABLE_PREFIX . "microsupport_tickets WHERE id = $ticketid");
       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=tickets";
       eval(print_standard_redirect('microsupport_action_ok', true, true));
    } else {
	       $vbulletin->url="support.php?" . $vbulletin->session->vars['sessionurl'] . "do=main";
	       eval(print_standard_redirect('microsupport_invalid_data', true, true));
    }
}
?>
