<?php
/*======================================================================*\
|| #################################################################### ||
|| # Copyright &copy;2009 Quoord Systems Ltd. All Rights Reserved.    # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # This file is part of the Tapatalk package and should not be used # ||
|| # and distributed for any other purpose that is not approved by    # ||
|| # Quoord Systems Ltd.                                              # ||
|| # http://www.tapatalk.com | http://www.tapatalk.com/license.html   # ||
|| #################################################################### ||
\*======================================================================*/
	$methodContainer = array(
		"authorize_user" => array(
			"function" => "authorize_user_func",
			"signature" => array(array($xmlrpcStruct,$xmlrpcBase64,$xmlrpcString)),
			"docstring" => 'authorize need two parameters,the first is user name,second is password. Both are Base64',
		),
	   "logout_user" => array(
                        "function" => "logout_func",
                        "signature" =>array( array( $xmlrpcArray)),
                        "docstring" => 'no need parameters for logout',
           ),
		"get_forum" => array(
			"function" => "get_forum_func",
			"signature" =>array( array( $xmlrpcArray)),
			"docstring" => 'no need parameters for get_forum',
		),
		"get_topic" => array(
			"function" => "get_topic_func",
			"signature" => array(array($xmlrpcStruct,$xmlrpcString,$xmlrpcInt,$xmlrpcInt,$xmlrpcString),
                                             array( $xmlrpcStruct, $xmlrpcString, $xmlrpcInt, $xmlrpcInt,),
                                             array( $xmlrpcStruct, $xmlrpcString, $xmlrpcInt,),
                                             array( $xmlrpcStruct, $xmlrpcString,)
                           ),
			"docstring" => 'parameter should be array(int,int,int,string)',
		),
	    "get_thread" => array(
			"function" => "get_thread_func",
			"signature" => array(array($xmlrpcStruct,$xmlrpcString,$xmlrpcInt,$xmlrpcInt),
							array($xmlrpcStruct,$xmlrpcString)),
			"docstring" => 'parameter should be array(int,int,int,string)',
		),
             "get_user_topic" => array(
                        "function" => "get_user_topic_func",
                        "signature" => array(array($xmlrpcStruct,$xmlrpcBase64)),
                         "docstring" => 'parameter should be array(int,int,int,string)',
                ),
              "get_user_reply_post" => array(
                        "function" => "get_user_reply_post_func",
                        "signature" => array(array($xmlrpcStruct,$xmlrpcBase64)),
                         "docstring" => 'parameter should be array(int,int,int,string)',
                ),
             "get_user_info" => array(
                        "function" => "get_user_info_func",
                        "signature" => array(array($xmlrpcStruct,$xmlrpcBase64)),
                        "docstring" =>'parameter should be array(sring)',
            ),
              "get_new_topic" => array(
                        "function" => "get_new_topic_func",
                        "signature" => array(array( $xmlrpcArray)),
                        "docstring" => 'no need parameters for get_forum',
                ),
             "get_config" => array(
                        "function" => "get_config_func",
                        "signature" =>array( array( $xmlrpcArray)),
                        "docstring" => 'no need parameters for get_forum',
                ),
                "return_fault" => array(
		             'function' => 
		                        "return_fault_func",
		                'signature' => array(
		                        array(
		                                $xmlrpcStruct,
		                                $xmlrpcInt,
		                                $xmlrpcString,
		                        ),
		                ),
		                'docstring' => "return_fault function ; params faultcode,faultstring ; return @fault"
		        ),
	    	 "create_topic" => array(
				"function" => "create_topic_func",
				"signature" => array(array($xmlrpcStruct,$xmlrpcString,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcBase64),
											array($xmlrpcStruct,$xmlrpcString,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcString)),
				"docstring" => 'parameter should be array(int,string,string)',
			),
			 "reply_topic" => array(
				"function" => "reply_topic_func",
				"signature" => array(array($xmlrpcStruct,$xmlrpcString,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcBase64),
	                                             array($xmlrpcStruct,$xmlrpcString,$xmlrpcBase64,$xmlrpcBase64),
						     array($xmlrpcStruct,$xmlrpcString,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcString),),
				"docstring" => 'parameter should be array(int,string,string)',
			),
		      "get_subscribed_topic" => array(
				"function" => "get_subscribed_topic_func",
				"signature" => array(array($xmlrpcStruct)),
				"docstring" => 'no parameter',
			),
			"subscribe_topic" => array(
				"function" => "subscribe_topic_func",
				"signature" => array(array($xmlrpcStruct,$xmlrpcString)),
				"docstring" => 'parameter should be array(int)',
			),
			"unsubscribe_topic" => array(
				"function" => "unsubscribe_topic_func",
				"signature" => array(array($xmlrpcStruct,$xmlrpcString)),
				"docstring" => 'parameter should be array(int)',
			),
			 "create_message" => array(
				"function" => "create_message_func",
				"signature" => array(array($xmlrpcStruct,$xmlrpcArray,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcInt,$xmlrpcString),
		                             array($xmlrpcStruct,$xmlrpcArray,$xmlrpcBase64,$xmlrpcBase64),
                                             array($xmlrpcStruct,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcBase64),
                                              array($xmlrpcStruct,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcInt,$xmlrpcString),),
                                                 
				"docstring" => 'parameter should be array(string,string,string)',
			),
			"get_inbox_stat" => array(
				"function" => "get_inbox_stat_func",
				"signature" => array(array($xmlrpcStruct)),
				"docstring" => 'parameter should be array(string)',
			),
			"get_box_info" => array(
				"function" => "get_box_info_func",
				"signature" => array(array($xmlrpcStruct)),
				"docstring" => 'parameter should be array(string)',
			),
			"get_box" => array(
				"function" => "get_box_func",
			         "signature" => array(array($xmlrpcStruct,$xmlrpcString,$xmlrpcInt,$xmlrpcInt),
						      array($xmlrpcStruct,$xmlrpcString)),
				"docstring" => 'parameter should be array(string,int)',
			),
			"get_message" => array(
				"function" => "get_message_func",
			    "signature" => array( array($xmlrpcStruct,$xmlrpcString)),
				"docstring" => 'parameter should be array(string,int)',
			),
			"delete_message" => array(
				"function" => "delete_message_func",
				"signature" => array(array($xmlrpcStruct,$xmlrpcString)),
				"docstring" => 'parameter should be array(string,int)',
			),
			"get_board_stat" => array(
				"function" => "get_board_stat_func",
				"signature" => array(array($xmlrpcStruct)),
				"docstring" => 'no parameter',
			),
			"get_online_users" => array(
				"function" => "get_online_users_func",
				"signature" => array(array($xmlrpcStruct)),
				"docstring" => 'no parameter',
			),
		    'push_notify'    => array(
		         "function" => "push_notify_func",
   				 			 "signature" => array( array($xmlrpcStruct,$xmlrpcBase64,$xmlrpcString,$xmlrpcString)),
				"docstring" => 'parameter should be array(string,string)',
		    ),
		   'save_raw_post'    => array(
		         "function" => "save_raw_post_func",
   				 "signature" => array( array($xmlrpcStruct,$xmlrpcString,$xmlrpcBase64,$xmlrpcBase64)),
				"docstring" => 'parameter should be array(string,base64,base64)',
		    ),
		    'get_raw_post'    => array(
		         "function" => "get_raw_post_func",
   				 "signature" => array( array($xmlrpcStruct,$xmlrpcString)),
				"docstring" => 'parameter should be array(string)',
		    ),
		    'attach_image'    => array(
		    	 "function" => "attach_image_func",
		    	 "signature"=> array(array($xmlrpcStruct,$xmlrpcBase64,$xmlrpcBase64,$xmlrpcString,$xmlrpcString)),
		    	 "docstring" => 'parameter should be array(string,base64,base64,string,string)',
		   ),
	);
?>
