<?php

   error_reporting(E_ALL & ~E_NOTICE);
   if (!is_object($vbulletin->db))
   {
	   exit;
   }
   
   $vbulletin->db->hide_errors();
   
   /* Repair Tables As-Is */
   $vbulletin->db->query_write("REPAIR TABLES addonchat_settings, addonchat_who");
   
   sleep(1);

   /* Re-create tables should they not exist */
   $vbulletin->db->query_write("CREATE TABLE IF NOT EXISTS addonchat_who 
      (
         id INT UNSIGNED PRIMARY KEY NOT NULL AUTO_INCREMENT,
         username CHAR(48) NOT NULL,
         subroom CHAR(48) NOT NULL,
         hidden TINYINT(1) NOT NULL DEFAULT 0,
         uid INT UNSIGNED NOT NULL DEFAULT 0,
         admin TINYINT(1) NOT NULL DEFAULT 0
      ) 
      ENGINE=MyISAM CHARACTER SET utf8;");
      
   sleep(1);
      
   $vbulletin->db->query_write("CREATE TABLE IF NOT EXISTS addonchat_settings
      (
          account_id INT UNSIGNED NOT NULL DEFAULT 0,
          login_md5pass VARCHAR(32) NOT NULL DEFAULT '',
          language VARCHAR(8) NOT NULL DEFAULT 'en',
          settings_retrieved TINYINT(1) NOT NULL DEFAULT 0,
          login_email VARCHAR(64) NOT NULL DEFAULT '',   
          edition INT UNSIGNED NOT NULL DEFAULT 0,
          modules VARCHAR(128) NOT NULL DEFAULT '',
          ras_capable TINYINT(1) NOT NULL DEFAULT 0,
          edition_name VARCHAR(128) NOT NULL DEFAULT 'Unknown',
          expire_date DATE NOT NULL DEFAULT 0,
          ras_enabled TINYINT(1) NOT NULL DEFAULT 0,
          ras_url VARCHAR(128) NOT NULL DEFAULT 'http://',
          server_name VARCHAR(64) NOT NULL DEFAULT 'client0.addonchat.com',
          server_port INT UNSIGNED NOT NULL DEFAULT 8000,
          cpanel_login VARCHAR(255) NOT NULL DEFAULT 'http://',
          title VARCHAR(48) NOT NULL DEFAULT 'My Chat Room',
          account_id_fq VARCHAR(32) NOT NULL DEFAULT 'SC-0',
          customer_id_fq VARCHAR(32) NOT NULL DEFAULT 'RC-0',
          enable_auto_login TINYINT(1) NOT NULL DEFAULT 1,
          allow_unregistered_guests TINYINT(1) NOT NULL DEFAULT 0,
          url_exit VARCHAR(128) NOT NULL DEFAULT 'http://',
          width VARCHAR(8) NOT NULL DEFAULT '100%',
          height VARCHAR(8) NOT NULL DEFAULT 450,
          width_float INT UNSIGNED DEFAULT 620,
          height_float INT UNSIGNED DEFAULT 420,
          forum_url VARCHAR(255) NOT NULL DEFAULT 'http://',
          ef_profile TINYINT(1) NOT NULL DEFAULT 1,
          ef_find_posts TINYINT(1) NOT NULL DEFAULT 1,
          ef_email TINYINT(1) NOT NULL DEFAULT 1,
          ef_pm TINYINT(1) NOT NULL DEFAULT 1,
          ef_add_buddy TINYINT(1) NOT NULL DEFAULT 1,
          ef_forum_ignore TINYINT(1) NOT NULL DEFAULT 0,
          vb_enable_menu TINYINT(1) NOT NULL DEFAULT 1,
          vb_enable_embed TINYINT(1) NOT NULL DEFAULT 1,
          vb_enable_popup TINYINT(1) NOT NULL DEFAULT 1,
          vb_enable_whos_chatting TINYINT(1) NOT NULL DEFAULT 1,
          vb_enable_whos_chatting_main TINYINT(1) NOT NULL DEFAULT 0,          
          link_enable_tab TINYINT(1) NOT NULL DEFAULT 1,
          link_enable_community TINYINT(1) NOT NULL DEFAULT 1,
          link_enable_quick TINYINT(1) NOT NULL DEFAULT 0,
          link_show_user_count TINYINT(1) NOT NULL DEFAULT 1,          
          ef_blogs TINYINT(1) NOT NULL DEFAULT 0,
          ef_articles TINYINT(1) NOT NULL DEFAULT 0,
          ef_albums TINYINT(1) NOT NULL DEFAULT 0,                    
          applet_parameters TEXT,
          direct_settings TEXT
       ) 
       ENGINE=MyISAM CHARACTER SET utf8;");
       
   sleep(1);
      
   /* Do It Again */
   $vbulletin->db->query_write("REPAIR TABLES addonchat_settings, addonchat_who");      

   $vbulletin->db->show_errors();
   
   log_cron_action('', $nextitem, 1);

?>
