<?php

   error_reporting(E_ALL & ~E_NOTICE);

   require_once(DIR . '/includes/functions_addonchat.php');

   if (!is_object($vbulletin->db))
   {
	   exit;
   }
      
   $vbulletin->db->hide_errors();

   /* Load Account Settings */

   if($addonchat['account_query'] = $vbulletin->db->query_first("SELECT * FROM addonchat_settings"))
   {
      /* Load Account Settings into Array */
      foreach($addonchat['account_query'] as $key => $value)
         $addonchat[$key] = $value;

      /* Check if there is a valid account.. */
      if(intval($addonchat['account_id'])!=0)
      {
         /*
            If vb_enable_embed, vb_enable_popup, and vb_enable_whos_chatting are 
            all set to zero, the chat room is disabled.
         */
         if( ($addonchat['vb_enable_embed']==0) && ($addonchat['vb_enable_popup']==0) && ($addonchat['vb_enable_whos_chatting']==0) )
            $addonchat['enabled'] = 0;
         else
            $addonchat['enabled'] = 1;

         /* Populate Who's Chatting Table */
         if(intval($addonchat['enabled']) == 1)
         {
            if(intval($addonchat['vb_enable_whos_chatting'])!=0)
            {
               $vbulletin->db->query_write("TRUNCATE TABLE addonchat_who");
            
               $remote_file = "http://" . $addonchat['server_name'] . "/scwho.php?style=0" . 
                  "&id=" . intval($addonchat['account_id']) .
                  "&port=" . intval($addonchat['server_port']) . 
                  "&roompw=" . urlencode($addonchat['login_md5pass']);   
                  
               if( ($raw_user_list = addonchat_geturl($remote_file)) === FALSE)
               {
                  log_cron_action("Cannot read from remote server. Check allow_url_fopen setting in php.ini.", $nextitem, 1);
                  exit;
               }    
               
               foreach ($raw_user_list as $user_data)
               {
                  list($admin, $username, $subroomname, $uid) = explode("\t", $user_data);      

                  $insert_query = "INSERT INTO addonchat_who VALUES
                     (NULL,
                     \"" . addslashes($username)  . "\", 
                     \"" . addslashes($subroomname)  . "\", 
                     0, 
                     $uid, 
                     $admin)
                  ";

                  $vbulletin->db->query_write($insert_query);        
               }                                       
            }
         }                        
      }
   }
         
   $vbulletin->db->show_errors();
   
   log_cron_action('', $nextitem, 1);

?>
