<?php
/*======================================================================*\
|| #################################################################### ||
|| # Modification-System                                              # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2008 php-unlimited. All Rights Reserved.              # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| #                   http://www.php-unlimited.com                   # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);
@set_time_limit(0);

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('CVS_REVISION', '$RCSfile$ - $Revision: 26624 $');
@ini_set('display_errors', true);

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array ('modsystem','stats','maintenance');
$specialtemplates = array ();

// ########################## REQUIRE BACK-END ############################
require_once ('./global.php');
require_once (DIR . '/includes/functions_album.php');
require_once (DIR . '/includes/modsystem_functions.php');
require_once (DIR . '/includes/adminfunctions_attachment.php');
require_once (DIR . '/includes/adminfunctions_options.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer ('canadminmodsystem')) print_cp_no_permission ();

// ############################# LOG ACTION ###############################
log_admin_action();

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

print_cp_header ($vbphrase['modsystem_admin_title']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'counter';
}

if ($vbulletin->options['modsettings_motm_start'] == 0)
{
	$n = date ('n', time ());
	$y = date ('Y', time ());
	if ($n == 1)
	{
		$y--;
		$n = 12;
	}
	else $n--;
	$motm_date = strtotime ('1.' . $n . '.' . $y);
	$motm = $db->query_first ("SELECT `varname` FROM `" . TABLE_PREFIX . "setting` WHERE `varname`='modsettings_motm_start'");
	if (!$motm['varname']) $db->query("INSERT INTO `" . TABLE_PREFIX . "setting` VALUES ('modsettings_motm_start','modsettings','" . $motm_date . "','','','0','1','0','number','modsystem','','0')");
	else $db->query("UPDATE `" . TABLE_PREFIX . "setting` SET `value`='" . $motm_date . "' WHERE `varname`='modsettings_motm_start'");

	build_options ();

	print_cp_redirect("options.php?" . $vbulletin->session->vars['sessionurl'] . "do=options&amp;dogroup=modsettings");
	echo "<p><a href=\"options.php?" . $vbulletin->session->vars['sessionurl'] . "do=options&amp;dogroup=modsettings\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";

//	$db->query("INSERT INTO `" . TABLE_PREFIX . "setting` VALUES ('modsettings_do_motm','modsettings','0','','','0','1','0','number','modsystem','','0')");
}

$vbulletin->input->clean_array_gpc('r', array(
	'do'                => TYPE_STR,
	'so'                => TYPE_STR,
	'type'              => TYPE_STR,
	'send'              => TYPE_STR,
	'title'             => TYPE_STR,
	'title_clean'       => TYPE_STR,
	'licence'           => TYPE_STR,
	'doedit'            => TYPE_INT,
	'modversion'        => TYPE_STR,
	'versionid'         => TYPE_INT,
	'coderid'           => TYPE_INT,
	'mincount'          => TYPE_INT,
	'maxcount'          => TYPE_INT,
	'designerid'        => TYPE_INT,
	'licenceid'         => TYPE_INT,
	'modsys_versionsid' => TYPE_UINT,
	'modsys_licencesid' => TYPE_UINT,
	'start'             => TYPE_ARRAY_UINT,
	'end'               => TYPE_ARRAY_UINT,
	'perpage'           => TYPE_UINT,
	'startat'           => TYPE_UINT
));

if ($vbulletin->GPC['do'] == 'coder')
{
	if ($vbulletin->GPC['send'] == 'send' AND $vbulletin->GPC['title'])
	{
		$vbulletin->GPC['do'] = '';
		if ($vbulletin->GPC['doedit'] AND $vbulletin->GPC['coderid'])
		{
			$db->query_write ("UPDATE " . TABLE_PREFIX . "modsys_coder SET 
				title      ='" . $db->escape_string ($vbulletin->GPC['title']) . "', 
				title_clean='" . $db->escape_string ($vbulletin->GPC['title_clean']) . "',
				mincount   =" . intval ($vbulletin->GPC['mincount']) . ",
				maxcount   =" . intval ($vbulletin->GPC['maxcount']) . "
				WHERE id=" . intval ($vbulletin->GPC['coderid']) . "
			");
		}
		else
		{
			$db->query_write ("INSERT INTO " . TABLE_PREFIX . "modsys_coder 
				(title,title_clean,mincount,maxcount) 
				VALUES 
				('" . $db->escape_string ($vbulletin->GPC['title']) . "','" . $db->escape_string ($vbulletin->GPC['title_clean']) . "'," . intval ($vbulletin->GPC['mincount']) . "," . intval ($vbulletin->GPC['maxcount']) . ") 
			");
		}
		datastore_cd_titles ('coder');
	}

	if ($vbulletin->GPC['so'] == 'delete')
	{
		$db->query_write ("DELETE FROM " . TABLE_PREFIX . "modsys_coder WHERE id=" . intval ($vbulletin->GPC['coderid']));

		datastore_cd_titles ('coder');
	}

	if ($vbulletin->GPC['so'] == 'edit')
	{
		$doedit = 1;
		$code = $db->query_first ("SELECT * FROM " . TABLE_PREFIX . "modsys_coder WHERE id=" . intval ($vbulletin->GPC['coderid']));
	}

	print_form_header ('modsystem_admin', 'coder');
	print_table_header ($vbphrase['modsystem_admin_coder_level'], 5);
	print_description_row ($vbphrase['modsystem_admin_cs_desc'], 0, 5);
	print_cells_row (array ($vbphrase['modsystem_admin_licence_title'], $vbphrase['modsystem_admin_cs_usertitle'], $vbphrase['modsystem_admin_cs_min'], $vbphrase['modsystem_admin_cs_max'], $vbphrase['modsystem_admin_licence_controls']), 1, 'tcat');

	$mc = 0;
	$coders = $db->query_read ("SELECT * FROM " . TABLE_PREFIX . "modsys_coder ORDER BY mincount ASC, maxcount ASC, title ASC");
	while ($coder = $db->fetch_array ($coders))
	{
		$mc++;
		print_cells_row (array ($coder['title'], 
			$coder['title_clean'], 
			$coder['mincount'], $coder['maxcount'], 
			construct_link_code ($vbphrase['edit'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=coder&amp;so=edit&amp;coderid=$coder[id]") .
			construct_link_code ($vbphrase['delete'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=coder&amp;so=delete&amp;coderid=$coder[id]")
		));
	}
	if (!$mc)
	{
		print_description_row ($vbphrase['modsystem_admin_coder_no'], 0, 5);
	}
	print_table_footer();

	print_form_header ('modsystem_admin', 'coder');
	construct_hidden_code ('send', 'send');
	construct_hidden_code ('doedit', $doedit);
	construct_hidden_code ('coderid', $code['id']);
	print_table_header ($vbphrase['modsystem_admin_coder_usertitle']);
	print_input_row ($vbphrase['modsystem_admin_cs_leveltitle'], 'title', $code['title'], 1, 30);
	print_input_row ($vbphrase['modsystem_admin_coder_usertitle'], 'title_clean', $code['title_clean'], 1, 30);
	print_input_row ($vbphrase['modsystem_admin_coder_min'], 'mincount', $code['mincount'], 1, 30);
	print_input_row ($vbphrase['modsystem_admin_coder_max'], 'maxcount', $code['maxcount'], 1, 30);
	if ($doedit) print_submit_row ($vbphrase['save']);
	else print_submit_row ($vbphrase['add']);
}

if ($vbulletin->GPC['do'] == 'designer')
{
	if ($vbulletin->GPC['send'] == 'send' AND $vbulletin->GPC['title'])
	{
		$vbulletin->GPC['do'] = '';
		if ($vbulletin->GPC['doedit'] AND $vbulletin->GPC['designerid'])
		{
			$db->query_write ("UPDATE " . TABLE_PREFIX . "modsys_designer SET 
				title      ='" . $db->escape_string ($vbulletin->GPC['title']) . "', 
				title_clean='" . $db->escape_string ($vbulletin->GPC['title_clean']) . "',
				mincount   =" . intval ($vbulletin->GPC['mincount']) . ",
				maxcount   =" . intval ($vbulletin->GPC['maxcount']) . "
				WHERE id=" . intval ($vbulletin->GPC['designerid']) . "
			");
		}
		else
		{
			$db->query_write ("INSERT INTO " . TABLE_PREFIX . "modsys_designer
				(title,title_clean,mincount,maxcount) 
				VALUES 
				('" . $db->escape_string ($vbulletin->GPC['title']) . "','" . $db->escape_string ($vbulletin->GPC['title_clean']) . "'," . intval ($vbulletin->GPC['mincount']) . "," . intval ($vbulletin->GPC['maxcount']) . ") 
			");
		}

		datastore_cd_titles ('style');
	}

	if ($vbulletin->GPC['so'] == 'delete')
	{
		$db->query_write ("DELETE FROM " . TABLE_PREFIX . "modsys_designer WHERE id=" . intval ($vbulletin->GPC['designerid']));

		datastore_cd_titles ('style');
	}

	if ($vbulletin->GPC['so'] == 'edit')
	{
		$doedit = 1;
		$desi = $db->query_first ("SELECT * FROM " . TABLE_PREFIX . "modsys_designer WHERE id=" . intval ($vbulletin->GPC['designerid']));
	}

	print_form_header ('modsystem_admin', 'designer');
	print_table_header ($vbphrase['modsystem_admin_designer_level'], 5);
	print_description_row ($vbphrase['modsystem_admin_cs_desc'], 0, 5);
	print_cells_row (array ($vbphrase['modsystem_admin_licence_title'], $vbphrase['modsystem_admin_cs_usertitle'], $vbphrase['modsystem_admin_cs_min'], $vbphrase['modsystem_admin_cs_max'], $vbphrase['modsystem_admin_licence_controls']), 1, 'tcat');

	$mc = 0;
	$designers = $db->query_read ("SELECT * FROM " . TABLE_PREFIX . "modsys_designer ORDER BY mincount ASC, maxcount ASC, title ASC");
	while ($designer = $db->fetch_array ($designers))
	{
		$mc++;
		print_cells_row (array ($designer['title'], 
			$designer['title_clean'], 
			$designer['mincount'], $designer['maxcount'], 
			construct_link_code ($vbphrase['edit'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=designer&amp;so=edit&amp;designerid=$designer[id]") .
			construct_link_code ($vbphrase['delete'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=designer&amp;so=delete&amp;designerid=$designer[id]")
		));
	}
	if (!$mc)
	{
		print_description_row ($vbphrase['modsystem_admin_designer_no'], 0, 5);
	}
	print_table_footer();

	print_form_header ('modsystem_admin', 'designer');
	construct_hidden_code ('send', 'send');
	construct_hidden_code ('doedit', $doedit);
	construct_hidden_code ('designerid', $desi['id']);
	print_table_header ($vbphrase['modsystem_admin_designer_usertitle']);
	print_input_row ($vbphrase['modsystem_admin_cs_leveltitle'], 'title', $desi['title'], 1, 30);
	print_input_row ($vbphrase['modsystem_admin_designer_usertitle'], 'title_clean', $desi['title_clean'], 1, 30);
	print_input_row ($vbphrase['modsystem_admin_coder_min'], 'mincount', $desi['mincount'], 1, 30);
	print_input_row ($vbphrase['modsystem_admin_coder_max'], 'maxcount', $desi['maxcount'], 1, 30);
	if ($doedit) print_submit_row ($vbphrase['save']);
	else print_submit_row ($vbphrase['add']);
}

if ($vbulletin->GPC['do'] == 'counter')
{
	print_form_header ('modsystem_admin', 'create_oldthread', 0, 1, 'statform');
	print_table_header ($vbphrase['modsystem_admin_counter_settings_title'], 2);
	print_description_row ($vbphrase['modsystem_admin_counter_settings_desc'], 0, 2);
	print_input_row ($vbphrase['modsystem_admin_counter_input'], 'perpage', 1000, 1, 30);
	print_submit_row ($vbphrase['modsystem_admin_counter_submit']);

	print_form_header ('modsystem_admin', 'doublethreads', 0, 1, 'statform');
	print_table_header ($vbphrase['modsystem_admin_counter_doublethread_title'], 2);
	print_description_row ($vbphrase['modsystem_admin_counter_doublethread_desc'], 0, 2);
	print_input_row ($vbphrase['modsystem_admin_counter_coder_input'], 'perpage', 1000, 1, 30);
	print_submit_row ($vbphrase['modsystem_admin_counter_doublethread_submit']);

	print_form_header ('modsystem_admin', 'rebuild_stats_c', 0, 1, 'statform');
	print_table_header ($vbphrase['modsystem_admin_counter_coder_title'], 2);
	print_input_row ($vbphrase['modsystem_admin_counter_coder_input'], 'perpage', 1000, 1, 30);
	print_submit_row ($vbphrase['modsystem_admin_counter_coder_title']);

	print_form_header ('modsystem_admin', 'rebuild_stats_d', 0, 1, 'statform');
	print_table_header ($vbphrase['modsystem_admin_counter_designer_title'], 2);
	print_input_row ($vbphrase['modsystem_admin_counter_coder_input'], 'perpage', 1000, 1, 30);
	print_submit_row ($vbphrase['modsystem_admin_counter_designer_title']);

	print_form_header ('modsystem_admin', 'rebuild_datastore', 0, 1, 'statform');
	print_table_header ($vbphrase['modsystem_admin_counter_datastore_title'], 2);
	print_description_row ($vbphrase['modsystem_admin_counter_datastore_desc'], 0, 2);
	print_submit_row ($vbphrase['modsystem_admin_counter_datastore_title']);
}

if ($vbulletin->GPC['do'] == 'doublethreads')
{
	$notifications = $db->query_read ("SELECT 
		DISTINCT threadid, userid 
		FROM " . TABLE_PREFIX . "modsys_user_notification 
		ORDER BY userid 
		LIMIT " . $vbulletin->GPC['perpage']
	);

	$finishat = $vbulletin->GPC['startat'];

	while ($notify = $db->fetch_array ($notifications))
	{
		$usern = $db->query_read ("SELECT * FROM " . TABLE_PREFIX . "modsys_user_notification WHERE userid=" . $notify['userid'] . " AND threadid=" . $notify['threadid']);
		$notify['count'] = $db->num_rows ($usern);

		$notify_array = '';
		if ($notify['count'] > 1)
		{
			$notify_array = array (
				'threadid'       => $notify['threadid'],
				'userid'         => $notify['userid'],
				'nominate_date'  => 0,
				'mod_downloaded' => 0,
				'mod_installed'  => 0,
				'mod_nominated'  => 0,
				'mod_tagged'     => 0,
				'auto_notify'    => 0,
				'manual_notify'  => 0,
				'pm_notify'      => 0
			);
			while ($user = $db->fetch_array ($usern))
			{
				if (!$notify_array['nominate_date'] AND $user['nominate_date']) $notify_array['nominate_date'] = $user['nominate_date'];

				if (!$notify_array['nominate_date'] AND $user['nominate_date']) $notify_array['nominate_date'] = $user['nominate_date'];
				if (!$notify_array['mod_downloaded'] AND $user['mod_downloaded']) $notify_array['mod_downloaded'] = $user['mod_downloaded'];
				if (!$notify_array['mod_installed'] AND $user['mod_installed']) $notify_array['mod_installed'] = $user['mod_installed'];
				if (!$notify_array['mod_nominated'] AND $user['mod_nominated']) $notify_array['mod_nominated'] = $user['mod_nominated'];
				if (!$notify_array['mod_tagged'] AND $user['mod_tagged']) $notify_array['mod_tagged'] = $user['mod_tagged'];
				if (!$notify_array['auto_notify'] AND $user['auto_notify']) $notify_array['auto_notify'] = $user['auto_notify'];
				if (!$notify_array['manual_notify'] AND $user['manual_notify']) $notify_array['manual_notify'] = $user['manual_notify'];
				if (!$notify_array['pm_notify'] AND $user['pm_notify']) $notify_array['pm_notify'] = $user['pm_notify'];
			}
		}

		if (is_array ($notify_array))
		{
			$query_fields = $query_values = array ();
			foreach ($notify_array as $key => $val)
			{
				$query_fields[] = $key;
				$query_values[] = intval ($val);
			}
			if (!empty ($query_fields))
			{
				$db->query ("DELETE FROM " . TABLE_PREFIX . "modsys_user_notification WHERE userid=" . $notify['userid'] . " AND threadid=" . $notify['threadid']);
				$db->query ("INSERT INTO " . TABLE_PREFIX . "modsys_user_notification 
					(" . implode (',', $query_fields) . ") 
					VALUES 
					(" . implode (',', $query_values) . ")
				");
			}
		}

		$finishat = ($thread['userid'] > $finishat ? $thread['userid'] : $finishat);
	}

	if ($finishat != $vbulletin->GPC['startat'])
	{
		$finishat++;
		$checkmore = $db->query_first("SELECT userid FROM " . TABLE_PREFIX . "modsys_user_notification WHERE userid >= " . $finishat . " LIMIT 1");
	}
	else $checkmore = 0;

	if ($checkmore)
	{
		print_cp_redirect("modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=doublethreads&startat=" . $finishat . "&pp=" . $vbulletin->GPC['perpage']);
		echo "<p><a href=\"modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=doublethreads&amp;startat=" . $finishat . "&amp;pp=" . $vbulletin->GPC['perpage'] . "\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";
	}
	else
	{
		define('CP_REDIRECT', 'modsystem_admin.php');
		print_stop_message ('modsystem_update_settings_ok');
	}
}
else if ($vbulletin->GPC['do'] == 'create_oldthread')
{
	if ($vbulletin->options['modsettings_forumids'] == '' OR !$vbulletin->options['modsettings_forumids'])
	{
		print_stop_message ('modsystem_no_forumids');
	}
	else
	{
		$forumids = explode (',', $vbulletin->options['modsettings_forumids']);

		$threads = $db->query_read ("SELECT
			thread.forumid,thread.threadid,thread.title,thread.firstpostid,thread.postuserid,
			post.dateline,user.username,
			modification.threadid AS mthreadid
			FROM " . TABLE_PREFIX . "thread AS thread 
			LEFT JOIN " . TABLE_PREFIX . "user AS user ON (user.userid=thread.postuserid) 
			LEFT JOIN " . TABLE_PREFIX . "post AS post ON (post.postid=thread.firstpostid) 
			LEFT JOIN " . TABLE_PREFIX . "modsys_settings AS modification ON (modification.threadid=thread.threadid) 
			WHERE thread.threadid >= " . $vbulletin->GPC['startat'] . "
			AND thread.forumid IN (0," . $vbulletin->options['modsettings_forumids'] . ") 
			LIMIT " . $vbulletin->GPC['perpage']
		);

		$finishat = $vbulletin->GPC['startat'];

		while ($thread = $db->fetch_array ($threads))
		{
			$x = 0;

			// create the missing settings from older threads
			if ($thread['dateline'] AND $thread['postuserid'] AND !$thread['mthreadid'])
			{
				$x = 1;
				$db->query("
					INSERT INTO " . TABLE_PREFIX . "modsys_settings 
					(threadid, author, dateline) 
					VALUES 
					(" . $thread['threadid'] . "," . $thread['postuserid'] . "," . $thread['dateline'] . ")
				");
				echo construct_phrase ($vbphrase['processing_x'], $thread['threadid']) . "<br />\n";
				vbflush();
			}

			$tid = $thread['threadid'];
			if ($x) $tid = $db->insert_id();

			// update counters
			$user_info = $db->query_read ("SELECT 
				uno.threadid,SUM(uno.mod_installed) AS installs, 
				modification.author 
				FROM " . TABLE_PREFIX . "modsys_user_notification as uno 
				LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON (thread.threadid=uno.threadid) 
				LEFT JOIN " . TABLE_PREFIX . "modsys_settings AS modification ON (modification.threadid=thread.threadid) 
				WHERE uno.threadid=" . intval ($tid) . " 
				GROUP BY thread.threadid
			");
			while ($ui = $db->fetch_array ($user_info))
			{
				$db->query ("UPDATE " . TABLE_PREFIX . "modsys_settings SET mod_installcount=" . $ui['installs'] . " WHERE threadid=" . $ui['threadid']);
			}

			$finishat = ($thread['threadid'] > $finishat ? $thread['threadid'] : $finishat);
		}
	}

	if ($finishat != $vbulletin->GPC['startat'])
	{
		$finishat++;
		$checkmore = $db->query_first("SELECT threadid FROM " . TABLE_PREFIX . "thread WHERE threadid >= " . $finishat . " LIMIT 1");
	}
	else $checkmore = 0;

	if ($checkmore)
	{
		print_cp_redirect("modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=create_oldthread&startat=" . $finishat . "&pp=" . $vbulletin->GPC['perpage']);
		echo "<p><a href=\"modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=create_oldthread&amp;startat=" . $finishat . "&amp;pp=" . $vbulletin->GPC['perpage'] . "\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";
	}
	else
	{
		define('CP_REDIRECT', 'modsystem_admin.php');
		print_stop_message ('modsystem_update_settings_ok');
	}

}
else if ($vbulletin->GPC['do'] == 'rebuild_datastore')
{
	require_once (DIR . '/includes/modsystem_functions.php');

	mode_create_datastore ('coder', 1);
	mode_create_datastore ('style', 1);
	mode_create_datastore ('motm', 1);

	define('CP_REDIRECT', 'modsystem_admin.php');
	print_stop_message ('modsystem_datastore_ok');
}
else if ($vbulletin->GPC['do'] == 'rebuild_stats_c')
{
	$coder = 0;
	$rebuild_do = $vbulletin->GPC['do'];
	$vbulletin->GPC['do'] = 'rebuild_stats_cd';
	$fids = $vbulletin->options['modsettings_coder'];
}
else if ($vbulletin->GPC['do'] == 'rebuild_stats_d')
{
	$coder = 1;
	$rebuild_do = $vbulletin->GPC['do'];
	$vbulletin->GPC['do'] = 'rebuild_stats_cd';
	$fids = $vbulletin->options['modsettings_designer'];
}

if ($vbulletin->GPC['do'] == 'rebuild_stats_cd')
{

	if (empty ($vbulletin->GPC['perpage']))
	{
		$vbulletin->GPC['perpage'] = 1000;
	}

	echo '<p>' . $vbphrase['modsystem_admin_rebuild'] . ' - ' . (!$coder ? $vbphrase['modsystem_admin_rebuild_coder'] : $vbphrase['modsystem_admin_rebuild_designer']) . '</p>';
	if ($fids != '')
	{
		$ci_counter = $db->query_read ("SELECT
			COUNT(modification.id) AS installed,modification.author,thread.forumid  
			FROM `" . TABLE_PREFIX . "modsys_settings` AS modification 
			LEFT JOIN `" . TABLE_PREFIX . "thread` AS thread ON(thread.threadid=modification.threadid) 
			WHERE modification.author >= " . $vbulletin->GPC['startat'] . "
			AND thread.forumid IN (0," . $fids . ")
			GROUP BY modification.author 
			LIMIT " . $vbulletin->GPC['perpage']
		);

		$finishat = $vbulletin->GPC['startat'];

		if ($db->num_rows ($ci_counter))
		{
			while ($counter = $db->fetch_array ($ci_counter))
			{
				if (!$coder)
				{
					$db->query ("UPDATE `" . TABLE_PREFIX . "user` SET `codercount`=" . $counter['installed'] . " WHERE `userid`=" . $counter['author']);
				}
				else
				{
					$db->query ("UPDATE `" . TABLE_PREFIX . "user` SET `designercount`=" . $counter['installed'] . " WHERE `userid`=" . $counter['author']);
				}

				echo construct_phrase ($vbphrase['processing_x'], $counter['author']) . "<br />\n";
				vbflush ();

				$finishat = ($counter['author'] > $finishat ? $counter['author'] : $finishat);
			}

			$finishat++;
		}

		if ($db->num_rows ($ci_counter))
		{
			$checkmore = $db->query_first("SELECT author FROM " . TABLE_PREFIX . "modsys_settings WHERE author >= " . $finishat . " LIMIT 1");
		}
		else
		{
			$checkmore = 0;
		}

		if ($checkmore)
		{
			print_cp_redirect("modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=$rebuild_do&startat=" . $finishat . "&pp=" . $vbulletin->GPC['perpage']);
			echo "<p><a href=\"modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=$rebuild_do&amp;startat=" . $finishat . "&amp;pp=" . $vbulletin->GPC['perpage'] . "\">" . $vbphrase['click_here_to_continue_processing'] . "</a></p>";
		}
		else
		{
			define('CP_REDIRECT', 'modsystem_admin.php');
			print_stop_message ('modsystem_rebuild_stats_ok');
		}

	}
}

if ($vbulletin->GPC['do'] == 'statistic')
{
	if (empty ($vbulletin->GPC['start'])) $vbulletin->GPC['start'] = TIMENOW - 3600 * 24 * 365;
	if (empty ($vbulletin->GPC['end']))   $vbulletin->GPC['end']   = TIMENOW;

	print_form_header ('modsystem_admin', 'statistic', 0, 1, 'statform');
	construct_hidden_code ('type', 'stats');
	print_table_header ($vbphrase['modsystem_admin_motms'], 2);
	print_time_row ($vbphrase['start_date'], 'start', $vbulletin->GPC['start'], false);
	print_time_row ($vbphrase['end_date'], 'end', $vbulletin->GPC['end'], false);
	print_submit_row ($vbphrase['go']);

	if ($vbulletin->GPC['type'] == 'stats')
	{
		$condition = array ();
		$start_time = mktime (0, 0, 0, $vbulletin->GPC['start']['month'], 1, $vbulletin->GPC['start']['year']);
		$t = date ('t', $start_time);
		$end_time   = mktime (23, 59, 59, $vbulletin->GPC['end']['month'], $t, $vbulletin->GPC['end']['year']);
		$modifications = $db->query_read ("SELECT 
			motm.threadid,motm.dateline,motm.nominatecount,thread.title 
			FROM " . TABLE_PREFIX . "modsys_motm AS motm 
			LEFT JOIN " . TABLE_PREFIX . "thread AS thread ON(thread.threadid=motm.threadid) 
			WHERE motm.dateline BETWEEN " . $start_time . " AND " . $end_time . " 
			ORDER BY motm.nominatecount DESC
		");
		if ($db->num_rows ($modifications) != 0)
		{
			print_table_break ();
			print_table_header ($vbphrase['modsystem_admin_motms'], 3);
			print_cells_row (array ($vbphrase['modsystem_admin_licence_title'], $vbphrase['modsystem_admin_date'], $vbphrase['modsystem_admin_votes']), 1, 'tcat');
			while ($mod = $db->fetch_array ($modifications))
			{
				print_cells_row (array ($mod['title'], date ('F Y', $mod['dateline']), $mod['nominatecount']));
			}
			print_table_footer ();
		}
		else print_stop_message ('no_matches_found');
	}
	else
	{
		$n = date ('n', TIMENOW);
		$y = date ('Y', TIMENOW);
		$start = strtotime ('1.' . $n . '.' . $y);
		$t = date ('t', $start);
		$end = strtotime ($t . '.' . $n . '.' . $y);
		$n++;
		if ($n > 12)
		{
			$n = $n - 12;
			$y++;
		}
		$nt = strtotime ('1.' . $n . '.' . $y);
		$mc = 0;
		print_table_break ();
		print_table_header (construct_phrase ($vbphrase['modsystem_admin_curent_nominations'], date ('F Y', $nt)), 2);
		print_cells_row (array ($vbphrase['modsystem_admin_licence_title'], $vbphrase['modsystem_admin_nominations']), 1, 'tcat');
		$modifications = $db->query_read ("SELECT 
			SUM(un.mod_nominated) AS ncount,un.threadid,ms.author,t.title 
			FROM " . TABLE_PREFIX . "modsys_user_notification AS un 
			LEFT JOIN " . TABLE_PREFIX . "modsys_settings as ms ON(ms.threadid=un.threadid) 
			LEFT JOIN " . TABLE_PREFIX . "thread AS t ON(t.threadid=un.threadid) 
			WHERE un.nominate_date BETWEEN " . $start . " AND " . $end . "
			AND ms.motm=0 
			GROUP BY un.threadid 
			ORDER BY ncount DESC 
		");
		while ($mod = $db->fetch_array ($modifications))
		{
			$mc++;
			print_cells_row (array ($mod['title'], $mod['ncount']));
		}
		if (!$mc)
		{
			print_description_row ($vbphrase['modsystem_admin_no_nominations'], 0, 2);
		}
		print_table_footer ();
	}
}

if ($vbulletin->GPC['do'] == 'licencekill')
{
	$db->query_write ("DELETE FROM " . TABLE_PREFIX . "modsys_licences WHERE modsys_licencesid=" . intval ($vbulletin->GPC['modsys_licencesid']));
	$vbulletin->GPC['do'] = 'licence';
}

if ($vbulletin->GPC['do'] == 'licence')
{
	if ($vbulletin->GPC['send'] == 'send' AND $vbulletin->GPC['title'])
	{
		$vbulletin->GPC['do'] = '';
		if ($vbulletin->GPC['doedit'] AND $vbulletin->GPC['licenceid'])
		{
			$db->query_write ("UPDATE " . TABLE_PREFIX . "modsys_licences SET 
				title  ='" . $db->escape_string ($vbulletin->GPC['title']) . "', 
				licence='" . $db->escape_string ($vbulletin->GPC['licence']) . "' 
				WHERE modsys_licencesid=" . intval ($vbulletin->GPC['licenceid']) . "
			");
		}
		else
		{
			$db->query_write ("INSERT INTO " . TABLE_PREFIX . "modsys_licences 
				(title,licence) 
				VALUES 
				('" . $db->escape_string ($vbulletin->GPC['title']) . "','" . $db->escape_string ($vbulletin->GPC['licence']) . "') 
			");
		}
	}

	if ($vbulletin->GPC['so'] == 'delete')
	{
		print_delete_confirmation ('modsys_licences', $vbulletin->GPC['licenceid'], 'modsystem_admin', 'licencekill', '', 0, '', 'title');
		exit ();
	}

	if ($vbulletin->GPC['so'] == 'edit')
	{
		$doedit = 1;
		$lice = $db->query_first ("SELECT * FROM " . TABLE_PREFIX . "modsys_licences WHERE modsys_licencesid=" . intval ($vbulletin->GPC['licenceid']));
	}

	print_form_header ('modsystem_admin', 'licence');
	print_table_header ($vbphrase['modsystem_admin_licence_currently'], 3);
	print_cells_row (array ($vbphrase['modsystem_admin_licence_title'], $vbphrase['modsystem_admin_licence_licence'], $vbphrase['modsystem_admin_licence_controls']), 1, 'tcat');

	$mc = 0;
	$licences = $db->query_read ("SELECT * FROM " . TABLE_PREFIX . "modsys_licences ORDER BY title DESC");
	while ($licence = $db->fetch_array ($licences))
	{
		$mc++;
		print_cells_row (array ($licence['title'], 
			$licence['licence'], 
			construct_link_code ($vbphrase['edit'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=licence&amp;so=edit&amp;licenceid=$licence[modsys_licencesid]") .
			construct_link_code ($vbphrase['delete'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=licence&amp;so=delete&amp;licenceid=$licence[modsys_licencesid]")
		));
	}
	if (!$mc)
	{
		print_description_row ($vbphrase['modsystem_admin_licence_nolicence'], 0, 3);
	}
	print_table_footer();

	print_form_header ('modsystem_admin', 'licence');
	construct_hidden_code ('send', 'send');
	construct_hidden_code ('doedit', $doedit);
	construct_hidden_code ('licenceid', $lice['modsys_licencesid']);
	print_table_header ($vbphrase['modsystem_admin_licence_modification_title']);
	print_input_row ($vbphrase['modsystem_admin_licence_enter_title'], 'title', $lice['title'], 1, 30);
	print_textarea_row ($vbphrase['modsystem_admin_licence_enter_desc'], 'licence', $lice['licence']);
	if ($doedit) print_submit_row ($vbphrase['save']);
	else print_submit_row ($vbphrase['add']);
}

if ($vbulletin->GPC['do'] == 'versionkill')
{
	$db->query_write ("DELETE FROM " . TABLE_PREFIX . "modsys_versions WHERE modsys_versionsid=" . intval ($vbulletin->GPC['modsys_versionsid']));
	$vbulletin->GPC['do'] = 'version';
}

if ($vbulletin->GPC['do'] == 'version')
{
	if ($vbulletin->GPC['send'] == 'send' AND $vbulletin->GPC['modversion'])
	{
		$vbulletin->GPC['do'] = '';
		if ($vbulletin->GPC['doedit'] AND $vbulletin->GPC['versionid'])
		{
			$db->query_write ("UPDATE " . TABLE_PREFIX . "modsys_versions SET modversion='" . $db->escape_string ($vbulletin->GPC['modversion']) . "' WHERE modsys_versionsid=" . intval ($vbulletin->GPC['versionid']));
		}
		else
		{
			$db->query_write ("INSERT INTO " . TABLE_PREFIX . "modsys_versions 
				(modversion) VALUES ('" . $db->escape_string ($vbulletin->GPC['modversion']) . "') 
			");
		}
	}

	if ($vbulletin->GPC['so'] == 'delete')
	{
		print_delete_confirmation ('modsys_versions', $vbulletin->GPC['versionid'], 'modsystem_admin', 'versionkill', '', 0, '', 'modversion');
		exit ();
	}

	if ($vbulletin->GPC['so'] == 'edit')
	{
		$doedit = 1;
		$modversion = $db->query_first ("SELECT * FROM " . TABLE_PREFIX . "modsys_versions WHERE modsys_versionsid=" . intval ($vbulletin->GPC['versionid']));
	}

	print_form_header ('modsystem_admin', 'version');
	print_table_header ($vbphrase['modsystem_admin_version_currently'], 2);
	print_cells_row (array ($vbphrase['modsystem_admin_version_version'], $vbphrase['modsystem_admin_licence_controls']), 1, 'tcat');

	$mc = 0;
	$modversions = $db->query_read ("SELECT * FROM " . TABLE_PREFIX . "modsys_versions ORDER BY modversion DESC");
	while ($modv = $db->fetch_array ($modversions))
	{
		$mc++;
		print_cells_row (array ($modv['modversion'], 
			construct_link_code ($vbphrase['edit'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=version&amp;so=edit&amp;versionid=$modv[modsys_versionsid]") .
			construct_link_code ($vbphrase['delete'], "modsystem_admin.php?" . $vbulletin->session->vars['sessionurl'] . "do=version&amp;so=delete&amp;versionid=$modv[modsys_versionsid]")
		));
	}
	if (!$mc)
	{
		print_description_row ($vbphrase['modsystem_admin_version_noversion'], 0, 2);
	}
	print_table_footer();

	print_form_header ('modsystem_admin', 'version');
	construct_hidden_code ('send', 'send');
	construct_hidden_code ('doedit', $doedit);
	construct_hidden_code ('versionid', $modversion['modsys_versionsid']);
	print_table_header ($vbphrase['modsystem_admin_version_enter_title']);
	print_input_row ($vbphrase['modsystem_admin_version_enter_desc'], 'modversion', $modversion['modversion'], 1, 30);
	if ($doedit) print_submit_row ($vbphrase['save']);
	else print_submit_row ($vbphrase['add']);
}

if ($vbulletin->GPC['do'] == 'log')
{
	$vbulletin->input->clean_array_gpc ('r', array (
		'limitstart'   => TYPE_UINT,
		'limitnumber'  => TYPE_UINT,
		'logid'        => TYPE_ARRAY_INT,
	));

	if ($vbulletin->GPC['send'] == 'delete')
	{
		$vbulletin->GPC['limitstart'] = 0;
		if (!empty ($vbulletin->GPC['logid']))
		{
			foreach ($vbulletin->GPC['logid'] AS $key => $val)
			{
				$db->query_write ("DELETE FROM " . TABLE_PREFIX . "modsys_logs WHERE id=" . intval ($key));
			}
		}
	}

	if (empty ($vbulletin->GPC['limitstart']))
	{
		$vbulletin->GPC['limitstart'] = 0;
	}
	else
	{
		$vbulletin->GPC['limitstart']--;
	}
	$limit = 20;

	print_form_header ('modsystem_admin', 'log');
	construct_hidden_code ('send', 'send');
	print_table_header ($vbphrase['modsystem_admin_dllogs'], 5);
	print_cells_row (array ($vbphrase['modsystem_admin_id'], $vbphrase['modsystem_admin_username'], $vbphrase['modsystem_admin_filename'], $vbphrase['date'], ''), 1, 'tcat');
	$logs = $db->query_read ("SELECT 
		logs.*,user.username,attachment.filename 
		FROM " . TABLE_PREFIX . "modsys_logs AS logs 
		LEFT JOIN " . TABLE_PREFIX . "user AS user ON (user.userid=logs.userid) 
		LEFT JOIN " . TABLE_PREFIX . "attachment AS attachment ON (attachment.attachmentid=logs.threadid) 
		ORDER BY user.username ASC, logs.dateline ASC, attachment.filename ASC
		LIMIT " . $vbulletin->GPC['limitstart'] . "," . $limit
	);
	$countids = $db->query_first ("SELECT COUNT(*) AS logs FROM " . TABLE_PREFIX . "modsys_logs");

	$limitfinish = $vbulletin->GPC['limitstart'] + $limit;

	if ($db->num_rows ($logs))
	{
		while ($log = $db->fetch_array ($logs))
		{
			print_cells_row (
				array
				(
					$log['id'],
					$log['username'], 
					$log['filename'],
					vbdate ($vbulletin->options['dateformat'], $log['dateline']) . ' ' . vbdate ($vbulletin->options['timeformat'], $log['dateline']),
					'<input type="checkbox" name="logid[' . $log['id'] . ']" />'
				)
			);
		}

		if ($vbulletin->GPC['limitstart'] == 0 AND $countids['logs'] > $limit)
		{
			construct_hidden_code ('limitstart', $vbulletin->GPC['limitstart'] + $limit + 1);
			$tfoot = '
				<input type="button" class="button" tabindex="2" value="' . $vbphrase['modsystem_admin_delete_sel'] . '" onclick="this.form.send.value=\'delete\';this.form.submit();" />&nbsp;&nbsp;
				<input type="submit" id="submit0" class="button" tabindex="1" value="' . $vbphrase['next_page'] . '" accesskey="s" />
			';
		}
		else if ($limitfinish < $countids['logs'])
		{
			construct_hidden_code ('limitstart', $vbulletin->GPC['limitstart'] + $limit + 1);
			$tfoot = '
				<input type="button" id="goback0" class="button" value="' . $vbphrase['prev_page'] . '" tabindex="1" onclick="history.back();" />&nbsp;&nbsp;
				<input type="button" class="button" tabindex="2" value="' . $vbphrase['modsystem_admin_delete_sel'] . '" onclick="this.form.send.value=\'delete\';this.form.submit();" />&nbsp;&nbsp;
				<input type="submit" id="submit0" class="button" tabindex="1" value="' . $vbphrase['next_page'] . '" accesskey="s" />
			';
		}
		else if ($vbulletin->GPC['limitstart'] > 0 AND $limitfinish >= $countids['logs'])
		{
			$tfoot = '
				<input type="button" id="goback0" class="button" value="' . $vbphrase['prev_page'] . '" tabindex="1" onclick="history.back();" />&nbsp;&nbsp;
				<input type="button" class="button" tabindex="2" value="' . $vbphrase['modsystem_admin_delete_sel'] . '" onclick="this.form.send.value=\'delete\';this.form.submit();" />&nbsp;&nbsp;
				<input type="submit" id="submit0" class="button" tabindex="1" value="' . $vbphrase['first_page'] . '" accesskey="s" />
			';
		}
		else
		{
			$tfoot = '<input type="button" class="button" tabindex="2" value="' . $vbphrase['modsystem_admin_delete_sel'] . '" onclick="this.form.send.value=\'delete\';this.form.submit();" />';
		}
		print_table_footer (5, $tfoot, '');
	}
	else
	{
		// empty
		print_table_footer();
	}
}
echo '<p align="center">' . $vbphrase['modsystem_nav_copyright'] . '</p>';
print_cp_footer ();
?>