<?php
/*======================================================================*\
|| #################################################################### ||
|| # Modification-System                                              # ||
|| # ---------------------------------------------------------------- # ||
|| # Copyright 2008 php-unlimited. All Rights Reserved.              # ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------------------------------------------------------- # ||
|| #                   http://www.php-unlimited.com                   # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting (E_ALL & ~E_NOTICE);
if (!is_object ($vbulletin->db))
{
	exit ();
}

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

$n = date ('n', $vbulletin->options['modsettings_motm_start']);
$y = date ('Y', TIMENOW);

$n = $n + 2;																											// current month + 2
if ($n > 12)																											// if current month > 12
{
	$y++;																														// add a year
	$n = $n - 12;																										// new month is $n - 12
}
$new_motm = strtotime ('1.' . $n . '.' . $y . ' 00:00:01');				// when we start a new MOTM ?

if (TIMENOW >= $new_motm)
{
	require_once (DIR . '/includes/adminfunctions.php');

	$n = $n - 1;
	if ($n == 0)
	{
		$n = 12;
		$y--;
	}
	$motm_date = strtotime ('1.' . $n . '.' . $y);

	// restore last month
	$vbulletin->db->query ("UPDATE " . TABLE_PREFIX . "setting SET value=" . $motm_date . " WHERE varname='modsettings_motm_start'");

	// set the MOTM-flag. the next user in the forums will activate MOTM for the current month
	$vbulletin->db->query ("UPDATE " . TABLE_PREFIX . "setting SET value='1' WHERE varname='modsettings_do_motm'");

	// rebuild $vbulletin->options
	build_options ();
}
?>