<?php
$unique_ids = $dynnav_left = $dynnav_right = array ();
$dynnav = explode ("\n", trim ($vbulletin->options['dynamic_navbar']));

foreach ($dynnav AS $dynamic_link)
{
	$dynamic_line = explode ('|', $dynamic_link);

	$id    = intval ($dynamic_line[0]);
	$dhtml = intval ($dynamic_line[1]);
	$sub   = intval ($dynamic_line[2]);
	$sort  = intval ($dynamic_line[3]);
	$url   = $dynamic_line[4];
	$name  = $dynamic_line[5];
	$side  = intval ($dynamic_line[6]);
	$phras = intval ($dynamic_line[7]);
	$break = intval ($dynamic_line[8]);

	$link = array (
		'id'    => $id,
		'dhtml' => $dhtml,
		'sub'   => $sub,
		'link'  => $url,
		'name'  => $name,
		'phras' => $phras,
		'break' => $break,
	);

	if (!$side)
	{
		if (!$dhtml)
		{
			if (!$sub) $dynnav_left["$id"]["$sort"] = $link;
			else $dynnav_left["$sub"]["$sort"] = $link;
		}
		else
		{
			if (!$sub) $dynnav_left["$id"]["$sort"] = $link;
			else $dynnav_left["$sub"]["$sort"] = $link;
		}
	}
	else
	{
		if (!$dhtml)
		{
			if (!$sub) $dynnav_right["$id"]["$sort"] = $link;
			else $dynnav_right["$sub"]["$sort"] = $link;
		}
		else
		{
			if (!$sub) $dynnav_right["$id"]["$sort"] = $link;
			else $dynnav_right["$sub"]["$sort"] = $link;
		}
	}
}

$dhtml_menu = '';
$dynamic_output = create_dynamic_navigation ($dynnav_right);
if ($dynamic_output['navigation'])
{
	$template_hook['navbar_end'] .= $dynamic_output['navigation'];
	if ($dynamic_output['dhtlm_menu'])
	{
		$dhtml_menu .= $dynamic_output['dhtlm_menu'];
	}
}

$dynamic_output = create_dynamic_navigation ($dynnav_left);
if ($dynamic_output['navigation'])
{
	$template_hook['navbar_start'] .= $dynamic_output['navigation'];
	if ($dynamic_output['dhtlm_menu'])
	{
		$dhtml_menu .= $dynamic_output['dhtlm_menu'];
	}
}

if ($dhtml_menu)
{
	$ad_location['ad_navbar_below'] .= $dhtml_menu;
}
unset ($dhtml_menu);

function get_unique_id ()
{
	global $unique_ids;

	$id = rand (1, 1000000);
	if (in_array ($id, $unique_ids))
	{
		$id = get_unique_id ();
	}
	else
	{
		$unique_ids[] = $id;
	}

	return $id;
}

function create_dynamic_navigation ($navigation)
{
	global $stylevar, $vbphrase, $unique_ids;

	$ismenue = 0;
	$dynamic_dhtml = $dynamic_navigation = '';
	if (!empty ($navigation))
	{
		foreach ($navigation AS $val)
		{
			$m_id = get_unique_id ();
			$menu = 'dynamicnav' . $m_id;
			foreach ($val AS $key => $link)
			{
				if (!$link['dhtml'])
				{
					if ($link['link'] AND $link['name'])
					{
						$name = $link['name'];
						if ($link['phras']) $name = $vbphrase[$link['name']];

						if ($link['sub'])
						{
							// sub menue -> real link in DHTML
							$dynamic_navigation .= '<li><a href="' . $link['link'] . '">' . $name .'</a></li>' . "\n";
						}
						else
						{
							// sub menue -> real link
							$dynamic_navigation .= '<li><a href="' . $link['link'] . '">' . $name .'</a></li>' . "\n";
						}
					}
					else
					{
						if ($link['sub'] AND $link['link'] == '' AND $link['name'] != '')
						{
							// sub menue "thead"
							$name = $link['name'];
							if ($link['phras']) $name = $vbphrase[$link['name']];
							$dynamic_navigation .= '<li>' . $name .'</li>' . "\n";
						}
					}
				}
				else
				{
					if ($link['link'] == '' AND $link['name'] != '')
					{
						if ($ismenue)
						{
							$ismenue = 0;
							$dynamic_navigation .= '</ul></li>' . "\n";
						}
						$ismenue = 1;

						$name = $link['name'];
						if ($link['phras']) $name = $vbphrase[$link['name']];

						$dynamic_navigation .= '<li class="popupmenu">' . "\n";
						$dynamic_navigation .= '<a href="javascript://" class="popupctrl">' . $name . '</a>' . "\n";
						$dynamic_navigation .= '<ul class="popupbody popuphover">' . "\n";
					}
				}
			}
		}
		if ($ismenue)
		{
				$dynamic_navigation .= '</ul></li>' . "\n";
		}
	}

	return array (
		'dhtlm_menu' => $dynamic_dhtml,
		'navigation' => $dynamic_navigation
	);
}
?>